
Changelog
*********


Python 3.4.6
============

Release date: 2017-01-16

There were no changes between 3.4.6rc1 and 3.4.6 final.


Python 3.4.6rc1
===============

Release date: 2017-01-02


Core and Builtins
-----------------

* Issue #28648: Fixed crash in Py_DecodeLocale() in debug build on
  Mac OS X when decode astral characters.  Patch by Xiang Zhang.

* Issue #28426: Fixed potential crash in PyUnicode_AsDecodedObject()
  in debug build.


Library
-------

* Issue #28563: Fixed possible DoS and arbitrary code execution when
  handle plural form selections in the gettext module.  The expression
  parser now supports exact syntax supported by GNU gettext.

* In the curses module, raise an error if window.getstr() or
  window.instr() is passed a negative value.

* Issue #27783: Fix possible usage of uninitialized memory in
  operator.methodcaller.

* Issue #27774: Fix possible Py_DECREF on unowned object in _sre.

* Issue #27760: Fix possible integer overflow in binascii.b2a_qp.

* Issue #27758: Fix possible integer overflow in the _csv module for
  large record lengths.

* Issue #27568: Prevent HTTPoxy attack (CVE-2016-1000110). Ignore
  the HTTP_PROXY variable when REQUEST_METHOD environment is set,
  which indicates that the script is in CGI mode.

* Issue #27759: Fix selectors incorrectly retain invalid file
  descriptors. Patch by Mark Williams.


Build
-----

* Issue #28248: Update Windows build to use OpenSSL 1.0.2j.


Tests
-----

* Issue #27369: In test_pyexpat, avoid testing an error message
  detail that changed in Expat 2.2.0.


Python 3.4.5
============

Release date: 2016-06-26


Tests
-----

* Issue #26867: Ubuntu's openssl OP_NO_SSLv3 is forced on by
  default; fix test.


Python 3.4.5rc1
===============

Release date: 2016-06-11


Core and Builtins
-----------------

* Issue #26478: Fix semantic bugs when using binary operators with
  dictionary views and tuples.

* Issue #26171: Fix possible integer overflow and heap corruption in
  zipimporter.get_data().


Library
-------

* Issue #26556: Update expat to 2.1.1, fixes CVE-2015-1283.

* Fix TLS stripping vulnerability in smptlib, CVE-2016-0772.
  Reported by Team Oststrom

* Issue #25939: On Windows open the cert store readonly in
  ssl.enum_certificates.

* Issue #26012: Don't traverse into symlinks for ** pattern in
  pathlib.Path.[r]glob().

* Issue #24120: Ignore PermissionError when traversing a tree with
  pathlib.Path.[r]glob().  Patch by Ulrich Petri.

* Skip getaddrinfo if host is already resolved. Patch by A. Jesse
  Jiryu Davis.

* Add asyncio.timeout() context manager.

* Issue #26050: Add asyncio.StreamReader.readuntil() method. Patch
  by Марк Коренберг.


Tests
-----

* Issue #25940: Changed test_ssl to use self-signed.pythontest.net.
  This avoids relying on svn.python.org, which recently changed root
  certificate.


Python 3.4.4
============

Release date: 2015/12/20


Windows
-------

* Issue #25844: Corrected =/== typo potentially leading to crash in
  launcher.


Python 3.4.4rc1
===============

Release date: 2015/12/06


Core and Builtins
-----------------

* Issue #25709: Fixed problem with in-place string concatenation and
  utf-8 cache.

* Issue #24097: Fixed crash in object.__reduce__() if slot name is
  freed inside __getattr__.

* Issue #24731: Fixed crash on converting objects with special
  methods __bytes__, __trunc__, and __float__ returning instances of
  subclasses of bytes, int, and float to subclasses of bytes, int, and
  float correspondingly.

* Issue #25388: Fixed tokenizer crash when processing undecodable
  source code with a null byte.

* Issue #22995: Default implementation of __reduce__ and
  __reduce_ex__ now rejects builtin types with not defined __new__.

* Issue #24802: Avoid buffer overreads when int(), float(),
  compile(), exec() and eval() are passed bytes-like objects.  These
  objects are not necessarily terminated by a null byte, but the
  functions assumed they were.

* Issue #24402: Fix input() to prompt to the redirected stdout when
  sys.stdout.fileno() fails.

* Issue #24806: Prevent builtin types that are not allowed to be
  subclassed from being subclassed through multiple inheritance.

* Issue #24848: Fixed a number of bugs in UTF-7 decoding of
  misformed data.

* Issue #25280: Import trace messages emitted in verbose (-v) mode
  are no longer formatted twice.

* Issue #25003: os.urandom() doesn't use getentropy() on Solaris
  because getentropy() is blocking, whereas os.urandom() should not
  block. getentropy() is supported since Solaris 11.3.

* Issue #25182: The stdprinter (used as sys.stderr before the io
  module is imported at startup) now uses the backslashreplace error
  handler.

* Issue #24891: Fix a race condition at Python startup if the file
  descriptor of stdin (0), stdout (1) or stderr (2) is closed while
  Python is creating sys.stdin, sys.stdout and sys.stderr objects.
  These attributes are now set to None if the creation of the object
  failed, instead of raising an OSError exception. Initial patch
  written by Marco Paolini.

* Issue #21167: NAN operations are now handled correctly when python
  is compiled with ICC even if -fp-model strict is not specified.

* Issue #4395: Better testing and documentation of binary operators.
  Patch by Martin Panter.

* Issue #24467: Fixed possible buffer over-read in bytearray. The
  bytearray object now always allocates place for trailing null byte
  and it's buffer now is always null-terminated.

* Issue #24115: Update uses of PyObject_IsTrue(), PyObject_Not(),
  PyObject_IsInstance(), PyObject_RichCompareBool() and
  _PyDict_Contains() to check for and handle errors correctly.

* Issue #24257: Fixed system error in the comparison of faked
  types.SimpleNamespace.

* Issue #22939: Fixed integer overflow in iterator object.  Patch by
  Clement Rouault.

* Issue #23985: Fix a possible buffer overrun when deleting a slice
  from the front of a bytearray and then appending some other bytes
  data.

* Issue #24102: Fixed exception type checking in standard error
  handlers.

* Issue #23757: PySequence_Tuple() incorrectly called the concrete
  list API when the data was a list subclass.

* Issue #24407: Fix crash when dict is mutated while being updated.

* Issue #24096: Make warnings.warn_explicit more robust against
  mutation of the warnings.filters list.

* Issue #23996: Avoid a crash when a delegated generator raises an
  unnormalized StopIteration exception.  Patch by Stefan Behnel.

* Issue #24022: Fix tokenizer crash when processing undecodable
  source code.

* Issue #23309: Avoid a deadlock at shutdown if a daemon thread is
  aborted while it is holding a lock to a buffered I/O object, and the
  main thread tries to use the same I/O object (typically stdout or
  stderr).  A fatal error is emitted instead.

* Issue #22977: Fixed formatting Windows error messages on Wine.
  Patch by Martin Panter.

* Issue #23803: Fixed str.partition() and str.rpartition() when a
  separator is wider then partitioned string.

* Issue #23192: Fixed generator lambdas.  Patch by Bruno Cauet.

* Issue #23629: Fix the default __sizeof__ implementation for
  variable-sized objects.

* Issue #24044: Fix possible null pointer dereference in list.sort
  in out of memory conditions.

* Issue #21354: PyCFunction_New function is exposed by python DLL
  again.


Library
-------

* Issue #24903: Fix regression in number of arguments compileall
  accepts when '-d' is specified.  The check on the number of
  arguments has been dropped completely as it never worked correctly
  anyway.

* Issue #25764: In the subprocess module, preserve any exception
  caused by fork() failure when preexec_fn is used.

* Issue #6478: _strptime's regexp cache now is reset after changing
  timezone with time.tzset().

* Issue #25177: Fixed problem with the mean of very small and very
  large numbers. As a side effect, statistics.mean and
  statistics.variance should be significantly faster.

* Issue #25718: Fixed copying object with state with boolean value
  is false.

* Issue #10131: Fixed deep copying of minidom documents.  Based on
  patch by Marian Ganisin.

* Issue #25725: Fixed a reference leak in pickle.loads() when
  unpickling invalid data including tuple instructions.

* Issue #25663: In the Readline completer, avoid listing duplicate
  global names, and search the global namespace before searching
  builtins.

* Issue #25688: Fixed file leak in ElementTree.iterparse() raising
  an error.

* Issue #23914: Fixed SystemError raised by unpickler on broken
  pickle data.

* Issue #25691: Fixed crash on deleting ElementTree.Element
  attributes.

* Issue #25624: ZipFile now always writes a ZIP_STORED header for
  directory entries.  Patch by Dingyuan Wang.

* Issue #25583: Avoid incorrect errors raised by
  os.makedirs(exist_ok=True) when the OS gives priority to errors such
  as EACCES over EEXIST.

* Issue #25593: Change semantics of EventLoop.stop() in asyncio.

* Issue #6973: When we know a subprocess.Popen process has died, do
  not allow the send_signal(), terminate(), or kill() methods to do
  anything as they could potentially signal a different process.

* Issue #25578: Fix (another) memory leak in SSLSocket.getpeercer().

* Issue #25590: In the Readline completer, only call getattr() once
  per attribute.

* Issue #25498: Fix a crash when garbage-collecting ctypes objects
  created by wrapping a memoryview.  This was a regression made in
  3.4.3.  Based on patch by Eryksun.

* Issue #18010: Fix the pydoc web server's module search function to
  handle exceptions from importing packages.

* Issue #25510: fileinput.FileInput.readline() now returns b''
  instead of '' at the end if the FileInput was opened with binary
  mode. Patch by Ryosuke Ito.

* Issue #25530: Disable the vulnerable SSLv3 protocol by default
  when creating ssl.SSLContext.

* Issue #25569: Fix memory leak in SSLSocket.getpeercert().

* Issue #21827: Fixed textwrap.dedent() for the case when largest
  common whitespace is a substring of smallest leading whitespace.
  Based on patch by Robert Li.

* Issue #25471: Sockets returned from accept() shouldn't appear to
  be nonblocking.

* Issue #25441: asyncio: Raise error from drain() when socket is
  closed.

* Issue #25411: Improved Unicode support in SMTPHandler through
  better use of the email package. Thanks to user simon04 for the
  patch.

* Issue #25380: Fixed protocol for the STACK_GLOBAL opcode in
  pickletools.opcodes.

* Issue #23972: Updates asyncio datagram create method allowing
  reuseport and reuseaddr socket options to be set prior to binding
  the socket. Mirroring the existing asyncio create_server method the
  reuseaddr option for datagram sockets defaults to True if the O/S is
  'posix' (except if the platform is Cygwin). Patch by Chris Laws.

* Issue #25304: Add asyncio.run_coroutine_threadsafe().  This lets
  you submit a coroutine to a loop from another thread, returning a
  concurrent.futures.Future.  By Vincent Michel.

* Issue #25319: When threading.Event is reinitialized, the
  underlying condition should use a regular lock rather than a
  recursive lock.

* Issue #25232: Fix CGIRequestHandler to split the query from the
  URL at the first question mark (?) rather than the last. Patch from
  Xiang Zhang.

* Issue #24657: Prevent CGIRequestHandler from collapsing slashes in
  the query part of the URL as if it were a path. Patch from Xiang
  Zhang.

* Issue #22958: Constructor and update method of
  weakref.WeakValueDictionary now accept the self and the dict keyword
  arguments.

* Issue #22609: Constructor of collections.UserDict now accepts the
  self keyword argument.

* Issue #25262. Added support for BINBYTES8 opcode in Python
  implementation of unpickler.  Highest 32 bits of 64-bit size for
  BINUNICODE8 and BINBYTES8 opcodes no longer silently ignored on
  32-bit platforms in C implementation.

* Issue #25034: Fix string.Formatter problem with auto-numbering and
  nested format_specs. Patch by Anthon van der Neut.

* Issue #25233: Rewrite the guts of asyncio.Queue and
  asyncio.Semaphore to be more understandable and correct.

* Issue #23600: Default implementation of tzinfo.fromutc() was
  returning wrong results in some cases.

* Issue #25203: Failed readline.set_completer_delims() no longer
  left the module in inconsistent state.

* Prevent overflow in _Unpickler_Read.

* Issue #25047: The XML encoding declaration written by Element Tree
  now respects the letter case given by the user. This restores the
  ability to write encoding names in uppercase like "UTF-8", which
  worked in Python 2.

* Issue #19143: platform module now reads Windows version from
  kernel32.dll to avoid compatibility shims.

* Issue #23517: Fix rounding in fromtimestamp() and
  utcfromtimestamp() methods of datetime.datetime: microseconds are
  now rounded to nearest with ties going to nearest even integer
  (ROUND_HALF_EVEN), instead of being rounding towards zero
  (ROUND_DOWN). It's important that these methods use the same
  rounding mode than datetime.timedelta to keep the property:
  (datetime(1970,1,1) + timedelta(seconds=t)) ==
  datetime.utcfromtimestamp(t). It also the rounding mode used by
  round(float) for example.

* Issue #24684: socket.socket.getaddrinfo() now calls
  PyUnicode_AsEncodedString() instead of calling the encode() method
  of the host, to handle correctly custom string with an encode()
  method which doesn't return a byte string. The encoder of the IDNA
  codec is now called directly instead of calling the encode() method
  of the string.

* Issue #24982: shutil.make_archive() with the "zip" format now adds
  entries for directories (including empty directories) in ZIP file.

* Issue #24857: Comparing call_args to a long sequence now correctly
  returns a boolean result instead of raising an exception.  Patch by
  A Kaptur.

* Issue #25019: Fixed a crash caused by setting non-string key of
  expat parser. Based on patch by John Leitch.

* Issue #24917: time_strftime() buffer over-read.

* Issue #23144: Make sure that HTMLParser.feed() returns all the
  data, even when convert_charrefs is True.

* Issue #16180: Exit pdb if file has syntax error, instead of
  trapping user in an infinite loop.  Patch by Xavier de Gaye.

* Issue #21112: Fix regression in unittest.expectedFailure on
  subclasses. Patch from Berker Peksag.

* Issue #24931: Instances of subclasses of namedtuples have their
  own __dict__ which breaks the inherited __dict__ property and breaks
  the _asdict() method. Removed the __dict__ property to prevent the
  conflict and fixed _asdict().

* Issue #24764: cgi.FieldStorage.read_multi() now ignores the
  Content- Length header in part headers. Patch written by Peter
  Landry and reviewed by Pierre Quentel.

* Issue #24774: Fix docstring in http.server.test. Patch from Chiu-
  Hsiang Hsu.

* Issue #21159: Improve message in
  configparser.InterpolationMissingOptionError. Patch from Łukasz
  Langa.

* Issue #23888: Handle fractional time in cookie expiry. Patch by
  ssh.

* Issue #23004: mock_open() now reads binary data correctly when the
  type of read_data is bytes.  Initial patch by Aaron Hill.

* Issue #23652: Make it possible to compile the select module
  against the libc headers from the Linux Standard Base, which do not
  include some EPOLL macros.  Patch by Matt Frank.

* Issue #22932: Fix timezones in email.utils.formatdate. Patch from
  Dmitry Shachnev.

* Issue #23779: imaplib raises TypeError if authenticator tries to
  abort. Patch from Craig Holmquist.

* Issue #23319: Fix ctypes.BigEndianStructure, swap correctly bytes.
  Patch written by Matthieu Gautier.

* Issue #23254: Document how to close the TCPServer listening
  socket. Patch from Martin Panter.

* Issue #19450: Update Windows and OS X installer builds to use
  SQLite 3.8.11.

* Issue #23441: rcompleter now prints a tab character instead of
  displaying possible completions for an empty word.  Initial patch by
  Martin Sekera.

* Issue #24735: Fix invalid memory access in
  itertools.combinations_with_replacement().

* Issue #17527: Add PATCH to wsgiref.validator. Patch from Luca
  Sbardella.

* Issue #24683: Fixed crashes in _json functions called with
  arguments of inappropriate type.

* Issue #21697: shutil.copytree() now correctly handles symbolic
  links that point to directories.  Patch by Eduardo Seabra and Thomas
  Kluyver.

* Issue #24620: Random.setstate() now validates the value of state
  last element.

* Issue #22153: Improve unittest docs. Patch from Martin Panter and
  evilzero.

* Issue #24206: Fixed __eq__ and __ne__ methods of inspect classes.

* Issue #21750: mock_open.read_data can now be read from each
  instance, as it could in Python 3.3.

* Issue #23247: Fix a crash in the StreamWriter.reset() of CJK
  codecs.

* Issue #18622: unittest.mock.mock_open().reset_mock would recurse
  infinitely. Patch from Nicola Palumbo and Laurent De Buyst.

* Issue #24608: chunk.Chunk.read() now always returns bytes, not
  str.

* Issue #18684: Fixed reading out of the buffer in the re module.

* Issue #24259: tarfile now raises a ReadError if an archive is
  truncated inside a data segment.

* Issue #24552: Fix use after free in an error case of the _pickle
  module.

* Issue #24514: tarfile now tolerates number fields consisting of
  only whitespace.

* Issue #19176: Fixed doctype() related bugs in C implementation of
  ElementTree. A deprecation warning no longer issued by XMLParser
  subclass with default doctype() method.  Direct call of doctype()
  now issues a warning.  Parser's doctype() now is not called if
  target's doctype() is called.  Based on patch by Martin Panter.

* Issue #20387: Restore semantic round-trip correctness in
  tokenize/untokenize for tab-indented blocks.

* Issue #24456: Fixed possible buffer over-read in adpcm2lin() and
  lin2adpcm() functions of the audioop module.

* Issue #24336: The contextmanager decorator now works with
  functions with keyword arguments called "func" and "self".  Patch by
  Martin Panter.

* Issue #24489: ensure a previously set C errno doesn't disturb
  cmath.polar().

* Issue #5633: Fixed timeit when the statement is a string and the
  setup is not.

* Issue #24326: Fixed audioop.ratecv() with non-default weightB
  argument. Original patch by David Moore.

* Issue #23840: tokenize.open() now closes the temporary binary file
  on error to fix a resource warning.

* Issue #24257: Fixed segmentation fault in sqlite3.Row constructor
  with faked cursor type.

* Issue #22107: tempfile.gettempdir() and tempfile.mkdtemp() now try
  again when a directory with the chosen name already exists on
  Windows as well as on Unix.  tempfile.mkstemp() now fails early if
  parent directory is not valid (not exists or is a file) on Windows.

* Issue #6598: Increased time precision and random number range in
  email.utils.make_msgid() to strengthen the uniqueness of the message
  ID.

* Issue #24091: Fixed various crashes in corner cases in C
  implementation of ElementTree.

* Issue #21931: msilib.FCICreate() now raises TypeError in the case
  of a bad argument instead of a ValueError with a bogus FCI error
  number. Patch by Jeffrey Armstrong.

* Issue #23796: peek and read1 methods of BufferedReader now raise
  ValueError if they called on a closed object. Patch by John
  Hergenroeder.

* Issue #24521: Fix possible integer overflows in the pickle module.

* Issue #22931: Allow '[' and ']' in cookie values.

* Issue #20274: Remove ignored and erroneous "kwargs" parameters
  from three METH_VARARGS methods on _sqlite.Connection.

* Issue #24094: Fix possible crash in json.encode with poorly
  behaved dict subclasses.

* Asyncio issue 222 / PR 231 (Victor Stinner) -- fix @coroutine
  functions without __name__.

* Issue #9246: On POSIX, os.getcwd() now supports paths longer than
  1025 bytes. Patch written by William Orr.

* The keywords attribute of functools.partial is now always a
  dictionary.

* Issues #24099, #24100, and #24101: Fix free-after-use bug in
  heapq's siftup and siftdown functions.

* Backport collections.deque fixes from Python 3.5.  Prevents
  reentrant badness during deletion by deferring the decref until the
  container has been restored to a consistent state.

* Issue #23008: Fixed resolving attributes with boolean value is
  False in pydoc.

* Fix asyncio issue 235: LifoQueue and PriorityQueue's put didn't
  increment unfinished tasks (this bug was introduced in 3.4.3 when
  JoinableQueue was merged with Queue).

* Issue #23908: os functions now reject paths with embedded null
  character on Windows instead of silently truncate them.

* Issue #23728: binascii.crc_hqx() could return an integer outside
  of the range 0-0xffff for empty data.

* Issue #23811: Add missing newline to the PyCompileError error
  message. Patch by Alex Shkop.

* Issue #17898: Fix exception in gettext.py when parsing certain
  plural forms.

* Issue #22982: Improve BOM handling when seeking to multiple
  positions of a writable text file.

* Issue #23865: close() methods in multiple modules now are
  idempotent and more robust at shutdown. If they need to release
  multiple resources, all are released even if errors occur.

* Issue #23881: urllib.request.ftpwrapper constructor now closes the
  socket if the FTP connection failed to fix a ResourceWarning.

* Issue #23400: Raise same exception on both Python 2 and 3 if
  sem_open is not available.  Patch by Davin Potts.

* Issue #15133: _tkinter.tkapp.getboolean() now supports Tcl_Obj and
  always returns bool.  tkinter.BooleanVar now validates input values
  (accepted bool, int, str, and Tcl_Obj).  tkinter.BooleanVar.get()
  now always returns bool.

* Issue #23338: Fixed formatting ctypes error messages on Cygwin.
  Patch by Makoto Kato.

* Issue #16840: Tkinter now supports 64-bit integers added in Tcl
  8.4 and arbitrary precision integers added in Tcl 8.5.

* Issue #23834: Fix socket.sendto(), use the C Py_ssize_t type to
  store the result of sendto() instead of the C int type.

* Issue #21526: Tkinter now supports new boolean type in Tcl 8.5.

* Issue #23838: linecache now clears the cache and returns an empty
  result on MemoryError.

* Issue #18473: Fixed 2to3 and 3to2 compatible pickle mappings.
  Fixed ambigious reverse mappings.  Added many new mappings.  Import
  mapping is no longer applied to modules already mapped with full
  name mapping.

* Issue #23745: The new email header parser now handles duplicate
  MIME parameter names without error, similar to how get_param
  behaves.

* Issue #23792: Ignore KeyboardInterrupt when the pydoc pager is
  active. This mimics the behavior of the standard unix pagers, and
  prevents pipepager from shutting down while the pager itself is
  still running.

* Issue #23742: ntpath.expandvars() no longer loses unbalanced
  single quotes.

* Issue #21802: The reader in BufferedRWPair now is closed even when
  closing writer failed in BufferedRWPair.close().

* Issue #23671: string.Template now allows to specify the "self"
  parameter as keyword argument.  string.Formatter now allows to
  specify the "self" and the "format_string" parameters as keyword
  arguments.

* Issue #21560: An attempt to write a data of wrong type no longer
  cause GzipFile corruption.  Original patch by Wolfgang Maier.

* Issue #23647: Increase impalib's MAXLINE to accommodate modern
  mailbox sizes.

* Issue #23539: If body is None, http.client.HTTPConnection.request
  now sets Content-Length to 0 for PUT, POST, and PATCH headers to
  avoid 411 errors from some web servers.

* Issue #22351: The nntplib.NNTP constructor no longer leaves the
  connection and socket open until the garbage collector cleans them
  up.  Patch by Martin Panter.

* Issue #23136: _strptime now uniformly handles all days in week 0,
  including Dec 30 of previous year.  Based on patch by Jim Carroll.

* Issue #23700: Iterator of NamedTemporaryFile now keeps a reference
  to NamedTemporaryFile instance.  Patch by Bohuslav Kabrda.

* Issue #22903: The fake test case created by unittest.loader when
  it fails importing a test module is now picklable.

* Issue #23568: Add rdivmod support to MagicMock() objects. Patch by
  Håkan Lövdahl.

* Issue #23138: Fixed parsing cookies with absent keys or values in
  cookiejar. Patch by Demian Brecht.

* Issue #23051: multiprocessing.Pool methods imap() and
  imap_unordered() now handle exceptions raised by an iterator.  Patch
  by Alon Diamant and Davin Potts.

* Issue #22928: Disabled HTTP header injections in http.client.
  Original patch by Demian Brecht.

* Issue #23615: Modules bz2, tarfile and tokenize now can be
  reloaded with imp.reload().  Patch by Thomas Kluyver.

* Issue #23476: In the ssl module, enable OpenSSL's
  X509_V_FLAG_TRUSTED_FIRST flag on certificate stores when it is
  available.

* Issue #23576: Avoid stalling in SSL reads when EOF has been
  reached in the SSL layer but the underlying connection hasn't been
  closed.

* Issue #23504: Added an __all__ to the types module.

* Issue #20204: Added the __module__ attribute to _tkinter classes.

* Issue #23521: Corrected pure python implementation of timedelta
  division.

   * Eliminated OverflowError from timedelta * float for some
     floats;

   * Corrected rounding in timedlta true division.

* Issue #21619: Popen objects no longer leave a zombie after exit in
  the with statement if the pipe was broken.  Patch by Martin Panter.

* Issue #6639: Module-level turtle functions no longer raise
  TclError after closing the window.

* Issues #814253, #9179: Warnings now are raised when group
  references and conditional group references are used in lookbehind
  assertions in regular expressions.

* Issue #23215: Multibyte codecs with custom error handlers that
  ignores errors consumed too much memory and raised SystemError or
  MemoryError. Original patch by Aleksi Torhamo.

* Issue #5700: io.FileIO() called flush() after closing the file.
  flush() was not called in close() if closefd=False.

* Issue #23374: Fixed pydoc failure with non-ASCII files when stdout
  encoding differs from file system encoding (e.g. on Mac OS).

* Issue #23481: Remove RC4 from the SSL module's default cipher
  list.

* Issue #21548: Fix pydoc.synopsis() and pydoc.apropos() on modules
  with empty docstrings.

* Issue #22885: Fixed arbitrary code execution vulnerability in the
  dbm.dumb module.  Original patch by Claudiu Popa.

* Issue #23146: Fix mishandling of absolute Windows paths with
  forward slashes in pathlib.

* Issue #23421: Fixed compression in tarfile CLI.  Patch by
  wdv4758h.

* Issue #23367: Fix possible overflows in the unicodedata module.

* Issue #23361: Fix possible overflow in Windows subprocess creation
  code.

* Issue #23801: Fix issue where cgi.FieldStorage did not always
  ignore the entire preamble to a multipart body.

* Issue #23310: Fix MagicMock's initializer to work with
  __methods__, just like configure_mock().  Patch by Kasia Jachim.

* asyncio: New event loop APIs: set_task_factory() and
  get_task_factory().

* asyncio: async() function is deprecated in favour of
  ensure_future().

* Issue #23898: Fix inspect.classify_class_attrs() to support
  attributes with overloaded __eq__ and __bool__.  Patch by Mike
  Bayer.

* Issue #24298: Fix inspect.signature() to correctly unwrap wrappers
  around bound methods.

* Issue #23572: Fixed functools.singledispatch on classes with falsy
  metaclasses.  Patch by Ethan Furman.


IDLE
----

* Issue 15348: Stop the debugger engine (normally in a user process)
  before closing the debugger window (running in the IDLE process).
  This prevents the RuntimeErrors that were being caught and ignored.

* Issue #24455: Prevent IDLE from hanging when a) closing the shell
  while the debugger is active (15347); b) closing the debugger with
  the [X] button (15348); and c) activating the debugger when already
  active (24455). The patch by Mark Roseman does this by making two
  changes. 1. Suspend and resume the gui.interaction method with the
  tcl vwait mechanism intended for this purpose (instead of
  root.mainloop & .quit). 2. In gui.run, allow any existing
  interaction to terminate first.

* Change 'The program' to 'Your program' in an IDLE 'kill program?'
  message to make it clearer that the program referred to is the
  currently running user program, not IDLE itself.

* Issue #24750: Improve the appearance of the IDLE editor window
  status bar. Patch by Mark Roseman.

* Issue #25313: Change the handling of new built-in text color
  themes to better address the compatibility problem introduced by the
  addition of IDLE Dark. Consistently use the revised
  idleConf.CurrentTheme everywhere in idlelib.

* Issue #24782: Extension configuration is now a tab in the IDLE
  Preferences dialog rather than a separate dialog.   The former tabs
  are now a sorted list.  Patch by Mark Roseman.

* Issue #22726: Re-activate the config dialog help button with some
  content about the other buttons and the new IDLE Dark theme.

* Issue #24820: IDLE now has an 'IDLE Dark' built-in text color
  theme. It is more or less IDLE Classic inverted, with a cobalt blue
  background. Strings, comments, keywords, ... are still green, red,
  orange, ... . To use it with IDLEs released before November 2015,
  hit the 'Save as New Custom Theme' button and enter a new name, such
  as 'Custom Dark'.  The custom theme will work with any IDLE release,
  and can be modified.

* Issue #25224: README.txt is now an idlelib index for IDLE
  developers and curious users.  The previous user content is now in
  the IDLE doc chapter. 'IDLE' now means 'Integrated Development and
  Learning Environment'.

* Issue #24820: Users can now set breakpoint colors in Settings ->
  Custom Highlighting.  Original patch by Mark Roseman.

* Issue #24972: Inactive selection background now matches active
  selection background, as configured by users, on all systems.  Found
  items are now always highlighted on Windows.  Initial patch by Mark
  Roseman.

* Issue #24570: Idle: make calltip and completion boxes appear on
  Macs affected by a tk regression.  Initial patch by Mark Roseman.

* Issue #24988: Idle ScrolledList context menus (used in debugger)
  now work on Mac Aqua.  Patch by Mark Roseman.

* Issue #24801: Make right-click for context menu work on Mac Aqua.
  Patch by Mark Roseman.

* Issue #25173: Associate tkinter messageboxes with a specific
  widget. For Mac OSX, make them a 'sheet'.  Patch by Mark Roseman.

* Issue #25198: Enhance the initial html viewer now used for Idle
  Help. * Properly indent fixed-pitch text (patch by Mark Roseman). *
  Give code snippet a very Sphinx-like light blueish-gray background.
  * Re-use initial width and height set by users for shell and editor.
  * When the Table of Contents (TOC) menu is used, put the section
  header at the top of the screen.

* Issue #25225: Condense and rewrite Idle doc section on text
  colors.

* Issue #21995: Explain some differences between IDLE and console
  Python.

* Issue #22820: Explain need for *print* when running file from Idle
  editor.

* Issue #25224: Doc: augment Idle feature list and no-subprocess
  section.

* Issue #25219: Update doc for Idle command line options. Some were
  missing and notes were not correct.

* Issue #24861: Most of idlelib is private and subject to change.
  Use idleib.idle.* to start Idle. See idlelib.__init__.__doc__.

* Issue #25199: Idle: add synchronization comments for future
  maintainers.

* Issue #16893: Replace help.txt with help.html for Idle doc
  display. The new idlelib/help.html is rstripped
  Doc/build/html/library/idle.html. It looks better than help.txt and
  will better document Idle as released. The tkinter html viewer that
  works for this file was written by Mark Roseman. The now unused
  EditorWindow.HelpDialog class and helt.txt file are deprecated.

* Issue #24199: Deprecate unused idlelib.idlever with possible
  removal in 3.6.

* Issue #24790: Remove extraneous code (which also create 2 & 3
  conflicts).

* Issue #23672: Allow Idle to edit and run files with astral chars
  in name. Patch by Mohd Sanad Zaki Rizvi.

* Issue 24745: Idle editor default font. Switch from Courier to
  platform-sensitive TkFixedFont.  This should not affect current
  customized font selections.  If there is a problem, edit
  $HOME/.idlerc/config-main.cfg and remove 'fontxxx' entries from
  [Editor Window].  Patch by Mark Roseman.

* Issue #21192: Idle editor. When a file is run, put its name in the
  restart bar. Do not print false prompts. Original patch by Adnan
  Umer.

* Issue #13884: Idle menus. Remove tearoff lines. Patch by Roger
  Serwy.

* Issue #23184: remove unused names and imports in idlelib. Initial
  patch by Al Sweigart.


Tests
-----

* Issue #25616: Tests for OrderedDict are extracted from
  test_collections into separate file test_ordered_dict.

* Issue #25099: Make test_compileall not fail when an entry on
  sys.path cannot be written to (commonly seen in administrative
  installs on Windows).

* Issue #24751: When running regrtest with the "-w" command line
  option, a test run is no longer marked as a failure if all tests
  succeed when re-run.

* Issue #21520: test_zipfile no longer fails if the word 'bad'
  appears anywhere in the name of the current directory.

* Issue #23799: Added test.support.start_threads() for running and
  cleaning up multiple threads.

* Issue #22390: test.regrtest now emits a warning if temporary files
  or directories are left after running a test.

* Issue #23583: Added tests for standard IO streams in IDLE.


Build
-----

* Issue #23445: pydebug builds now use "gcc -Og" where possible, to
  make the resulting executable faster.

* Issue #24603: Update Windows builds to use OpenSSL1.0.2d and OS X
  10.5 installer to use OpenSSL 1.0.2e.


C API
-----

* Issue #23998: PyImport_ReInitLock() now checks for lock allocation
  error


Documentation
-------------

* Issue #12067: Rewrite Comparisons section in the Expressions
  chapter of the language reference. Some of the details of comparing
  mixed types were incorrect or ambiguous. NotImplemented is only
  relevant at a lower level than the Expressions chapter. Added
  details of comparing range() objects, and default behaviour and
  consistency suggestions for user-defined classes. Patch from Andy
  Maier.

* Issue #24952: Clarify the default size argument of stack_size() in
  the "threading" and "_thread" modules. Patch from Mattip.

* Issue #24808: Update the types of some PyTypeObject fields. Patch
  by Joseph Weston.

* Issue #22812: Fix unittest discovery examples. Patch from Pam
  McA'Nulty.

* Issue #24129: Clarify the reference documentation for name
  resolution. This includes removing the assumption that readers will
  be familiar with the name resolution scheme Python used prior to the
  introduction of lexical scoping for function namespaces. Patch by
  Ivan Levkivskyi.

* Issue #20769: Improve reload() docs. Patch by Dorian Pula.

* Issue #23589: Remove duplicate sentence from the FAQ.  Patch by
  Yongzhi Pan.

* Issue #24729: Correct IO tutorial to match implementation
  regarding encoding parameter to open function.

* Issue #24351: Clarify what is meant by "identifier" in the context
  of string.Template instances.

* Issue #22155: Add File Handlers subsection with createfilehandler
  to tkinter doc.  Remove obsolete example from FAQ.  Patch by Martin
  Panter.

* Issue #24029: Document the name binding behavior for submodule
  imports.

* Issue #24077: Fix typo in man page for -I command option: -s, not
  -S.


Tools/Demos
-----------

* Issue #25440: Fix output of python-config --extension-suffix.

* Issue #23330: h2py now supports arbitrary filenames in #include.

* Issue #24031: make patchcheck now supports git checkouts, too.


Windows
-------

* Issue #24306: Sets component ID for launcher to match 3.5 and
  later to avoid downgrading.

* Issue #25022: Removed very outdated PC/example_nt/ directory.


Python 3.4.3
============

Release date: 2015-02-23


Core and Builtins
-----------------

* Issue #22735: Fix many edge cases (including crashes) involving
  custom mro() implementations.

* Issue #22896: Avoid using PyObject_AsCharBuffer(),
  PyObject_AsReadBuffer() and PyObject_AsWriteBuffer().

* Issue #21295: Revert some changes (issue #16795) to AST line
  numbers and column offsets that constituted a regression.

* Issue #21408: The default __ne__() now returns NotImplemented if
  __eq__() returned NotImplemented.  Original patch by Martin Panter.

* Issue #23321: Fixed a crash in str.decode() when error handler
  returned replacment string longer than mailformed input data.

* Issue #23048: Fix jumping out of an infinite while loop in the
  pdb.

* Issue #20335: bytes constructor now raises TypeError when encoding
  or errors is specified with non-string argument.  Based on patch by
  Renaud Blanch.

* Issue #22335: Fix crash when trying to enlarge a bytearray to
  0x7fffffff bytes on a 32-bit platform.

* Issue #22653: Fix an assertion failure in debug mode when doing a
  reentrant dict insertion in debug mode.

* Issue #22643: Fix integer overflow in Unicode case operations
  (upper, lower, title, swapcase, casefold).

* Issue #22604: Fix assertion error in debug mode when dividing a
  complex number by (nan+0j).

* Issue #22470: Fixed integer overflow issues in "backslashreplace",
  "xmlcharrefreplace", and "surrogatepass" error handlers.

* Issue #22520: Fix overflow checking when generating the repr of a
  unicode object.

* Issue #22519: Fix overflow checking in PyBytes_Repr.

* Issue #22518: Fix integer overflow issues in latin-1 encoding.

* Issue #23165: Perform overflow checks before allocating memory in
  the _Py_char2wchar function.


Library
-------

* Issue #23399: pyvenv creates relative symlinks where possible.

* Issue #23099: Closing io.BytesIO with exported buffer is rejected
  now to prevent corrupting exported buffer.

* Issue #23363: Fix possible overflow in itertools.permutations.

* Issue #23364: Fix possible overflow in itertools.product.

* Issue #23366: Fixed possible integer overflow in
  itertools.combinations.

* Issue #23369: Fixed possible integer overflow in
  _json.encode_basestring_ascii.

* Issue #23353: Fix the exception handling of generators in
  PyEval_EvalFrameEx(). At entry, save or swap the exception state
  even if PyEval_EvalFrameEx() is called with throwflag=0. At exit,
  the exception state is now always restored or swapped, not only if
  why is WHY_YIELD or WHY_RETURN. Patch co-written with Antoine
  Pitrou.

* Issue #18518: timeit now rejects statements which can't be
  compiled outside a function or a loop (e.g. "return" or "break").

* Issue #23094: Fixed readline with frames in Python implementation
  of pickle.

* Issue #23268: Fixed bugs in the comparison of ipaddress classes.

* Issue #21408: Removed incorrect implementations of __ne__() which
  didn't returned NotImplemented if __eq__() returned NotImplemented.
  The default __ne__() now works correctly.

* Issue #19996: "email.feedparser.FeedParser" now handles
  (malformed) headers with no key rather than assuming the body has
  started.

* Issue #23248: Update ssl error codes from latest OpenSSL git
  master.

* Issue #23098: 64-bit dev_t is now supported in the os module.

* Issue #23250: In the http.cookies module, capitalize "HttpOnly"
  and "Secure" as they are written in the standard.

* Issue #23063: In the disutils' check command, fix parsing of reST
  with code or code-block directives.

* Issue #23209, #23225: selectors.BaseSelector.close() now clears
  its internal reference to the selector mapping to break a reference
  cycle. Initial patch written by Martin Richard.

* Issue #21356: Make ssl.RAND_egd() optional to support LibreSSL.
  The availability of the function is checked during the compilation.
  Patch written by Bernard Spil.

* Issue #20896, #22935: The "ssl.get_server_certificate()" function
  now uses the "PROTOCOL_SSLv23" protocol by default, not
  "PROTOCOL_SSLv3", for maximum compatibility and support platforms
  where "PROTOCOL_SSLv3" support is disabled.

* Issue #23111: In the ftplib, make ssl.PROTOCOL_SSLv23 the default
  protocol version.

* Issue #23132: Mitigate regression in speed and clarity in
  functools.total_ordering.

* Issue #22585: On OpenBSD 5.6 and newer, os.urandom() now calls
  getentropy(), instead of reading /dev/urandom, to get pseudo-random
  bytes.

* Issue #23112: Fix SimpleHTTPServer to correctly carry the query
  string and fragment when it redirects to add a trailing slash.

* Issue #23093: In the io, module allow more operations to work on
  detached streams.

* Issue #19104: pprint now produces evaluable output for wrapped
  strings.

* Issue #23071: Added missing names to codecs.__all__.  Patch by
  Martin Panter.

* Issue #15513: Added a __sizeof__ implementation for pickle
  classes.

* Issue #19858: pickletools.optimize() now aware of the MEMOIZE
  opcode, can produce more compact result and no longer produces
  invalid output if input data contains MEMOIZE opcodes together with
  PUT or BINPUT opcodes.

* Issue #22095: Fixed HTTPConnection.set_tunnel with default port.
  The port value in the host header was set to "None".  Patch by
  Demian Brecht.

* Issue #23016: A warning no longer produces an AttributeError when
  the program is run with pythonw.exe.

* Issue #21775: shutil.copytree(): fix crash when copying to VFAT.
  An exception handler assumed that that OSError objects always have a
  'winerror' attribute. That is not the case, so the exception handler
  itself raised AttributeError when run on Linux (and, presumably, any
  other non-Windows OS). Patch by Greg Ward.

* Issue #1218234: Fix inspect.getsource() to load updated source of
  reloaded module. Initial patch by Berker Peksag.

* Issue #22959: In the constructor of http.client.HTTPSConnection,
  prefer the context's check_hostname attribute over the
  *check_hostname* parameter.

* Issue #16043: Add a default limit for the amount of data
  xmlrpclib.gzip_decode will return. This resolves CVE-2013-1753.

* Issue #22966: Fix __pycache__ pyc file name clobber when
  pyc_compile is asked to compile a source file containing multiple
  dots in the source file name.

* Issue #21971: Update turtledemo doc and add module to the index.

* Issue #21032. Fixed socket leak if HTTPConnection.getresponse()
  fails. Original patch by Martin Panter.

* Issue #22960: Add a context argument to xmlrpclib.ServerProxy
  constructor.

* Issue #22915: SAX parser now supports files opened with file
  descriptor or bytes path.

* Issue #22609: Constructors and update methods of mapping classes
  in the collections module now accept the self keyword argument.

* Issue #22788: Add *context* parameter to
  logging.handlers.HTTPHandler.

* Issue #22921: Allow SSLContext to take the *hostname* parameter
  even if OpenSSL doesn't support SNI.

* Issue #22894: TestCase.subTest() would cause the test suite to be
  stopped when in failfast mode, even in the absence of failures.

* Issue #22638: SSLv3 is now disabled throughout the standard
  library. It can still be enabled by instantiating a SSLContext
  manually.

* Issue #22370: Windows detection in pathlib is now more robust.

* Issue #22841: Reject coroutines in asyncio add_signal_handler().
  Patch by Ludovic.Gasc.

* Issue #22849: Fix possible double free in the io.TextIOWrapper
  constructor.

* Issue #12728: Different Unicode characters having the same
  uppercase but different lowercase are now matched in case-
  insensitive regular expressions.

* Issue #22821: Fixed fcntl() with integer argument on 64-bit big-
  endian platforms.

* Issue #22406: Fixed the uu_codec codec incorrectly ported to 3.x.
  Based on patch by Martin Panter.

* Issue #17293: uuid.getnode() now determines MAC address on AIX
  using netstat. Based on patch by Aivars Kalvāns.

* Issue #22769: Fixed ttk.Treeview.tag_has() when called without
  arguments.

* Issue #22417: Verify certificates by default in httplib (PEP 476).

* Issue #22775: Fixed unpickling of http.cookies.SimpleCookie with
  protocol 2 and above.  Patch by Tim Graham.

* Issue #22366: urllib.request.urlopen will accept a context object
  (SSLContext) as an argument which will then used be for HTTPS
  connection. Patch by Alex Gaynor.

* Issue #22776: Brought excluded code into the scope of a try block
  in SysLogHandler.emit().

* Issue #22665: Add missing get_terminal_size and SameFileError to
  shutil.__all__.

* Issue #17381: Fixed handling of case-insensitive ranges in regular
  expressions.

* Issue #22410: Module level functions in the re module now cache
  compiled locale-dependent regular expressions taking into account
  the locale.

* Issue #22759: Query methods on pathlib.Path() (exists(), is_dir(),
  etc.) now return False when the underlying stat call raises
  NotADirectoryError.

* Issue #8876: distutils now falls back to copying files when hard
  linking doesn't work.  This allows use with special filesystems such
  as VirtualBox shared folders.

* Issue #18853: Fixed ResourceWarning in shlex.__nain__.

* Issue #9351: Defaults set with set_defaults on an argparse
  subparser are no longer ignored when also set on the parent parser.

* Issue #21991: Make email.headerregistry's header 'params'
  attributes be read-only (MappingProxyType).  Previously the
  dictionary was modifiable but a new one was created on each access
  of the attribute.

* Issue #22641: In asyncio, the default SSL context for client
  connections is now created using ssl.create_default_context(), for
  stronger security.

* Issue #22435: Fix a file descriptor leak when SocketServer bind
  fails.

* Issue #13096: Fixed segfault in CTypes POINTER handling of large
  values.

* Issue #11694: Raise ConversionError in xdrlib as documented.
  Patch by Filip Gruszczyński and Claudiu Popa.

* Issue #22462: Fix pyexpat's creation of a dummy frame to make it
  appear in exception tracebacks.

* Issue #21173: Fix len() on a WeakKeyDictionary when .clear() was
  called with an iterator alive.

* Issue #11866: Eliminated race condition in the computation of
  names for new threads.

* Issue #21905: Avoid RuntimeError in pickle.whichmodule() when
  sys.modules is mutated while iterating.  Patch by Olivier Grisel.

* Issue #22219: The zipfile module CLI now adds entries for
  directories (including empty directories) in ZIP file.

* Issue #22449: In the ssl.SSLContext.load_default_certs, consult
  the environmental variables SSL_CERT_DIR and SSL_CERT_FILE on
  Windows.

* Issue #20076: Added non derived UTF-8 aliases to locale aliases
  table.

* Issue #20079: Added locales supported in glibc 2.18 to locale
  alias table.

* Issue #22396: On 32-bit AIX platform, don't expose
  os.posix_fadvise() nor os.posix_fallocate() because their prototypes
  in system headers are wrong.

* Issue #22517: When a io.BufferedRWPair object is deallocated,
  clear its weakrefs.

* Issue #22448: Improve canceled timer handles cleanup to prevent
  unbound memory usage. Patch by Joshua Moore-Oliva.

* Issue #23009: Make sure selectors.EpollSelecrtor.select() works
  when no FD is registered.


IDLE
----

* Issue #20577: Configuration of the max line length for the
  FormatParagraph extension has been moved from the General tab of the
  Idle preferences dialog to the FormatParagraph tab of the Config
  Extensions dialog. Patch by Tal Einat.

* Issue #16893: Update Idle doc chapter to match current Idle and
  add new information.

* Issue #3068: Add Idle extension configuration dialog to Options
  menu. Changes are written to HOME/.idlerc/config-extensions.cfg.
  Original patch by Tal Einat.

* Issue #16233: A module browser (File : Class Browser, Alt+C)
  requires an editor window with a filename.  When Class Browser is
  requested otherwise, from a shell, output window, or 'Untitled'
  editor, Idle no longer displays an error box.  It now pops up an
  Open Module box (Alt+M). If a valid name is entered and a module is
  opened, a corresponding browser is also opened.

* Issue #4832: Save As to type Python files automatically adds .py
  to the name you enter (even if your system does not display it).
  Some systems automatically add .txt when type is Text files.

* Issue #21986: Code objects are not normally pickled by the pickle
  module. To match this, they are no longer pickled when running under
  Idle.

* Issue #23180: Rename IDLE "Windows" menu item to "Window". Patch
  by Al Sweigart.


Tests
-----

* Issue #23392: Added tests for marshal C API that works with FILE*.

* Issue #18982: Add tests for CLI of the calendar module.

* Issue #19548: Added some additional checks to test_codecs to
  ensure that statements in the updated documentation remain accurate.
  Patch by Martin Panter.

* Issue #22838: All test_re tests now work with unittest test
  discovery.

* Issue #22173: Update lib2to3 tests to use unittest test discovery.

* Issue #16000: Convert test_curses to use unittest.

* Issue #21456: Skip two tests in test_urllib2net.py if _ssl module
  not present. Patch by Remi Pointel.

* Issue #22770: Prevent some Tk segfaults on OS X when running gui
  tests.

* Issue #23211: Workaround test_logging failure on some OS X 10.6
  systems.

* Issue #23345: Prevent test_ssl failures with large OpenSSL patch
  level values (like 0.9.8zc).

* Issue #22289: Prevent test_urllib2net failures due to ftp
  connection timeout.


Build
-----

* Issue #15506: Use standard PKG_PROG_PKG_CONFIG autoconf macro in
  the configure script.

* Issue #22935: Allow the ssl module to be compiled if openssl
  doesn't support SSL 3.

* Issue #16537: Check whether self.extensions is empty in setup.py.
  Patch by Jonathan Hosmer.

* Issue #18096: Fix library order returned by python-config.

* Issue #17219: Add library build dir for Python extension cross-
  builds.

* Issue #17128: Use private version of OpenSSL for 3.4.3 OS X 10.5+
  installer.


C API
-----

* Issue #22079: PyType_Ready() now checks that statically allocated
  type has no dynamically allocated bases.


Documentation
-------------

* Issue #19548: Update the codecs module documentation to better
  cover the distinction between text encodings and other codecs,
  together with other clarifications. Patch by Martin Panter.

* Issue #22914: Update the Python 2/3 porting HOWTO to describe a
  more automated approach.

* Issue #21514: The documentation of the json module now refers to
  new JSON RFC 7159 instead of obsoleted RFC 4627.


Tools/Demos
-----------

* Issue #22314: pydoc now works when the LINES environment variable
  is set.


Windows
-------

* Issue #17896: The Windows build scripts now expect external
  library sources to be in "PCbuild\..\externals" rather than
  "PCbuild\..\..".

* Issue #17717: The Windows build scripts now use a copy of NASM
  pulled from svn.python.org to build OpenSSL.

* Issue #22644: The bundled version of OpenSSL has been updated to
  1.0.1j.


Python 3.4.2
============

Release date: 2014-10-06


Library
-------

* Issue #10510: distutils register and upload methods now use HTML
  standards compliant CRLF line endings.

* Issue #9850: Fixed macpath.join() for empty first component.
  Patch by Oleg Oshmyan.

* Issue #22427: TemporaryDirectory no longer attempts to clean up
  twice when used in the with statement in generator.

* Issue #20912: Now directories added to ZIP file have correct Unix
  and MS-DOS directory attributes.

* Issue #21866: ZipFile.close() no longer writes ZIP64 central
  directory records if allowZip64 is false.

* Issue #22415: Fixed debugging output of the GROUPREF_EXISTS opcode
  in the re module.  Removed trailing spaces in debugging output.

* Issue #22423: Unhandled exception in thread no longer causes
  unhandled AttributeError when sys.stderr is None.

* Issue #21332: Ensure that "bufsize=1" in subprocess.Popen()
  selects line buffering, rather than block buffering.  Patch by Akira
  Li.


Python 3.4.2rc1
===============

Release date: 2014-09-22


Core and Builtins
-----------------

* Issue #22258: Fix the the internal function set_inheritable() on
  Illumos. This platform exposes the function "ioctl(FIOCLEX)", but
  calling it fails with errno is ENOTTY: "Inappropriate ioctl for
  device". set_inheritable() now falls back to the slower "fcntl()"
  ("F_GETFD" and then "F_SETFD").

* Issue #21669: With the aid of heuristics in SyntaxError.__init__,
  the parser now attempts to generate more meaningful (or at least
  more search engine friendly) error messages when "exec" and "print"
  are used as statements.

* Issue #21642: In the conditional if-else expression, allow an
  integer written with no space between itself and the "else" keyword
  (e.g. "True if 42else False") to be valid syntax.

* Issue #21523: Fix over-pessimistic computation of the stack effect
  of some opcodes in the compiler.  This also fixes a quadratic
  compilation time issue noticeable when compiling code with a large
  number of "and" and "or" operators.


Library
-------

* Issue #21091: Fix API bug:
  email.message.EmailMessage.is_attachment is now a method.  Since
  EmailMessage is provisional, we can change the API in a maintenance
  release, but we use a trick to remain backward compatible with
  3.4.0/1.

* Issue #21079: Fix email.message.EmailMessage.is_attachment to
  return the correct result when the header has parameters as well as
  a value.

* Issue #22247: Add NNTPError to nntplib.__all__.

* Issue #4180: The warnings registries are now reset when the
  filters are modified.

* Issue #22419: Limit the length of incoming HTTP request in wsgiref
  server to 65536 bytes and send a 414 error code for higher lengths.
  Patch contributed by Devin Cook.

* Lax cookie parsing in http.cookies could be a security issue when
  combined with non-standard cookie handling in some Web browsers.
  Reported by Sergey Bobrov.

* Issue #22384: An exception in Tkinter callback no longer crashes
  the program when it is run with pythonw.exe.

* Issue #22168: Prevent turtle AttributeError with non-default
  Canvas on OS X.

* Issue #21147: sqlite3 now raises an exception if the request
  contains a null character instead of truncate it.  Based on patch by
  Victor Stinner.

* Issue #21951: Fixed a crash in Tkinter on AIX when called Tcl
  command with empty string or tuple argument.

* Issue #21951: Tkinter now most likely raises MemoryError instead
  of crash if the memory allocation fails.

* Issue #22338: Fix a crash in the json module on memory allocation
  failure.

* Issue #22226: First letter no longer is stripped from the "status"
  key in the result of Treeview.heading().

* Issue #19524: Fixed resource leak in the HTTP connection when an
  invalid response is received.  Patch by Martin Panter.

* Issue #22051: turtledemo no longer reloads examples to re-run
  them. Initialization of variables and gui setup should be done in
  main(), which is called each time a demo is run, but not on import.

* Issue #21933: Turtledemo users can change the code font size with
  a menu selection or control(command) '-' or '+' or control-
  mousewheel. Original patch by Lita Cho.

* Issue #21597: The separator between the turtledemo text pane and
  the drawing canvas can now be grabbed and dragged with a mouse.  The
  code text pane can be widened to easily view or copy the full width
  of the text.  The canvas can be widened on small screens.  Original
  patches by Jan Kanis and Lita Cho.

* Issue #18132: Turtledemo buttons no longer disappear when the
  window is shrunk.  Original patches by Jan Kanis and Lita Cho.

* Issue #22216: smtplib now resets its state more completely after a
  quit.  The most obvious consequence of the previous behavior was a
  STARTTLS failure during a connect/starttls/quit/connect/starttls
  sequence.

* Issue #22185: Fix an occasional RuntimeError in
  threading.Condition.wait() caused by mutation of the waiters queue
  without holding the lock.  Patch by Doug Zongker.

* Issue #22182: Use e.args to unpack exceptions correctly in
  distutils.file_util.move_file. Patch by Claudiu Popa.

* The webbrowser module now uses subprocess's start_new_session=True
  rather than a potentially risky preexec_fn=os.setsid call.

* Issue #22236: Fixed Tkinter images copying operations in
  NoDefaultRoot mode.

* Issue #22191: Fix warnings.__all__.

* Issue #15696: Add a __sizeof__ implementation for mmap objects on
  Windows.

* Issue #22068: Avoided reference loops with Variables and Fonts in
  Tkinter.

* Issue #22165: SimpleHTTPRequestHandler now supports undecodable
  file names.

* Issue #8797: Raise HTTPError on failed Basic Authentication
  immediately. Initial patch by Sam Bull.

* Issue #20729: Restored the use of lazy
  iterkeys()/itervalues()/iteritems() in the mailbox module.

* Issue #21448: Changed FeedParser feed() to avoid O(N**2) behavior
  when parsing long line.  Original patch by Raymond Hettinger.

* Issue #22184: The functools LRU Cache decorator factory now gives
  an earlier and clearer error message when the user forgets the
  required parameters.

* Issue #17923: glob() patterns ending with a slash no longer match
  non-dirs on AIX.  Based on patch by Delhallt.

* Issue #21121: Don't force 3rd party C extensions to be built with
  -Werror=declaration-after-statement.

* Issue #21975: Fixed crash when using uninitialized sqlite3.Row (in
  particular when unpickling pickled sqlite3.Row).  sqlite3.Row is now
  initialized in the __new__() method.

* Issue #21580: Now Tkinter correctly handles bytes arguments passed
  to Tk. In particular this allows to initialize images from binary
  data.

* Issue #17172: Make turtledemo start as active on OS X even when
  run with subprocess.  Patch by Lita Cho.

* Issue #21704: Fix build error for _multiprocessing when semaphores
  are not available.  Patch by Arfrever Frehtes Taifersar Arahesis.

* Fix repr(_socket.socket) on Windows 64-bit: don't fail with
  OverflowError on closed socket. repr(socket.socket) already works
  fine.

* Issue #16133: The asynchat.async_chat.handle_read() method now
  ignores BlockingIOError exceptions.

* Issue #22044: Fixed premature DECREF in call_tzinfo_method. Patch
  by Tom Flanagan.

* Issue #19884: readline: Disable the meta modifier key if stdout is
  not a terminal to not write the ANSI sequence "033[1034h" into
  stdout. This sequence is used on some terminal (ex: TERM=xterm-
  256color") to enable support of 8 bit characters.

* Issue #21888: plistlib's load() and loads() now work if the fmt
  parameter is specified.

* Issue #21044: tarfile.open() now handles fileobj with an integer
  'name' attribute.  Based on patch by Antoine Pietri.

* Issue #21867: Prevent turtle crash due to invalid undo buffer
  size.

* Issue #19076: Don't pass the redundant 'file' argument to
  self.error().

* Issue #21942: Fixed source file viewing in pydoc's server mode on
  Windows.

* Issue #11259: asynchat.async_chat().set_terminator() now raises a
  ValueError if the number of received bytes is negative.

* Issue #12523: asynchat.async_chat.push() now raises a TypeError if
  it doesn't get a bytes string

* Issue #21707: Add missing kwonlyargcount argument to
  ModuleFinder.replace_paths_in_code().

* Issue #20639: calling Path.with_suffix('') allows removing the
  suffix again.  Patch by July Tikhonov.

* Issue #21714: Disallow the construction of invalid paths using
  Path.with_name().  Original patch by Antony Lee.

* Issue #21897: Fix a crash with the f_locals attribute with closure
  variables when frame.clear() has been called.

* Issue #21151: Fixed a segfault in the winreg module when "None" is
  passed as a "REG_BINARY" value to SetValueEx.  Patch by John
  Ehresman.

* Issue #21090: io.FileIO.readall() does not ignore I/O errors
  anymore. Before, it ignored I/O errors if at least the first C call
  read() succeed.

* Issue #21781: ssl.RAND_add() now supports strings longer than 2
  GB.

* Issue #11453: asyncore: emit a ResourceWarning when an unclosed
  file_wrapper object is destroyed. The destructor now closes the file
  if needed. The close() method can now be called twice: the second
  call does nothing.

* Issue #21858: Better handling of Python exceptions in the sqlite3
  module.

* Issue #21476: Make sure the email.parser.BytesParser TextIOWrapper
  is discarded after parsing, so the input file isn't unexpectedly
  closed.

* Issue #21729: Used the "with" statement in the dbm.dumb module to
  ensure files closing.  Patch by Claudiu Popa.

* Issue #21491: socketserver: Fix a race condition in child
  processes reaping.

* Issue #21832: Require named tuple inputs to be exact strings.

* Issue #19145: The times argument for itertools.repeat now handles
  negative values the same way for keyword arguments as it does for
  positional arguments.

* Issue #21812: turtle.shapetransform did not tranform the turtle on
  the first call.  (Issue identified and fixed by Lita Cho.)

* Issue #21635: The difflib SequenceMatcher.get_matching_blocks()
  method cache didn't match the actual result.  The former was a list
  of tuples and the latter was a list of named tuples.

* Issue #21722: The distutils "upload" command now exits with a non-
  zero return code when uploading fails.  Patch by Martin Dengler.

* Issue #21723: asyncio.Queue: support any type of number (ex:
  float) for the maximum size. Patch written by Vajrasky Kok.

* Issue #21326: Add a new is_closed() method to
  asyncio.BaseEventLoop. run_forever() and run_until_complete()
  methods of asyncio.BaseEventLoop now raise an exception if the event
  loop was closed.

* Issue #21774: Fixed NameError for an incorrect variable reference
  in the XML Minidom code for creating processing instructions. (Found
  and fixed by Claudiu Popa.)

* Issue #21766: Prevent a security hole in CGIHTTPServer by URL
  unquoting paths before checking for a CGI script at that path.

* Issue #21310: Fixed possible resource leak in failed open().

* Issue #21677: Fixed chaining nonnormalized exceptions in io
  close() methods.

* Issue #11709: Fix the pydoc.help function to not fail when
  sys.stdin is not a valid file.

* Issue #13223: Fix pydoc.writedoc so that the HTML documentation
  for methods that use 'self' in the example code is generated
  correctly.

* Issue #21463: In urllib.request, fix pruning of the FTP cache.

* Issue #21618: The subprocess module could fail to close open fds
  that were inherited by the calling process and already higher than
  POSIX resource limits would otherwise allow.  On systems with a
  functioning /proc/self/fd or /dev/fd interface the max is now
  ignored and all fds are closed.

* Issue #21552: Fixed possible integer overflow of too long string
  lengths in the tkinter module on 64-bit platforms.

* Issue #14315: The zipfile module now ignores extra fields in the
  central directory that are too short to be parsed instead of letting
  a struct.unpack error bubble up as this "bad data" appears in many
  real world zip files in the wild and is ignored by other zip tools.

* Issue #21402: tkinter.ttk now works when default root window is
  not set.

* Issue #10203: sqlite3.Row now truly supports sequence protocol.
  In particular it supports reverse() and negative indices.  Original
  patch by Claudiu Popa.

* Issue #18807: If copying (no symlinks) specified for a venv, then
  the python interpreter aliases (python, python3) are now created by
  copying rather than symlinking.

* Issue #14710: pkgutil.get_loader() no longer raises an exception
  when None is found in sys.modules.

* Issue #14710: pkgutil.find_loader() no longer raises an exception
  when a module doesn't exist.

* Issue #21481: Argparse equality and inequality tests now return
  NotImplemented when comparing to an unknown type.

* Issue #8743: Fix interoperability between set objects and the
  collections.Set() abstract base class.

* Issue #13355: random.triangular() no longer fails with a
  ZeroDivisionError when low equals high.

* Issue #21538: The plistlib module now supports loading of binary
  plist files when reference or offset size is not a power of two.

* Issue #21801: Validate that __signature__ is None or an instance
  of Signature.

* Issue #21923: Prevent AttributeError in
  distutils.sysconfig.customize_compiler due to possible uninitialized
  _config_vars.

* Issue #21323: Fix http.server to again handle scripts in CGI
  subdirectories, broken by the fix for security issue #19435.  Patch
  by Zach Byrne.


Extension Modules
-----------------

* Issue #22176: Update the ctypes module's libffi to v3.1.  This
  release adds support for the Linux AArch64 and POWERPC ELF ABIv2
  little endian architectures.


Build
-----

* Issue #15661: python.org OS X installers are now distributed as
  signed installer packages compatible with the Gatekeeper security
  feature.

* Issue #21958: Define HAVE_ROUND when building with Visual Studio
  2013 and above.  Patch by Zachary Turner.

* Issue #15759: "make suspicious", "make linkcheck" and "make
  doctest" in Doc/ now display special message when and only when
  there are failures.

* Issue #17095: Fix Modules/Setup *shared* support.

* Issue #21811: Anticipated fixes to support OS X versions > 10.9.

* Issue #21166: Prevent possible segfaults and other random failures
  of python --generate-posix-vars in pybuilddir.txt build target.


IDLE
----

* Issue #17390: Adjust Editor window title; remove 'Python', move
  version to end.

* Issue #14105: Idle debugger breakpoints no longer disappear when
  inseting or deleting lines.

* Issue #17172: Turtledemo can now be run from Idle. Currently, the
  entry is on the Help menu, but it may move to Run. Patch by
  Ramchandra Apt and Lita Cho.

* Issue #21765: Add support for non-ascii identifiers to
  HyperParser.

* Issue #21940: Add unittest for WidgetRedirector. Initial patch by
  Saimadhav Heblikar.

* Issue #18592: Add unittest for SearchDialogBase. Patch by Phil
  Webster.

* Issue #21694: Add unittest for ParenMatch. Patch by Saimadhav
  Heblikar.

* Issue #21686: add unittest for HyperParser. Original patch by
  Saimadhav Heblikar.

* Issue #12387: Add missing upper(lower)case versions of default
  Windows key bindings for Idle so Caps Lock does not disable them.
  Patch by Roger Serwy.

* Issue #21695: Closing a Find-in-files output window while the
  search is still in progress no longer closes Idle.

* Issue #18910: Add unittest for textView. Patch by Phil Webster.

* Issue #18292: Add unittest for AutoExpand. Patch by Saihadhav
  Heblikar.

* Issue #18409: Add unittest for AutoComplete. Patch by Phil
  Webster.


Tests
-----

* Issue #22166: With the assistance of a new internal
  _codecs._forget_codec helping function, test_codecs now clears the
  encoding caches to avoid the appearance of a reference leak

* Issue #22236: Tkinter tests now don't reuse default root window.
  New root window is created for every test class.

* Issue #20746: Fix test_pdb to run in refleak mode (-R).  Patch by
  Xavier de Gaye.

* Issue #22060: test_ctypes has been somewhat cleaned up and
  simplified; it now uses unittest test discovery to find its tests.

* Issue #22104: regrtest.py no longer holds a reference to the suite
  of tests loaded from test modules that don't define test_main().

* Issue #22002: Added "load_package_tests" function to test.support
  and used it to implement/augment test discovery in test_asyncio,
  test_email, test_importlib, test_json, and test_tools.

* Issue #21976: Fix test_ssl to accept LibreSSL version strings.
  Thanks to William Orr.

* Issue #21918: Converted test_tools from a module to a package
  containing separate test files for each tested script.

* Issue #20155: Changed HTTP method names in failing tests in
  test_httpservers so that packet filtering software (specifically
  Windows Base Filtering Engine) does not interfere with the
  transaction semantics expected by the tests.

* Issue #19493: Refactored the ctypes test package to skip tests
  explicitly rather than silently.

* Issue #18492: All resources are now allowed when tests are not run
  by regrtest.py.

* Issue #21634: Fix pystone micro-benchmark: use floor division
  instead of true division to benchmark integers instead of floating
  point numbers. Set pystone version to 1.2. Patch written by Lennart
  Regebro.

* Issue #21605: Added tests for Tkinter images.

* Issue #21493: Added test for ntpath.expanduser().  Original patch
  by Claudiu Popa.

* Issue #19925: Added tests for the spwd module. Original patch by
  Vajrasky Kok.

* Issue #21522: Added Tkinter tests for Listbox.itemconfigure(),
  PanedWindow.paneconfigure(), and Menu.entryconfigure().


Documentation
-------------

* Issue #21777: The binary sequence methods on bytes and bytearray
  are now documented explicitly, rather than assuming users will be
  able to derive the expected behaviour from the behaviour of the
  corresponding str methods.


Windows
-------

* Issue #21671, #22160, CVE-2014-0224: The bundled version of
  OpenSSL has been updated to 1.0.1i.

* Issue #10747: Use versioned labels in the Windows start menu.
  Patch by Olive Kilburn.


Tools/Demos
-----------

* Issue #22201: Command-line interface of the zipfile module now
  correctly extracts ZIP files with directory entries.  Patch by Ryan
  Wilson.

* Issue #21906: Make Tools/scripts/md5sum.py work in Python 3. Patch
  by Zachary Ware.

* Issue #21629: Fix Argument Clinic's "--converters" feature.


Python 3.4.1
============

Release date: 2014-05-18


Core and Builtins
-----------------

* Issue #21418: Fix a crash in the builtin function super() when
  called without argument and without current frame (ex: embedded
  Python).

* Issue #21425: Fix flushing of standard streams in the interactive
  interpreter.

* Issue #21435: In rare cases, when running finalizers on objects in
  cyclic trash a bad pointer dereference could occur due to a subtle
  flaw in internal iteration logic.


Library
-------

* Issue #10744: Fix PEP 3118 format strings on ctypes objects with a
  nontrivial shape.

* Issue #20998: Fixed re.fullmatch() of repeated single character
  pattern with ignore case.  Original patch by Matthew Barnett.

* Issue #21075: fileinput.FileInput now reads bytes from standard
  stream if binary mode is specified.  Patch by Sam Kimbrel.

* Issue #21396: Fix TextIOWrapper(..., write_through=True) to not
  force a flush() on the underlying binary stream.  Patch by akira.

* Issue #21470: Do a better job seeding the random number generator
  by using enough bytes to span the full state space of the Mersenne
  Twister.

* Issue #21398: Fix an unicode error in the pydoc pager when the
  documentation contains characters not encodable to the stdout
  encoding.


Tests
-----

* Issue #17756: Fix test_code test when run from the installed
  location.

* Issue #17752: Fix distutils tests when run from the installed
  location.


IDLE
----

* Issue #18104: Add idlelib/idle_test/htest.py with a few sample
  tests to begin consolidating and improving human-validated tests of
  Idle. Change other files as needed to work with htest.  Running the
  module as __main__ runs all tests.


Python 3.4.1rc1
===============

Release date: 2014-05-05


Core and Builtins
-----------------

* Issue #21274: Define PATH_MAX for GNU/Hurd in Python/pythonrun.c.

* Issue #21209: Fix sending tuples to custom generator objects with
  the yield from syntax.

* Issue #21134: Fix segfault when str is called on an uninitialized
  UnicodeEncodeError, UnicodeDecodeError, or UnicodeTranslateError
  object.

* Issue #19537: Fix PyUnicode_DATA() alignment under m68k.  Patch by
  Andreas Schwab.

* Issue #20929: Add a type cast to avoid shifting a negative number.

* Issue #20731: Properly position in source code files even if they
  are opened in text mode. Patch by Serhiy Storchaka.

* Issue #20637: Key-sharing now also works for instance dictionaries
  of subclasses.  Patch by Peter Ingebretson.

* Issue #12546: Allow "\x00" to be used as a fill character when
  using str, int, float, and complex __format__ methods.

* Issue #13598: Modify string.Formatter to support auto-numbering of
  replacement fields. It now matches the behavior of str.format() in
  this regard. Patches by Phil Elson and Ramchandra Apte.


Library
-------

* Issue #21088: Bugfix for curses.window.addch() regression in
  3.4.0. In porting to Argument Clinic, the first two arguments were
  reversed.

* Issue #21469: Reduced the risk of false positives in robotparser
  by checking to make sure that robots.txt has been read or does not
  exist prior to returning True in can_fetch().

* Issue #21321: itertools.islice() now releases the reference to the
  source iterator when the slice is exhausted.  Patch by Anton
  Afanasyev.

* Issue #9815: assertRaises now tries to clear references to local
  variables in the exception's traceback.

* Issue #13204: Calling sys.flags.__new__ would crash the
  interpreter, now it raises a TypeError.

* Issue #19385: Make operations on a closed dbm.dumb database always
  raise the same exception.

* Issue #21207: Detect when the os.urandom cached fd has been closed
  or replaced, and open it anew.

* Issue #21291: subprocess's Popen.wait() is now thread safe so that
  multiple threads may be calling wait() or poll() on a Popen instance
  at the same time without losing the Popen.returncode value.

* Issue #21127: Path objects can now be instantiated from str
  subclass instances (such as "numpy.str_").

* Issue #15002: urllib.response object to use _TemporaryFileWrapper
  (and _TemporaryFileCloser) facility. Provides a better way to handle
  file descriptor close. Patch contributed by Christian Theune.

* Issue #12220: mindom now raises a custom ValueError indicating it
  doesn't support spaces in URIs instead of letting a 'split'
  ValueError bubble up.

* Issue #21239: patch.stopall() didn't work deterministically when
  the same name was patched more than once.

* Issue #21222: Passing name keyword argument to
  mock.create_autospec now works.

* Issue #21197: Add lib64 -> lib symlink in venvs on 64-bit non-OS X
  POSIX.

* Issue #17498: Some SMTP servers disconnect after certain errors,
  violating strict RFC conformance.  Instead of losing the error code
  when we issue the subsequent RSET, smtplib now returns the error
  code and defers raising the SMTPServerDisconnected error until the
  next command is issued.

* Issue #17826: setting an iterable side_effect on a mock function
  created by create_autospec now works. Patch by Kushal Das.

* Issue #7776: Fix "Host:" header and reconnection when using
  http.client.HTTPConnection.set_tunnel(). Patch by Nikolaus Rath.

* Issue #20968: unittest.mock.MagicMock now supports division. Patch
  by Johannes Baiter.

* Issue #21529 (CVE-2014-4616): Fix arbitrary memory access in
  JSONDecoder.raw_decode with a negative second parameter. Bug
  reported by Guido Vranken.

* Issue #21169: getpass now handles non-ascii characters that the
  input stream encoding cannot encode by re-encoding using the replace
  error handler.

* Issue #21171: Fixed undocumented filter API of the rot13 codec.
  Patch by Berker Peksag.

* Issue #21172: isinstance check relaxed from dict to
  collections.Mapping.

* Issue #21155: asyncio.EventLoop.create_unix_server() now raises a
  ValueError if path and sock are specified at the same time.

* Issue #21149: Improved thread-safety in logging cleanup during
  interpreter shutdown. Thanks to Devin Jeanpierre for the patch.

* Issue #20145: "assertRaisesRegex" and "assertWarnsRegex" now raise
  a TypeError if the second argument is not a string or compiled
  regex.

* Issue #21058: Fix a leak of file descriptor in
  "tempfile.NamedTemporaryFile()", close the file descriptor if
  "io.open()" fails

* Issue #21200: Return None from pkgutil.get_loader() when __spec__
  is missing.

* Issue #21013: Enhance ssl.create_default_context() when used for
  server side sockets to provide better security by default.

* Issue #20633: Replace relative import by absolute import.

* Issue #20980: Stop wrapping exception when using ThreadPool.

* Issue #21082: In os.makedirs, do not set the process-wide umask.
  Note this changes behavior of makedirs when exist_ok=True.

* Issue #20990: Fix issues found by pyflakes for multiprocessing.

* Issue #21015: SSL contexts will now automatically select an
  elliptic curve for ECDH key exchange on OpenSSL 1.0.2 and later, and
  otherwise default to "prime256v1".

* Issue #20995: Enhance default ciphers used by the ssl module to
  enable better security an prioritize perfect forward secrecy.

* Issue #20884: Don't assume that __file__ is defined on
  importlib.__init__.

* Issue #21499: Ignore __builtins__ in several
  test_importlib.test_api tests.

* Issue #20879: Delay the initialization of encoding and decoding
  tables for base32, ascii85 and base85 codecs in the base64 module,
  and delay the initialization of the unquote_to_bytes() table of the
  urllib.parse module, to not waste memory if these modules are not
  used.

* Issue #19157: Include the broadcast address in the usuable hosts
  for IPv6 in ipaddress.

* Issue #11599: When an external command (e.g. compiler) fails,
  distutils now prints out the whole command line (instead of just the
  command name) if the environment variable DISTUTILS_DEBUG is set.

* Issue #4931: distutils should not produce unhelpful "error: None"
  messages anymore.  distutils.util.grok_environment_error is kept but
  doc-deprecated.

* Issue #20875: Prevent possible gzip "'read' is not defined"
  NameError. Patch by Claudiu Popa.

* Issue #11558: "email.message.Message.attach" now returns a more
  useful error message if "attach" is called on a message for which
  "is_multipart" is False.

* Issue #20283: RE pattern methods now accept the string keyword
  parameters as documented.  The pattern and source keyword parameters
  are left as deprecated aliases.

* Issue #20778: Fix modulefinder to work with bytecode-only modules.

* Issue #20791: copy.copy() now doesn't make a copy when the input
  is a bytes object.  Initial patch by Peter Otten.

* Issue #19748: On AIX, time.mktime() now raises an OverflowError
  for year outsize range [1902; 2037].

* Issue #20816: Fix inspect.getcallargs() to raise correct TypeError
  for missing keyword-only arguments. Patch by Jeremiah Lowin.

* Issue #20817: Fix inspect.getcallargs() to fail correctly if more
  than 3 arguments are missing. Patch by Jeremiah Lowin.

* Issue #6676: Ensure a meaningful exception is raised when
  attempting to parse more than one XML document per pyexpat xmlparser
  instance. (Original patches by Hirokazu Yamamoto and Amaury Forgeot
  d'Arc, with suggested wording by David Gutteridge)

* Issue #21117: Fix inspect.signature to better support
  functools.partial. Due to the specifics of functools.partial
  implementation, positional-or-keyword arguments passed as keyword
  arguments become keyword-only.

* Issue #21209: Fix asyncio.tasks.CoroWrapper to workaround a bug in
  yield-from implementation in CPythons prior to 3.4.1.

* asyncio: Add gi_{frame,running,code} properties to CoroWrapper
  (upstream issue #163).

* Issue #21311: Avoid exception in _osx_support with non-standard
  compiler configurations.  Patch by John Szakmeister.

* Issue #11571: Ensure that the turtle window becomes the topmost
  window when launched on OS X.


Extension Modules
-----------------

* Issue #21276: posixmodule: Don't define USE_XATTRS on KFreeBSD and
  the Hurd.

* Issue #21226: Set up modules properly in
  PyImport_ExecCodeModuleObject (and friends).


IDLE
----

* Issue #21139: Change default paragraph width to 72, the PEP 8
  recommendation.

* Issue #21284: Paragraph reformat test passes after user changes
  reformat width.

* Issue #17654: Ensure IDLE menus are customized properly on OS X
  for non-framework builds and for all variants of Tk.


Build
-----

* The Windows build now includes OpenSSL 1.0.1g

* Issue #21285: Refactor and fix curses configure check to always
  search in a ncursesw directory.

* Issue #15234: For BerkelyDB and Sqlite, only add the found library
  and include directories if they aren't already being searched. This
  avoids an explicit runtime library dependency.

* Issue #20644: OS X installer build support for documentation build
  changes in 3.4.1: assume externally supplied sphinx-build is
  available in /usr/bin.


C API
-----

* Issue #20942: PyImport_ImportFrozenModuleObject() no longer sets
  __file__ to match what importlib does; this affects
  _frozen_importlib as well as any module loaded using
  imp.init_frozen().


Documentation
-------------

* Issue #17386: Expanded functionality of the "Doc/make.bat" script
  to make it much more comparable to "Doc/Makefile".

* Issue #21043: Remove the recommendation for specific CA
  organizations and to mention the ability to load the OS
  certificates.

* Issue #20765: Add missing documentation for PurePath.with_name()
  and PurePath.with_suffix().

* Issue #19407: New package installation and distribution guides
  based on the Python Packaging Authority tools. Existing guides have
  been retained as legacy links from the distutils docs, as they still
  contain some required reference material for tool developers that
  isn't recorded anywhere else.

* Issue #19697: Document cases where __main__.__spec__ is None.


Tests
-----

* Issue #18604: Consolidated checks for GUI availability.  All
  platforms now at least check whether Tk can be instantiated when the
  GUI resource is requested.

* Issue #21275: Fix a socket test on KFreeBSD.

* Issue #21223: Pass test_site/test_startup_imports when some of the
  extensions are built as builtins.

* Issue #20635: Added tests for Tk geometry managers.

* Add test case for freeze.

* Issue #20743: Fix a reference leak in test_tcl.

* Issue #21097: Move test_namespace_pkgs into test_importlib.

* Issue #20939: Avoid various network test failures due to new
  redirect of http://www.python.org/ to https://www.python.org: use
  http://www.example.com instead.

* Issue #20668: asyncio tests no longer rely on tests.txt file.
  (Patch by Vajrasky Kok)

* Issue #21093: Prevent failures of ctypes test_macholib on OS X if
  a copy of libz exists in $HOME/lib or /usr/local/lib.


Tools/Demos
-----------

* Add support for "yield from" to 2to3.

* Add support for the PEP 465 matrix multiplication operator to
  2to3.

* Issue #16047: Fix module exception list and __file__ handling in
  freeze. Patch by Meador Inge.

* Issue #11824: Consider ABI tags in freeze. Patch by Meador Inge.

* Issue #20535: PYTHONWARNING no longer affects the run_tests.py
  script. Patch by Arfrever Frehtes Taifersar Arahesis.


Python 3.4.0
============

Release date: 2014-03-16


Library
-------

* Issue #20939: Fix test_geturl failure in test_urllibnet due to new
  redirect of http://www.python.org/ to https://www.python.org.


Documentation
-------------

* Merge in all documentation changes since branching 3.4.0rc1.


Python 3.4.0 release candidate 3
================================

Release date: 2014-03-09


Core and Builtins
-----------------

* Issue #20786: Fix signatures for dict.__delitem__ and
  property.__delete__ builtins.


Library
-------

* Issue #20839: Don't trigger a DeprecationWarning in the still
  supported pkgutil.get_loader() API when __loader__ isn't set on a
  module (nor when pkgutil.find_loader() is called directly).


Build
-----

* Issue #14512: Launch pydoc -b instead of pydocgui.pyw on Windows.

* Issue #20748: Uninstalling pip does not leave behind the pyc of
  the uninstaller anymore.

* Issue #20568: The Windows installer now installs the unversioned
  "pip" command in addition to the versioned "pip3" and "pip3.4"
  commands.

* Issue #20757: The ensurepip helper for the Windows uninstaller now
  skips uninstalling pip (rather than failing) if the user has updated
  pip to a different version from the one bundled with ensurepip.

* Issue #20465: Update OS X and Windows installer builds to use
  SQLite 3.8.3.1.


Python 3.4.0 release candidate 2
================================

Release date: 2014-02-23


Core and Builtins
-----------------

* Issue #20625: Parameter names in __annotations__ were not mangled
  properly. Discovered by Jonas Wielicki, patch by Yury Selivanov.

* Issue #20261: In pickle, lookup __getnewargs__ and
  __getnewargs_ex__ on the type of the object.

* Issue #20619: Give the AST nodes of keyword-only arguments a
  column and line number.

* Issue #20526: Revert changes of issue #19466 which introduces a
  regression: don't clear anymore the state of Python threads early
  during the Python shutdown.


Library
-------

* Issue #20710: The pydoc summary line no longer displays the "self"
  parameter for bound methods.

* Issue #20566: Change asyncio.as_completed() to use a Queue, to
  avoid O(N**2) behavior.

* Issue #20704: Implement new debug API in asyncio. Add new methods
  BaseEventLoop.set_debug() and BaseEventLoop.get_debug(). Add support
  for setting 'asyncio.tasks._DEBUG' variable with
  'PYTHONASYNCIODEBUG' environment variable.

* asyncio: Refactoring and fixes: BaseEventLoop.sock_connect()
  raises an error if the address is not resolved; use __slots__ in
  Handle and TimerHandle; as_completed() and wait() raise TypeError if
  the passed list of Futures is a single Future; call_soon() and other
  'call_*()' functions raise TypeError if the passed callback is a
  coroutine function; _ProactorBasePipeTransport uses
  _FlowControlMixin; WriteTransport.set_write_buffer_size() calls
  _maybe_pause_protocol() to consider pausing receiving if the
  watermark limits have changed; fix _check_resolved_address() for
  IPv6 address; and other minor improvements, along with multiple
  documentation updates.

* Issue #20684: Fix inspect.getfullargspec() to not to follow
  __wrapped__ chains. Make its behaviour consistent with bound methods
  first argument. Patch by Nick Coghlan and Yury Selivanov.

* Issue #20681: Add new error handling API in asyncio. New APIs:
  loop.set_exception_handler(), loop.default_exception_handler(), and
  loop.call_exception_handler().

* Issue #20673: Implement support for UNIX Domain Sockets in
  asyncio. New APIs: loop.create_unix_connection(),
  loop.create_unix_server(), streams.open_unix_connection(), and
  streams.start_unix_server().

* Issue #20616: Add a format() method to tracemalloc.Traceback.

* Issue #19744: the ensurepip installation step now just prints a
  warning to stderr rather than failing outright if SSL/TLS is
  unavailable. This allows local installation of POSIX builds without
  SSL/TLS support.

* Issue #20594: Avoid name clash with the libc function posix_close.


Build
-----

* Issue #20641: Run MSI custom actions (pip installation, pyc
  compilation) with the NoImpersonate flag, to support elevated
  execution (UAC).

* Issue #20221: Removed conflicting (or circular) hypot definition
  when compiled with VS 2010 or above.  Initial patch by Tabrez
  Mohammed.

* Issue #20609: Restored the ability to build 64-bit Windows
  binaries on 32-bit Windows, which was broken by the change in issue
  #19788.


Python 3.4.0 release candidate 1
================================

Release date: 2014-02-10


Core and Builtins
-----------------

* Issue #19255: The builtins module is restored to initial value
  before cleaning other modules.  The sys and builtins modules are
  cleaned last.

* Issue #20588: Make Python-ast.c C89 compliant.

* Issue #20437: Fixed 22 potential bugs when deleting objects
  references.

* Issue #20500: Displaying an exception at interpreter shutdown no
  longer risks triggering an assertion failure in PyObject_Str.

* Issue #20538: UTF-7 incremental decoder produced inconsistent
  string when input was truncated in BASE64 section.

* Issue #20404: io.TextIOWrapper (and hence the open() builtin) now
  uses the internal codec marking system added for issue #19619 to
  throw LookupError for known non-text encodings at stream
  construction time. The existing output type checks remain in place
  to deal with unmarked third party codecs.

* Issue #17162: Add PyType_GetSlot.

* Issue #20162: Fix an alignment issue in the siphash24() hash
  function which caused a crash on PowerPC 64-bit (ppc64).


Library
-------

* Issue #20530: The signatures for slot builtins have been updated
  to reflect the fact that they only accept positional-only arguments.

* Issue #20517: Functions in the os module that accept two filenames
  now register both filenames in the exception on failure.

* Issue #20563: The ipaddress module API is now considered stable.

* Issue #14983: email.generator now always adds a line end after
  each MIME boundary marker, instead of doing so only when there is an
  epilogue.  This fixes an RFC compliance bug and solves an issue with
  signed MIME parts.

* Issue #20540: Fix a performance regression (vs. Python 3.2) when
  layering a multiprocessing Connection over a TCP socket.  For small
  payloads, Nagle's algorithm would introduce idle delays before the
  entire transmission of a message.

* Issue #16983: the new email header parsing code will now decode
  encoded words that are (incorrectly) surrounded by quotes, and
  register a defect.

* Issue #19772: email.generator no longer mutates the message object
  when doing a down-transform from 8bit to 7bit CTEs.

* Issue #20536: the statistics module now correctly handle Decimal
  instances with positive exponents

* Issue #18805: the netmask/hostmask parsing in ipaddress now more
  reliably filters out illegal values and correctly allows any valid
  prefix length.

* Issue #20481: For at least Python 3.4, the statistics module will
  require that all inputs for a single operation be of a single
  consistent type, or else a mixed of ints and a single other
  consistent type. This avoids some interoperability issues that arose
  with the previous approach of coercing to a suitable common type.

* Issue #20478: the statistics module now treats collections.Counter
  inputs like any other iterable.

* Issue #17369: get_filename was raising an exception if the
  filename parameter's RFC2231 encoding was broken in certain ways.
  This was a regression relative to python2.

* Issue #20013: Some imap servers disconnect if the current mailbox
  is deleted, and imaplib did not handle that case gracefully.  Now it
  handles the 'bye' correctly.

* Issue #20531: Revert 3.4 version of fix for #19063, and apply the
  3.3 version.  That is, do *not* raise an error if unicode is passed
  to email.message.Message.set_payload.

* Issue #20476: If a non-compat32 policy is used with any of the
  email parsers, EmailMessage is now used as the factory class.  The
  factory class should really come from the policy; that will get
  fixed in 3.5.

* Issue #19920: TarFile.list() no longer fails when outputs a
  listing containing non-encodable characters.  Based on patch by
  Vajrasky Kok.

* Issue #20515: Fix NULL pointer dereference introduced by issue
  #20368.

* Issue #19186: Restore namespacing of expat symbols inside the
  pyexpat module.

* Issue #20053: ensurepip (and hence venv) are no longer affected by
  the settings in the default pip configuration file.

* Issue #20426: When passing the re.DEBUG flag, re.compile()
  displays the debug output every time it is called, regardless of the
  compilation cache.

* Issue #20368: The null character now correctly passed from Tcl to
  Python. Improved error handling in variables-related commands.

* Issue #20435: Fix _pyio.StringIO.getvalue() to take into account
  newline translation settings.

* tracemalloc: Fix slicing traces and fix slicing a traceback.

* Issue #20354: Fix an alignment issue in the tracemalloc module on
  64-bit platforms. Bug seen on 64-bit Linux when using "make profile-
  opt".

* Issue #17159: inspect.signature now accepts duck types of
  functions, which adds support for Cython functions. Initial patch by
  Stefan Behnel.

* Issue #18801: Fix inspect.classify_class_attrs to correctly
  classify object.__new__ and object.__init__.

* Fixed cmath.isinf's name in its argument parsing code.

* Issue #20311, #20452: poll and epoll now round the timeout away
  from zero, instead of rounding towards zero, in select and selectors
  modules: select.epoll.poll(), selectors.PollSelector.poll() and
  selectors.EpollSelector.poll(). For example, a timeout of one
  microsecond (1e-6) is now rounded to one millisecondi (1e-3),
  instead of being rounded to zero.  However, the granularity property
  and asyncio's resolution feature were removed again.

* asyncio: Some refactoring; various fixes; add write flow control
  to unix pipes; Future.set_exception() instantiates the exception
  argument if it is a class; improved proactor pipe transport; support
  wait_for(f, None); don't log broken/disconnected pipes; use
  ValueError instead of assert for forbidden subprocess_{shell,exec}
  arguments; added a convenience API for subprocess management; added
  StreamReader.at_eof(); properly handle duplicate coroutines/futures
  in gather(), wait(), as_completed(); use a bytearray for buffering
  in StreamReader; and more.

* Issue #20288: fix handling of invalid numeric charrefs in
  HTMLParser.

* Issue #20424: Python implementation of io.StringIO now supports
  lone surrogates.

* Issue #20308: inspect.signature now works on classes without user-
  defined __init__ or __new__ methods.

* Issue #20372: inspect.getfile (and a bunch of other inspect
  functions that use it) doesn't crash with unexpected AttributeError
  on classes defined in C without __module__.

* Issue #20356: inspect.signature formatting uses '/' to separate
  positional-only parameters from others.

* Issue #20223: inspect.signature now supports methods defined with
  functools.partialmethods.

* Issue #19456: ntpath.join() now joins relative paths correctly
  when a drive is present.

* Issue #19077: tempfile.TemporaryDirectory cleanup no longer fails
  when called during shutdown.  Emitting resource warning in __del__
  no longer fails. Original patch by Antoine Pitrou.

* Issue #20394: Silence Coverity warning in audioop module.

* Issue #20367: Fix behavior of concurrent.futures.as_completed()
  for duplicate arguments.  Patch by Glenn Langford.

* Issue #8260: The read(), readline() and readlines() methods of
  codecs.StreamReader returned incomplete data when were called after
  readline() or read(size).  Based on patch by Amaury Forgeot d'Arc.

* Issue #20105: the codec exception chaining now correctly sets the
  traceback of the original exception as its __traceback__ attribute.

* Issue #17481: inspect.getfullargspec() now uses
  inspect.signature() API.

* Issue #15304: concurrent.futures.wait() can block forever even if
  Futures have completed. Patch by Glenn Langford.

* Issue #14455: plistlib: fix serializing integers in the range of
  an unsigned long long but outside of the range of signed long long
  for binary plist files.


IDLE
----

* Issue #20406: Use Python application icons for Idle window title
  bars. Patch mostly by Serhiy Storchaka.

* Update the python.gif icon for the Idle classbrowser and
  pathbowser from the old green snake to the new blue and yellow
  snakes.

* Issue #17721: Remove non-functional configuration dialog help
  button until we make it actually gives some help when clicked. Patch
  by Guilherme Simões.


Tests
-----

* Issue #20532: Tests which use _testcapi now are marked as CPython
  only.

* Issue #19920: Added tests for TarFile.list().  Based on patch by
  Vajrasky Kok.

* Issue #19990: Added tests for the imghdr module.  Based on patch
  by Claudiu Popa.

* Issue #20474: Fix test_socket "unexpected success" failures on OS
  X 10.7+.


Tools/Demos
-----------

* Issue #20530: Argument Clinic's signature format has been revised
  again. The new syntax is highly human readable while still
  preventing false positives.  The syntax also extends Python syntax
  to denote "self" and positional-only parameters, allowing
  inspect.Signature objects to be totally accurate for all supported
  builtins in Python 3.4.

* Issue #20456: Argument Clinic now observes the C preprocessor
  conditional compilation statements of the C files it parses.  When a
  Clinic block is inside a conditional code, it adjusts its output to
  match, including automatically generating an empty methoddef macro.

* Issue #20456: Cloned functions in Argument Clinic now use the
  correct name, not the name of the function they were cloned from,
  for text strings inside generated code.

* Issue #20456: Fixed Argument Clinic's test suite and "--
  converters" feature.

* Issue #20456: Argument Clinic now allows specifying different
  names for a parameter in Python and C, using "as" on the parameter
  line.

* Issue #20326: Argument Clinic now uses a simple, unique signature
  to annotate text signatures in docstrings, resulting in fewer false
  positives.  "self" parameters are also explicitly marked, allowing
  inspect.Signature() to authoritatively detect (and skip) said
  parameters.

* Issue #20326: Argument Clinic now generates separate checksums for
  the input and output sections of the block, allowing external tools
  to verify that the input has not changed (and thus the output is not
  out-of-date).


Build
-----

* Issue #20465: Update SQLite shipped with OS X installer to 3.8.3.


C-API
-----

* Issue #20517: Added new functions allowing OSError exceptions to
  reference two filenames instead of one:
  PyErr_SetFromErrnoWithFilenameObjects() and
  PyErr_SetExcFromWindowsErrWithFilenameObjects().


Documentation
-------------

* Issue #20488: Change wording to say importlib is *the*
  implementation of import instead of just *an* implementation.

* Issue #6386: Clarify in the tutorial that specifying a symlink to
  execute means the directory containing the executed script and not
  the symlink is added to sys.path.


Python 3.4.0 Beta 3
===================

Release date: 2014-01-26


Core and Builtins
-----------------

* Issue #20189: Four additional builtin types (PyTypeObject,
  PyMethodDescr_Type, _PyMethodWrapper_Type, and PyWrapperDescr_Type)
  have been modified to provide introspection information for
  builtins.

* Issue #17825: Cursor "^" is correctly positioned for SyntaxError
  and IndentationError.

* Issue #2382: SyntaxError cursor "^" is now written at correct
  position in most cases when multibyte characters are in line (before
  "^").  This still not works correctly with wide East Asian
  characters.

* Issue #18960: The first line of Python script could be executed
  twice when the source encoding was specified on the second line. Now
  the source encoding declaration on the second line isn't effective
  if the first line contains anything except a comment. 'python -x'
  works now again with files with the source encoding declarations,
  and can be used to make Python batch files on Windows.


Library
-------

* asyncio: Various improvements and small changes not all covered by
  issues listed below.  E.g. wait_for() now cancels the inner task if
  the timeout occcurs; tweaked the set of exported symbols; renamed
  Empty/Full to QueueEmpty/QueueFull; "with (yield from lock)" now
  uses a separate context manager; readexactly() raises if not enough
  data was read; PTY support tweaks.

* Issue #20311: asyncio: Add a granularity attribute to
  BaseEventLoop: maximum between the resolution of the
  BaseEventLoop.time() method and the resolution of the selector. The
  granuarility is used in the scheduler to round time and deadline.

* Issue #20311: selectors: Add a resolution attribute to
  BaseSelector.

* Issue #20189: unittest.mock now no longer assumes that any object
  for which it could get an inspect.Signature is a callable written in
  Python. Fix courtesy of Michael Foord.

* Issue #20317: ExitStack.__exit__ could create a self-referential
  loop if an exception raised by a cleanup operation already had its
  context set correctly (for example, by the @contextmanager
  decorator). The infinite loop this caused is now avoided by checking
  if the expected context is already set before trying to fix it.

* Issue #20374: Fix build with GNU readline >= 6.3.

* Issue #20262: Warnings are raised now when duplicate names are
  added in the ZIP file or too long ZIP file comment is truncated.

* Issue #20165: The unittest module no longer considers tests marked
  with @expectedFailure successful if they pass.

* Issue #18574: Added missing newline in 100-Continue reply from
  http.server.BaseHTTPRequestHandler. Patch by Nikolaus Rath.

* Issue #20270: urllib.urlparse now supports empty ports.

* Issue #20243: TarFile no longer raise ReadError when opened in
  write mode.

* Issue #20238: TarFile opened with external fileobj and "w:gz" mode
  didn't write complete output on close.

* Issue #20245: The open functions in the tarfile module now
  correctly handle empty mode.

* Issue #20242: Fixed basicConfig() format strings for the
  alternative formatting styles. Thanks to kespindler for the bug
  report and patch.

* Issue #20246: Fix buffer overflow in socket.recvfrom_into.

* Issues #20206 and #5803: Fix edge case in email.quoprimime.encode
  where it truncated lines ending in a character needing encoding but
  no newline by using a more efficient algorithm that doesn't have the
  bug.

* Issue #19082: Working xmlrpc.server and xmlrpc.client examples.
  Both in modules and in documentation. Initial patch contributed by
  Vajrasky Kok.

* Issue #20138: The wsgiref.application_uri() and
  wsgiref.request_uri() functions now conform to PEP 3333 when handle
  non-ASCII URLs.

* Issue #19097: Raise the correct Exception when cgi.FieldStorage is
  given an invalid fileobj.

* Issue #20152: Ported Python/import.c over to Argument Clinic.

* Issue #13107: argparse and optparse no longer raises an exception
  when output a help on environment with too small COLUMNS.  Based on
  patch by Elazar Gershuni.

* Issue #20207: Always disable SSLv2 except when PROTOCOL_SSLv2 is
  explicitly asked for.

* Issue #18960: The tokenize module now ignore the source encoding
  declaration on the second line if the first line contains anything
  except a comment.

* Issue #20078: Reading malformed zipfiles no longer hangs with 100%
  CPU consumption.

* Issue #20113: os.readv() and os.writev() now raise an OSError
  exception on error instead of returning -1.

* Issue #19719: Make importlib.abc.MetaPathFinder.find_module(),
  PathEntryFinder.find_loader(), and Loader.load_module() use PEP 451
  APIs to help with backwards-compatibility.

* Issue #20144: inspect.Signature now supports parsing simple
  symbolic constants as parameter default values in
  __text_signature__.

* Issue #20072: Fixed multiple errors in tkinter with wantobjects is
  False.

* Issue #20229: Avoid plistlib deprecation warning in
  platform.mac_ver().

* Issue #14455: Fix some problems with the new binary plist support
  in plistlib.


IDLE
----

* Issue #17390: Add Python version to Idle editor window title bar.
  Original patches by Edmond Burnett and Kent Johnson.

* Issue #18960: IDLE now ignores the source encoding declaration on
  the second line if the first line contains anything except a
  comment.


Tests
-----

* Issue #20358: Tests for curses.window.overlay and
  curses.window.overwrite no longer specify min{row,col} >
  max{row,col}.

* Issue #19804: The test_find_mac test in test_uuid is now skipped
  if the ifconfig executable is not available.

* Issue #19886: Use better estimated memory requirements for bigmem
  tests.


Tools/Demos
-----------

* Issue #20390: Argument Clinic's "file" output preset now defaults
  to "{dirname}/clinic/{basename}.h".

* Issue #20390: Argument Clinic's "class" directive syntax has been
  extended with two new required arguments: "typedef" and
  "type_object".

* Issue #20390: Argument Clinic: If __new__ or __init__ functions
  didn't use kwargs (or args), the PyArg_NoKeywords (or
  PyArg_NoPositional) calls generated are only run when the type
  object is an exact match.

* Issue #20390: Argument Clinic now fails if you have required
  parameters after optional parameters.

* Issue #20390: Argument Clinic converters now have a new template
  they can inject code into: "modifiers".  Code put there is run in
  the parsing function after argument parsing but before the call to
  the impl.

* Issue #20376: Argument Clinic now escapes backslashes in
  docstrings.

* Issue #20381: Argument Clinic now sanity checks the default
  argument when c_default is also specified, providing a nice failure
  message for disallowed values.

* Issue #20189: Argument Clinic now ensures that parser functions
  for __new__ are always of type newfunc, the type of the tp_new slot.
  Similarly, parser functions for __init__ are now always of type
  initproc, the type of tp_init.

* Issue #20189: Argument Clinic now suppresses the docstring for
  __new__ and __init__ functions if no docstring is provided in the
  input.

* Issue #20189: Argument Clinic now suppresses the "self" parameter
  in the impl for @staticmethod functions.

* Issue #20294: Argument Clinic now supports argument parsing for
  __new__ and __init__ functions.

* Issue #20299: Argument Clinic custom converters may now change the
  default value of c_default and py_default with a class member.

* Issue #20287: Argument Clinic's output is now configurable,
  allowing delaying its output or even redirecting it to a separate
  file.

* Issue #20226: Argument Clinic now permits simple expressions (e.g.
  "sys.maxsize - 1") as default values for parameters.

* Issue #19936: Added executable bits or shebang lines to Python
  scripts which requires them.  Disable executable bits and shebang
  lines in test and benchmark files in order to prevent using a random
  system python, and in source files of modules which don't provide
  command line interface.  Fixed shebang lines in the unittestgui and
  checkpip scripts.

* Issue #20268: Argument Clinic now supports cloning the parameters
  and return converter of existing functions.

* Issue #20228: Argument Clinic now has special support for class
  special methods.

* Issue #20214: Fixed a number of small issues and documentation
  errors in Argument Clinic (see issue for details).

* Issue #20196: Fixed a bug where Argument Clinic did not generate
  correct parsing code for functions with positional-only parameters
  where all arguments are optional.

* Issue #18960: 2to3 and the findnocoding.py script now ignore the
  source encoding declaration on the second line if the first line
  contains anything except a comment.

* Issue #19723: The marker comments Argument Clinic uses have been
  changed to improve readability.

* Issue #20157: When Argument Clinic renames a parameter because its
  name collides with a C keyword, it no longer exposes that rename to
  PyArg_Parse.

* Issue #20141: Improved Argument Clinic's support for the
  PyArg_Parse "O!" format unit.

* Issue #20144: Argument Clinic now supports simple symbolic
  constants as parameter default values.

* Issue #20143: The line numbers reported in Argument Clinic errors
  are now more accurate.

* Issue #20142: Py_buffer variables generated by Argument Clinic are
  now initialized with a default value.


Build
-----

* Issue #12837: Silence a tautological comparison warning on OS X
  under Clang in socketmodule.c.


Python 3.4.0 Beta 2
===================

Release date: 2014-01-05


Core and Builtins
-----------------

* Issue #17432: Drop UCS2 from names of Unicode functions in
  python3.def.

* Issue #19526: Exclude all new API from the stable ABI. Exceptions
  can be made if a need is demonstrated.

* Issue #19969: PyBytes_FromFormatV() now raises an OverflowError if
  "%c" argument is not in range [0; 255].

* Issue #19995: %c, %o, %x, and %X now issue a DeprecationWarning on
  non-integer input; reworded docs to clarify that an integer type
  should define both __int__ and __index__.

* Issue #19787: PyThread_set_key_value() now always set the value.
  In Python 3.3, the function did nothing if the key already exists
  (if the current value is a non-NULL pointer).

* Issue #14432: Remove the thread state field from the frame
  structure. Fix a crash when a generator is created in a C thread
  that is destroyed while the generator is still used. The issue was
  that a generator contains a frame, and the frame kept a reference to
  the Python state of the destroyed C thread. The crash occurs when a
  trace function is setup.

* Issue #19576: PyGILState_Ensure() now initializes threads. At
  startup, Python has no concrete GIL. If PyGILState_Ensure() is
  called from a new thread for the first time and PyEval_InitThreads()
  was not called yet, a GIL needs to be created.

* Issue #17576: Deprecation warning emitted now when __int__() or
  __index__() return not int instance.

* Issue #19932: Fix typo in import.h, missing whitespaces in
  function prototypes.

* Issue #19736: Add module-level statvfs constants defined for
  GNU/glibc based systems.

* Issue #20097: Fix bad use of "self" in importlib's
  WindowsRegistryFinder.

* Issue #19729: In str.format(), fix recursive expansion in format
  spec.

* Issue #19638: Fix possible crash / undefined behaviour from huge
  (more than 2 billion characters) input strings in _Py_dg_strtod.


Library
-------

* Issue #20154: Deadlock in asyncio.StreamReader.readexactly().

* Issue #16113: Remove sha3 module again.

* Issue #20111: pathlib.Path.with_suffix() now sanity checks the
  given suffix.

* Fix breakage in TestSuite.countTestCases() introduced by issue
  #11798.

* Issue #20108: Avoid parameter name clash in inspect.getcallargs().

* Issue #19918: Fix PurePath.relative_to() under Windows.

* Issue #19422: Explicitly disallow non-SOCK_STREAM sockets in the
  ssl module, rather than silently let them emit clear text data.

* Issue #20046: Locale alias table no longer contains entities which
  can be calculated.  Generalized support of the euro modifier.

* Issue #20027: Fixed locale aliases for devanagari locales.

* Issue #20067: Tkinter variables now work when wantobjects is
  false.

* Issue #19020: Tkinter now uses splitlist() instead of split() in
  configure methods.

* Issue #19744: ensurepip now provides a better error message when
  Python is built without SSL/TLS support (pip currently requires that
  support to run, even if only operating with local wheel files)

* Issue #19734: ensurepip now ignores all pip environment variables
  to avoid odd behaviour based on user configuration settings

* Fix TypeError on "setup.py upload --show-response".

* Issue #20045: Fix "setup.py register --list-classifiers".

* Issue #18879: When a method is looked up on a temporary file,
  avoid closing the file before the method is possibly called.

* Issue #20037: Avoid crashes when opening a text file late at
  interpreter shutdown.

* Issue #19967: Thanks to the PEP 442, asyncio.Future now uses a
  destructor to log uncaught exceptions, instead of the dedicated
  _TracebackLogger class.

* Added a Task.current_task() class method to asyncio.

* Issue #19850: Set SA_RESTART in asyncio when registering a signal
  handler to limit EINTR occurrences.

* Implemented write flow control in asyncio for proactor event loop
  (Windows).

* Change write buffer in asyncio use to avoid O(N**2) behavior.
  Make write()/sendto() accept bytearray/memoryview.

* Issue #20034: Updated alias mapping to most recent locale.alias
  file from X.org distribution using makelocalealias.py.

* Issue #5815: Fixed support for locales with modifiers.  Fixed
  support for locale encodings with hyphens.

* Issue #20026: Fix the sqlite module to handle correctly invalid
  isolation level (wrong type).

* Issue #18829: csv.Dialect() now checks type for delimiter,
  escapechar and quotechar fields.  Original patch by Vajrasky Kok.

* Issue #19855: uuid.getnode() on Unix now looks on the PATH for the
  executables used to find the mac address, with /sbin and /usr/sbin
  as fallbacks.

* Issue #20007: HTTPResponse.read(0) no more prematurely closes
  connection. Original patch by Simon Sapin.

* Issue #19946: multiprocessing now uses runpy to initialize
  __main__ in child processes when necessary, allowing it to correctly
  handle scripts without suffixes and submodules that use explicit
  relative imports or otherwise rely on parent modules being correctly
  imported prior to execution.

* Issue #19921: When Path.mkdir() is called with parents=True, any
  missing parent is created with the default permissions, ignoring the
  mode argument (mimicking the POSIX "mkdir -p" command).

* Issue #19887: Improve the Path.resolve() algorithm to support
  certain symlink chains.

* Issue #19912: Fixed numerous bugs in ntpath.splitunc().

* Issue #19911: ntpath.splitdrive() now correctly processes the 'İ'
  character (U+0130, LATIN CAPITAL LETTER I WITH DOT ABOVE).

* Issue #19532: python -m compileall with no filename/directory
  arguments now respects the -f and -q flags instead of ignoring them.

* Issue #19623: Fixed writing to unseekable files in the aifc
  module.

* Issue #19946: multiprocessing.spawn now raises ImportError when
  the module to be used as the main module cannot be imported.

* Issue #17919: select.poll.register() again works with
  poll.POLLNVAL on AIX. Fixed integer overflow in the eventmask
  parameter.

* Issue #19063: if a Charset's body_encoding was set to None, the
  email package would generate a message claiming the Content-
  Transfer-Encoding was 7bit, and produce garbage output for the
  content.  This now works. A couple of other set_payload mishandlings
  of non-ASCII are also fixed. In addition, calling set_payload with a
  string argument without specifying a charset now raises an error
  (this is a new error in 3.4).

* Issue #15475: Add __sizeof__ implementations for itertools
  objects.

* Issue #19944: Fix importlib.find_spec() so it imports parents as
  needed and move the function to importlib.util.

* Issue #19880: Fix a reference leak in unittest.TestCase.
  Explicitly break reference cycles between frames and the _Outcome
  instance.

* Issue #17429: platform.linux_distribution() now decodes files from
  the UTF-8 encoding with the surrogateescape error handler, instead
  of decoding from the locale encoding in strict mode. It fixes the
  function on Fedora 19 which is probably the first major distribution
  release with a non-ASCII name. Patch written by Toshio Kuratomi.

* Issue #19343: Expose FreeBSD-specific APIs in resource module.
  Original patch by Koobs.

* Issue #19929: Call os.read with 32768 within
  subprocess.Popen.communicate rather than 4096 for efficiency.  A
  microbenchmark shows Linux and OS X both using ~50% less cpu time
  this way.

* Issue #19506: Use a memoryview to avoid a data copy when piping
  data to stdin within subprocess.Popen.communicate.  5-10% less cpu
  usage.

* Issue #19876: selectors unregister() no longer raises ValueError
  or OSError if the FD is closed (as long as it was registered).

* Issue #19908: pathlib now joins relative Windows paths correctly
  when a drive is present.  Original patch by Antoine Pitrou.

* Issue #19296: Silence compiler warning in dbm_open

* Issue #6784: Strings from Python 2 can now be unpickled as bytes
  objects by setting the encoding argument of Unpickler to be 'bytes'.
  Initial patch by Merlijn van Deen.

* Issue #19839: Fix regression in bz2 module's handling of non-bzip2
  data at EOF, and analogous bug in lzma module.

* Issue #19881: Fix pickling bug where cpickle would emit bad pickle
  data for large bytes string (i.e., with size greater than 2**32-1).

* Issue #19138: doctest's IGNORE_EXCEPTION_DETAIL now allows a match
  when no exception detail exists (no colon following the exception's
  name, or a colon does follow but no text follows the colon).

* Issue #19927: Add __eq__ to path-based loaders in importlib.

* Issue #19827: On UNIX, setblocking() and settimeout() methods of
  socket.socket can now avoid a second syscall if the ioctl() function
  can be used, or if the non-blocking flag of the socket is unchanged.

* Issue #19785: smtplib now supports SSLContext.check_hostname and
  server name indication for TLS/SSL connections.

* Issue #19784: poplib now supports SSLContext.check_hostname and
  server name indication for TLS/SSL connections.

* Issue #19783: nntplib now supports SSLContext.check_hostname and
  server name indication for TLS/SSL connections.

* Issue #19782: imaplib now supports SSLContext.check_hostname and
  server name indication for TLS/SSL connections.

* Issue #20123: Fix pydoc.synopsis() for "binary" modules.

* Issue #19834: Support unpickling of exceptions pickled by Python
  2.

* Issue #19781: ftplib now supports SSLContext.check_hostname and
  server name indication for TLS/SSL connections.

* Issue #19509: Add SSLContext.check_hostname to match the peer's
  certificate with server_hostname on handshake.

* Issue #15798: Fixed subprocess.Popen() to no longer fail if file
  descriptor 0, 1 or 2 is closed.

* Issue #17897: Optimized unpickle prefetching.

* Issue #3693: Make the error message more helpful when the
  array.array() constructor is given a str. Move the array module
  typecode documentation to the docstring of the constructor.

* Issue #19088: Fixed incorrect caching of the copyreg module in
  object.__reduce__() and object.__reduce_ex__().

* Issue #19698: Removed exec_module() methods from
  importlib.machinery.BuiltinImporter and ExtensionFileLoader.

* Issue #18864: Added a setter for ModuleSpec.has_location.

* Fixed _pickle.Unpickler to not fail when loading empty strings as
  persistent IDs.

* Issue #11480: Fixed copy.copy to work with classes with custom
  metaclasses. Patch by Daniel Urban.

* Issue #6477: Added support for pickling the types of built-in
  singletons (i.e., Ellipsis, NotImplemented, None).

* Issue #19713: Add remaining PEP 451-related deprecations and move
  away from using find_module/find_loaer/load_module.

* Issue #19708: Update pkgutil to use the new importer APIs.

* Issue #19703: Update pydoc to use the new importer APIs.

* Issue #19851: Fixed a regression in reloading sub-modules.

* ssl.create_default_context() sets OP_NO_COMPRESSION to prevent
  CRIME.

* Issue #19802: Add socket.SO_PRIORITY.

* Issue #11508: Fixed uuid.getnode() and uuid.uuid1() on environment
  with virtual interface.  Original patch by Kent Frazier.

* Issue #11489: JSON decoder now accepts lone surrogates.

* Issue #19545: Avoid chained exceptions while passing stray % to
  time.strptime().  Initial patch by Claudiu Popa.


IDLE
----

* Issue #20058: sys.stdin.readline() in IDLE now always returns only
  one line.

* Issue #19481: print() of string subclass instance in IDLE no
  longer hangs.

* Issue #18270: Prevent possible IDLE AttributeError on OS X when no
  initial shell window is present.


Tests
-----

* Issue #20055: Fix test_shutil under Windows with symlink
  privileges held. Patch by Vajrasky Kok.

* Issue #20070: Don't run test_urllib2net when network resources are
  not enabled.

* Issue #19938: Re-enabled test_bug_1333982 in test_dis, which had
  been disabled since 3.0 due to the changes in listcomp handling.

* Issue #19320: test_tcl no longer fails when wantobjects is false.

* Issue #19919: Fix flaky SSL test. connect_ex() sometimes returns
  EWOULDBLOCK on Windows or VMs hosted on Windows.

* Issue #19912: Added tests for ntpath.splitunc().

* Issue #19828: Fixed test_site when the whole suite is run with -S.

* Issue #19928: Implemented a test for repr() of cell objects.

* Issue #19535: Fixed test_docxmlrpc, test_functools, test_inspect,
  and test_statistics when python is run with -OO.

* Issue #19926: Removed unneeded test_main from
  test_abstract_numbers. Patch by Vajrasky Kok.

* Issue #19572: More skipped tests explicitly marked as skipped.

* Issue #19595, #19987: Re-enabled a long-disabled test in
  test_winsound.

* Issue #19588: Fixed tests in test_random that were silently
  skipped most of the time.  Patch by Julian Gindi.


Build
-----

* Issue #19728: Enable pip installation by default on Windows.

* Issue #16136: Remove VMS support

* Issue #18215: Add script Tools/ssl/test_multiple_versions.py to
  compile and run Python's unit tests with multiple versions of
  OpenSSL.

* Issue #19922: define _INCLUDE__STDC_A1_SOURCE in HP-UX to include
  mbstate_t for mbrtowc().

* Issue #19788: kill_python(_d).exe is now run as a PreBuildEvent on
  the pythoncore sub-project.  This should prevent build errors due a
  previous build's python(_d).exe still running.


Documentation
-------------

* Issue #20265: Updated some parts of the Using Windows document.

* Issue #20266: Updated some parts of the Windows FAQ.

* Issue #20255: Updated the about and bugs pages.

* Issue #20253: Fixed a typo in the ipaddress docs that advertised
  an illegal attribute name.  Found by INADA Naoki.

* Issue #18840: Introduce the json module in the tutorial, and de-
  emphasize the pickle module.

* Issue #19845: Updated the Compiling Python on Windows section.

* Issue #19795: Improved markup of True/False constants.


Tools/Demos
-----------

* Issue #19659: Added documentation for Argument Clinic.

* Issue #19976: Argument Clinic METH_NOARGS functions now always
  take two parameters.


Python 3.4.0 Beta 1
===================

Release date: 2013-11-24


Core and Builtins
-----------------

* Use the repr of a module name in more places in import, especially
  exceptions.

* Issue #19619: str.encode, bytes.decode and bytearray.decode now
  use an internal API to throw LookupError for known non-text
  encodings, rather than attempting the encoding or decoding operation
  and then throwing a TypeError for an unexpected output type. (The
  latter mechanism remains in place for third party non-text
  encodings)

* Issue #19183: Implement PEP 456 'secure and interchangeable hash
  algorithm'. Python now uses SipHash24 on all major platforms.

* Issue #12892: The utf-16* and utf-32* encoders no longer allow
  surrogate code points (U+D800-U+DFFF) to be encoded.  The utf-32*
  decoders no longer decode byte sequences that correspond to
  surrogate code points.  The surrogatepass error handler now works
  with the utf-16* and utf-32* codecs.  Based on patches by Victor
  Stinner and Kang-Hao (Kenny) Lu.

* Issue #17806: Added keyword-argument support for "tabsize" to
  str/bytes.expandtabs().

* Issue #17828: Output type errors in str.encode(), bytes.decode()
  and bytearray.decode() now direct users to codecs.encode() or
  codecs.decode() as appropriate.

* Issue #17828: The interpreter now attempts to chain errors that
  occur in codec processing with a replacement exception of the same
  type that includes the codec name in the error message. It ensures
  it only does this when the creation of the replacement exception
  won't lose any information.

* Issue #19466: Clear the frames of daemon threads earlier during
  the Python shutdown to call objects destructors. So "unclosed file"
  resource warnings are now corretly emitted for daemon threads.

* Issue #19514: Deduplicate some _Py_IDENTIFIER declarations. Patch
  by Andrei Dorian Duma.

* Issue #17936: Fix O(n**2) behaviour when adding or removing many
  subclasses of a given type.

* Issue #19428: zipimport now handles errors when reading truncated
  or invalid ZIP archive.

* Issue #18408: Add a new PyFrame_FastToLocalsWithError() function
  to handle exceptions when merging fast locals into f_locals of a
  frame. PyEval_GetLocals() now raises an exception and return NULL on
  failure.

* Issue #19369: Optimized the usage of __length_hint__().

* Issue #18603: Ensure that PyOS_mystricmp and PyOS_mystrnicmp are
  in the Python executable and not removed by the linker's optimizer.

* Issue #19306: Add extra hints to the faulthandler module's stack
  dumps that these are "upside down".


Library
-------

* Issue #3158: doctest can now find doctests in functions and
  methods written in C.

* Issue #13477: Added command line interface to the tarfile module.
  Original patch by Berker Peksag.

* Issue #19674: inspect.signature() now produces a correct signature
  for some builtins.

* Issue #19722: Added opcode.stack_effect(), which computes the
  stack effect of bytecode instructions.

* Issue #19735: Implement private function
  ssl._create_stdlib_context() to create SSLContext objects in
  Python's stdlib module. It provides a single configuration point and
  makes use of SSLContext.load_default_certs().

* Issue #16203: Add re.fullmatch() function and regex.fullmatch()
  method, which anchor the pattern at both ends of the string to
  match. Original patch by Matthew Barnett.

* Issue #13592: Improved the repr for regular expression pattern
  objects. Based on patch by Hugo Lopes Tavares.

* Issue #19641: Added the audioop.byteswap() function to convert
  big- endian samples to little-endian and vice versa.

* Issue #15204: Deprecated the 'U' mode in file-like objects.

* Issue #17810: Implement PEP 3154, pickle protocol 4.

* Issue #19668: Added support for the cp1125 encoding.

* Issue #19689: Add ssl.create_default_context() factory function.
  It creates a new SSLContext object with secure default settings.

* Issue #19727: os.utime(..., None) is now potentially more precise
  under Windows.

* Issue #17201: ZIP64 extensions now are enabled by default.  Patch
  by William Mallard.

* Issue #19292: Add SSLContext.load_default_certs() to load default
  root CA certificates from default stores or system stores. By
  default the method loads CA certs for authentication of server
  certs.

* Issue #19673: Add pathlib to the stdlib as a provisional module
  (PEP 428).

* Issue #16596: pdb in a generator now properly skips over yield and
  yield from rather than stepping out of the generator into its
  caller.  (This is essential for stepping through asyncio
  coroutines.)

* Issue #17916: Added dis.Bytecode.from_traceback() and
  dis.Bytecode.current_offset to easily display "current instruction"
  markers in the new disassembly API (Patch by Claudiu Popa).

* Issue #19552: venv now supports bootstrapping pip into virtual
  environments

* Issue #17134: Finalize interface to Windows' certificate store.
  Cert and CRL enumeration are now two functions. enum_certificates()
  also returns purpose flags as set of OIDs.

* Issue #19555: Restore sysconfig.get_config_var('SO'), (and the
  distutils equivalent) with a DeprecationWarning pointing people at
  $EXT_SUFFIX.

* Issue #8813: Add SSLContext.verify_flags to change the
  verification flags of the context in order to enable certification
  revocation list (CRL) checks or strict X509 rules.

* Issue #18294: Fix the zlib module to make it 64-bit safe.

* Issue #19682: Fix compatibility issue with old version of OpenSSL
  that was introduced by Issue #18379.

* Issue #14455: plistlib now supports binary plists and has an
  updated API.

* Issue #19633: Fixed writing not compressed 16- and 32-bit wave
  files on big-endian platforms.

* Issue #18379: SSLSocket.getpeercert() returns CA issuer AIA
  fields, OCSP and CRL distribution points.

* Issue #18138: Implement cadata argument of
  SSLContext.load_verify_location() to load CA certificates and CRL
  from memory. It supports PEM and DER encoded strings.

* Issue #18775: Add name and block_size attribute to HMAC object.
  They now provide the same API elements as non-keyed cryptographic
  hash functions.

* Issue #17276: MD5 as default digestmod for HMAC is deprecated. The
  HMAC module supports digestmod names, e.g. hmac.HMAC('sha1').

* Issue #19449: in csv's writerow, handle non-string keys when
  generating the error message that certain keys are not in the
  'fieldnames' list.

* Issue #13633: Added a new convert_charrefs keyword arg to
  HTMLParser that, when True, automatically converts all character
  references.

* Issue #2927: Added the unescape() function to the html module.

* Issue #8402: Added the escape() function to the glob module.

* Issue #17618: Add Base85 and Ascii85 encoding/decoding to the
  base64 module.

* Issue #19634: time.strftime("%y") now raises a ValueError on AIX
  when given a year before 1900.

* Fix test.support.bind_port() to not cause an error when Python was
  compiled on a system with SO_REUSEPORT defined in the headers but
  run on a system with an OS kernel that does not support that
  reasonably new socket option.

* Fix compilation error under gcc of the ctypes module bundled
  libffi for arm.

* Issue #19448: Add private API to SSL module to lookup ASN.1
  objects by OID, NID, short name and long name.

* Issue #19282: dbm.open now supports the context management
  protocol. (Inital patch by Claudiu Popa)

* Issue #8311: Added support for writing any bytes-like objects in
  the aifc, sunau, and wave modules.

* Issue #5202: Added support for unseekable files in the wave
  module.

* Issue #19544 and Issue #1180: Restore global option to ignore
  ~/.pydistutils.cfg in Distutils, accidentally removed in backout of
  distutils2 changes.

* Issue #19523: Closed FileHandler leak which occurred when delay
  was set.

* Issue #19544 and Issue #6516: Restore support for --user and
  --group parameters to sdist command accidentally rolled back as part
  of the distutils2 rollback.

* Issue #13674: Prevented time.strftime from crashing on Windows
  when given a year before 1900 and a format of %y.

* Issue #19406: implementation of the ensurepip module (part of PEP
  453). Patch by Donald Stufft and Nick Coghlan.

* Issue #19544 and Issue #6286: Restore use of urllib over http
  allowing use of http_proxy for Distutils upload command, a feature
  accidentally lost in the rollback of distutils2.

* Issue #19544 and Issue #7457: Restore the read_pkg_file method to
  distutils.dist.DistributionMetadata accidentally removed in the undo
  of distutils2.

* Issue #16685: Added support for any bytes-like objects in the
  audioop module. Removed support for strings.

* Issue #7171: Add Windows implementation of "inet_ntop" and
  "inet_pton" to socket module. Patch by Atsuo Ishimoto.

* Issue #19261: Added support for writing 24-bit samples in the
  sunau module.

* Issue #1097797: Added CP273 encoding, used on IBM mainframes in
  Germany and Austria.  Mapping provided by Michael Bierenfeld.

* Issue #1575020: Fixed support of 24-bit wave files on big-endian
  platforms.

* Issue #19378: Fixed a number of cases in the dis module where the
  new "file" parameter was not being honoured correctly

* Issue #19378: Removed the "dis.Bytecode.show_info" method

* Issue #19378: Renamed the "dis.Bytecode.display_code" method to
  "dis.Bytecode.dis" and converted it to returning a string rather
  than printing output.

* Issue #19378: the "line_offset" parameter in the new
  "dis.get_instructions" API has been renamed to "first_line" (and the
  default value and usage changed accordingly). This should reduce
  confusion with the more common use of "offset" in the dis docs to
  refer to bytecode offsets.

* Issue #18678: Corrected spwd struct member names in spwd module:
  sp_nam->sp_namp, and sp_pwd->sp_pwdp.  The old names are kept as
  extra structseq members, for backward compatibility.

* Issue #6157: Fixed tkinter.Text.debug().  tkinter.Text.bbox() now
  raises TypeError instead of TclError on wrong number of arguments.
  Original patch by Guilherme Polo.

* Issue #10197: Rework subprocess.get[status]output to use
  subprocess functionality and thus to work on Windows. Patch by Nick
  Coghlan

* Issue #6160: The bbox() method of tkinter.Spinbox now returns a
  tuple of integers instead of a string.  Based on patch by Guilherme
  Polo.

* Issue #19403: contextlib.redirect_stdout is now reentrant

* Issue #19286: Directories in "package_data" are no longer added to
  the filelist, preventing failure outlined in the ticket.

* Issue #19480: HTMLParser now accepts all valid start-tag names as
  defined by the HTML5 standard.

* Issue #15114: The html.parser module now raises a
  DeprecationWarning when the strict argument of HTMLParser or the
  HTMLParser.error method are used.

* Issue #19410: Undo the special-casing removal of '' for
  importlib.machinery.FileFinder.

* Issue #19424: Fix the warnings module to accept filename
  containing surrogate characters.

* Issue #19435: Fix directory traversal attack on
  CGIHttpRequestHandler.

* Issue #19227: Remove pthread_atfork() handler. The handler was
  added to solve #18747 but has caused issues.

* Issue #19420: Fix reference leak in module initalization code of
  _hashopenssl.c

* Issue #19329: Optimized compiling charsets in regular expressions.

* Issue #19227: Try to fix deadlocks caused by re-seeding then
  OpenSSL pseudo-random number generator on fork().

* Issue #16037: HTTPMessage.readheaders() raises an HTTPException
  when more than 100 headers are read.  Adapted from patch by Jyrki
  Pulliainen.

* Issue #16040: CVE-2013-1752: nntplib: Limit maximum line lengths
  to 2048 to prevent readline() calls from consuming too much memory.
  Patch by Jyrki Pulliainen.

* Issue #16041: CVE-2013-1752: poplib: Limit maximum line lengths to
  2048 to prevent readline() calls from consuming too much memory.
  Patch by Jyrki Pulliainen.

* Issue #17997: Change behavior of "ssl.match_hostname()" to follow
  RFC 6125, for security reasons.  It now doesn't match multiple
  wildcards nor wildcards inside IDN fragments.

* Issue #16039: CVE-2013-1752: Change use of readline in imaplib
  module to limit line length.  Patch by Emil Lind.

* Issue #19330: the unnecessary wrapper functions have been removed
  from the implementations of the new contextlib.redirect_stdout and
  contextlib.suppress context managers, which also ensures they
  provide reasonable help() output on instances

* Issue #19393: Fix symtable.symtable function to not be confused
  when there are functions or classes named "top".

* Issue #18685: Restore re performance to pre-PEP 393 levels.

* Issue #19339: telnetlib module is now using time.monotonic() when
  available to compute timeout.

* Issue #19399: fix sporadic test_subprocess failure.

* Issue #13234: Fix os.listdir to work with extended paths on
  Windows. Patch by Santoso Wijaya.

* Issue #19375: The site module adding a "site-python" directory to
  sys.path, if it exists, is now deprecated.

* Issue #19379: Lazily import linecache in the warnings module, to
  make startup with warnings faster until a warning gets printed.

* Issue #19288: Fixed the "in" operator of dbm.gnu databases for
  string argument.  Original patch by Arfrever Frehtes Taifersar
  Arahesis.

* Issue #19287: Fixed the "in" operator of dbm.ndbm databases for
  string argument.  Original patch by Arfrever Frehtes Taifersar
  Arahesis.

* Issue #19327: Fixed the working of regular expressions with too
  big charset.

* Issue #17400: New 'is_global' attribute for ipaddress to tell if
  an address is allocated by IANA for global or private networks.

* Issue #19350: Increasing the test coverage of macurl2path. Patch
  by Colin Williams.

* Issue #19365: Optimized the parsing of long replacement string in
  re.sub*() functions.

* Issue #19352: Fix unittest discovery when a module can be reached
  through several paths (e.g. under Debian/Ubuntu with virtualenv).

* Issue #15207: Fix mimetypes to read from correct part of Windows
  registry Original patch by Dave Chambers

* Issue #16595: Add prlimit() to resource module.

* Issue #19324: Expose Linux-specific constants in resource module.

* Load SSL's error strings in hashlib.

* Issue #18527: Upgrade internal copy of zlib to 1.2.8.

* Issue #19274: Add a filterfunc parameter to PyZipFile.writepy.

* Issue #8964: fix platform._sys_version to handle IronPython 2.6+.
  Patch by Martin Matusiak.

* Issue #19413: Restore pre-3.3 reload() semantics of re-finding
  modules.

* Issue #18958: Improve error message for json.load(s) while passing
  a string that starts with a UTF-8 BOM.

* Issue #19307: Improve error message for json.load(s) while passing
  objects of the wrong type.

* Issue #16038: CVE-2013-1752: ftplib: Limit amount of data read by
  limiting the call to readline().  Original patch by Michał
  Jastrzębski and Giampaolo Rodola.

* Issue #17087: Improved the repr for regular expression match
  objects.


Tests
-----

* Issue #19664: test_userdict's repr test no longer depends on the
  order of dict elements.

* Issue #19440: Clean up test_capi by removing an unnecessary
  __future__ import, converting from test_main to unittest.main, and
  running the _testcapi module tests as subTests of a unittest
  TestCase method.

* Issue #19378: the main dis module tests are now run with both
  stdout redirection *and* passing an explicit file parameter

* Issue #19378: removed the not-actually-helpful
  assertInstructionMatches and assertBytecodeExactlyMatches helpers
  from bytecode_helper

* Issue #18702: All skipped tests now reported as skipped.

* Issue #19439: interpreter embedding tests are now executed on
  Windows (Patch by Zachary Ware)

* Issue #19085: Added basic tests for all tkinter widget options.

* Issue #19384: Fix test_py_compile for root user, patch by Claudiu
  Popa.


Documentation
-------------

* Issue #18326: Clarify that list.sort's arguments are keyword-only.
  Also, attempt to reduce confusion in the glossary by not saying
  there are different "types" of arguments and parameters.


Build
-----

* Issue #19358: "make clinic" now runs the Argument Clinic
  preprocessor over all CPython source files.

* Update SQLite to 3.8.1, xz to 5.0.5, and Tcl/Tk to 8.6.1 on
  Windows.

* Issue #16632: Enable DEP and ASLR on Windows.

* Issue #17791: Drop PREFIX and EXEC_PREFIX definitions from
  PC/pyconfig.h

* Add workaround for VS 2010 nmake clean issue. VS 2010 doesn't set
  up PATH for nmake.exe correctly.

* Issue #19550: Implement Windows installer changes of PEP 453
  (ensurepip).

* Issue #19520: Fix compiler warning in the _sha3 module on 32bit
  Windows.

* Issue #19356: Avoid using a C variabled named "_self", it's a
  reserved word in some C compilers.

* Issue #15792: Correct build options on Win64. Patch by Jeremy
  Kloth.

* Issue #19373: Apply upstream change to Tk 8.5.15 fixing OS X 10.9
  screen refresh problem for OS X installer build.

* Issue #19649: On OS X, the same set of file names are now
  installed in bin directories for all configurations: non-framework
  vs framework, and single arch vs universal builds.  pythonx.y-32 is
  now always installed for 64-bit/32-bit universal builds.  The
  obsolete and undocumented pythonw* symlinks are no longer installed
  anywhere.

* Issue #19553: PEP 453 - "make install" and "make altinstall" now
  install or upgrade pip by default, using the bundled pip provided by
  the new ensurepip module.  A new configure option, --with-
  ensurepip[=upgrade|install|no], is available to override the default
  ensurepip "--upgrade" option.  The option can also be set with "make
  [alt]install ENSUREPIP=[upgrade|install|no]".

* Issue #19551: PEP 453 - the OS X installer now installs pip by
  default.

* Update third-party libraries for OS X installers: xz 5.0.3 ->
  5.0.5, SQLite 3.7.13 -> 3.8.1

* Issue #15663: Revert OS X installer built-in Tcl/Tk support for
  3.4.0b1. Some third-party projects, such as Matplotlib and
  PIL/Pillow, depended on being able to build with Tcl and Tk
  frameworks in /Library/Frameworks.


Tools/Demos
-----------

* Issue #19730: Argument Clinic now supports all the existing PyArg
  "format units" as legacy converters, as well as two new features:
  "self converters" and the "version" directive.

* Issue #19552: pyvenv now bootstraps pip into virtual environments
  by default (pass --without-pip to request the old behaviour)

* Issue #19390: Argument Clinic no longer accepts malformed Python
  and C ids.


Python 3.4.0 Alpha 4
====================

Release date: 2013-10-20


Core and Builtins
-----------------

* Issue #19301: Give classes and functions that are explicitly
  marked global a global qualname.

* Issue #19279: UTF-7 decoder no longer produces illegal strings.

* Issue #16612: Add "Argument Clinic", a compile-time preprocessor
  for C files to generate argument parsing code.  (See PEP 436.)

* Issue #18810: Shift stat calls in importlib.machinery.FileFinder
  such that the code is optimistic that if something exists in a
  directory named exactly like the possible package being searched for
  that it's in actuality a directory.

* Issue #18416: importlib.machinery.PathFinder now treats '' as the
  cwd and importlib.machinery.FileFinder no longer special-cases '' to
  '.'. This leads to modules imported from cwd to now possess an
  absolute file path for __file__ (this does not affect modules
  specified by path on the CLI but it does affect -m/runpy). It also
  allows FileFinder to be more consistent by not having an edge case.

* Issue #4555: All exported C symbols are now prefixed with either
  "Py" or "_Py".

* Issue #19219: Speed up marshal.loads(), and make pyc files
  slightly (5% to 10%) smaller.

* Issue #19221: Upgrade Unicode database to version 6.3.0.

* Issue #16742: The result of the C callback
  PyOS_ReadlineFunctionPointer must now be a string allocated by
  PyMem_RawMalloc() or PyMem_RawRealloc() (or NULL if an error
  occurred), instead of a string allocated by PyMem_Malloc() or
  PyMem_Realloc().

* Issue #19199: Remove "PyThreadState.tick_counter" field

* Fix macro expansion of _PyErr_OCCURRED(), and make sure to use it
  in at least one place so as to avoid regressions.

* Issue #19087: Improve bytearray allocation in order to allow cheap
  popping of data at the front (slice deletion).

* Issue #19014: memoryview.cast() is now allowed on zero-length
  views.

* Issue #18690: memoryview is now automatically registered with
  collections.abc.Sequence

* Issue #19078: memoryview now correctly supports the reversed
  builtin (Patch by Claudiu Popa)


Library
-------

* Issue #17457: unittest test discovery now works with namespace
  packages. Patch by Claudiu Popa.

* Issue #18235: Fix the sysconfig variables LDSHARED and BLDSHARED
  under AIX. Patch by David Edelsohn.

* Issue #18606: Add the new "statistics" module (PEP 450).
  Contributed by Steven D'Aprano.

* Issue #12866: The audioop module now supports 24-bit samples.

* Issue #19254: Provide an optimized Python implementation of
  pbkdf2_hmac.

* Issues #19201, Issue #19222, Issue #19223: Add "x" mode (exclusive
  creation) in opening file to bz2, gzip and lzma modules. Patches by
  Tim Heaney and Vajrasky Kok.

* Fix a reference count leak in _sre.

* Issue #19262: Initial check in of the 'asyncio' package (a.k.a.
  Tulip, a.k.a. PEP 3156).  There are no docs yet, and the PEP is
  slightly out of date with the code.  This module will have
  *provisional* status in Python 3.4.

* Issue #19276: Fixed the wave module on 64-bit big-endian
  platforms.

* Issue #19266: Rename the new-in-3.4 "contextlib.ignore" context
  manager to "contextlib.suppress" in order to be more consistent with
  existing descriptions of that operation elsewhere in the language
  and standard library documentation (Patch by Zero Piraeus).

* Issue #18891: Completed the new email package (provisional) API
  additions by adding new classes EmailMessage, MIMEPart, and
  ContentManager.

* Issue #18281: Unused stat constants removed from "tarfile".

* Issue #18999: Multiprocessing now supports 'contexts' with the
  same API as the module, but bound to specified start methods.

* Issue #18468: The re.split, re.findall, and re.sub functions and
  the group() and groups() methods of match object now always return a
  string or a bytes object.

* Issue #18725: The textwrap module now supports truncating
  multiline text.

* Issue #18776: atexit callbacks now display their full traceback
  when they raise an exception.

* Issue #17827: Add the missing documentation for "codecs.encode"
  and "codecs.decode".

* Issue #19218: Rename collections.abc to _collections_abc in order
  to speed up interpreter start.

* Issue #18582: Add 'pbkdf2_hmac' to the hashlib module. It
  implements PKCS#5 password-based key derivation functions with HMAC
  as pseudorandom function.

* Issue #19131: The aifc module now correctly reads and writes
  sampwidth of compressed streams.

* Issue #19209: Remove import of copyreg from the os module to speed
  up interpreter startup. stat_result and statvfs_result are now hard-
  coded to reside in the os module.

* Issue #19205: Don't import the 're' module in site and sysconfig
  module to speed up interpreter start.

* Issue #9548: Add a minimal "_bootlocale" module that is imported
  by the _io module instead of the full locale module.

* Issue #18764: Remove the 'print' alias for the PDB 'p' command so
  that it no longer shadows the print function.

* Issue #19158: A rare race in BoundedSemaphore could allow
  .release() too often.

* Issue #15805: Add contextlib.redirect_stdout().

* Issue #18716: Deprecate the formatter module.

* Issue #10712: 2to3 has a new "asserts" fixer that replaces
  deprecated names of unittest methods (e.g. failUnlessEqual ->
  assertEqual).

* Issue #18037: 2to3 now escapes "'\u'" and "'\U'" in native
  strings.

* Issue #17839: base64.decodebytes and base64.encodebytes now accept
  any object that exports a 1 dimensional array of bytes (this means
  the same is now also true for base64_codec)

* Issue #19132: The pprint module now supports compact mode.

* Issue #19137: The pprint module now correctly formats instances of
  set and frozenset subclasses.

* Issue #10042: functools.total_ordering now correctly handles
  NotImplemented being returned by the underlying comparison function
  (Patch by Katie Miller)

* Issue #19092: contextlib.ExitStack now correctly reraises
  exceptions from the __exit__ callbacks of inner context managers
  (Patch by Hrvoje Nikšić)

* Issue #12641: Avoid passing "-mno-cygwin" to the mingw32 compiler,
  except when necessary.  Patch by Oscar Benjamin.

* Issue #5845: In site.py, only load readline history from
  ~/.python_history if no history has been read already.  This avoids
  double writes to the history file at shutdown.

* Properly initialize all fields of a SSL object after allocation.

* Issue #19095: SSLSocket.getpeercert() now raises ValueError when
  the SSL handshake hasn't been done.

* Issue #4366: Fix building extensions on all platforms when
  --enable- shared is used.

* Issue #19030: Fixed "inspect.getmembers" and
  "inspect.classify_class_attrs" to attempt activating descriptors
  before falling back to a __dict__ search for faulty descriptors.
  "inspect.classify_class_attrs" no longer returns Attributes whose
  home class is None.


C API
-----

* Issue #1772673: The type of "char*" arguments now changed to
  "const char*".

* Issue #16129: Added a "Py_SetStandardStreamEncoding" pre-
  initialization API to allow embedding applications like Blender to
  force a particular encoding and error handler for the standard IO
  streams (initial patch by Bastien Montagne)


Tests
-----

* Issue #19275: Fix test_site on AMD64 Snow Leopard

* Issue #14407: Fix unittest test discovery in
  test_concurrent_futures.

* Issue #18919: Unified and extended tests for audio modules: aifc,
  sunau and wave.

* Issue #18714: Added tests for "pdb.find_function()".


Documentation
-------------

* Issue #18758: Fixed and improved cross-references.

* Issue #18972: Modernize email examples and use the argparse module
  in them.


Build
-----

* Issue #19130: Correct PCbuild/readme.txt, Python 3.3 and 3.4
  require VS 2010.

* Issue #15663: Update OS X 10.6+ installer to use Tcl/Tk 8.5.15.

* Issue #14499: Fix several problems with OS X universal build
  support:

     1. ppc arch detection for extension module builds broke with
        Xcode 5

     2. ppc arch detection in configure did not work on OS X 10.4

     3. -sysroot and -arch flags were unnecessarily duplicated

     4. there was no obvious way to configure an intel-32 only
        build.

* Issue #19019: Change the OS X installer build script to use CFLAGS
  instead of OPT for special build options.  By setting OPT, some
  compiler-specific options like -fwrapv were overridden and thus not
  used, which could result in broken interpreters when building with
  clang.


Python 3.4.0 Alpha 3
====================

Release date: 2013-09-29


Core and Builtins
-----------------

* Issue #18818: The "encodingname" part of PYTHONIOENCODING is now
  optional.

* Issue #19098: Prevent overflow in the compiler when the recursion
  limit is set absurdly high.


Library
-------

* Issue #18929: "inspect.classify_class_attrs()" now correctly finds
  class attributes returned by "dir()" that are located in the
  metaclass.

* Issue #18950: Fix miscellaneous bugs in the sunau module.
  Au_read.readframes() now updates current file position and reads
  correct number of frames from multichannel stream.
  Au_write.writeframesraw() now correctly updates current file
  position.  Au_read.getnframes() now returns an integer (as in Python
  2).  Au_read and Au_write now correctly works with file object if
  start file position is not a zero.

* Issue #18594: The fast path for collections.Counter() was never
  taken due to an over-restrictive type check.

* Issue #19053: ZipExtFile.read1() with non-zero argument no more
  returns empty bytes until end of data.

* logging: added support for Unix domain sockets to SocketHandler
  and DatagramHandler.

* Issue #18996: TestCase.assertEqual() now more cleverly shorten
  differing strings in error report.

* Issue #19034: repr() for tkinter.Tcl_Obj now exposes string
  reperesentation.

* Issue #18978: "urllib.request.Request" now allows the method to be
  indicated on the class and no longer sets it to None in "__init__".

* Issue #18626: the inspect module now offers a basic command line
  introspection interface (Initial patch by Claudiu Popa)

* Issue #3015: Fixed tkinter with wantobject=False.  Any Tcl command
  call returned empty string.

* Issue #19037: The mailbox module now makes all changes to maildir
  files before moving them into place, to avoid race conditions with
  other programs that may be accessing the maildir directory.

* Issue #14984: On POSIX systems, when netrc is called without a
  filename argument (and therefore is reading the user's $HOME/.netrc
  file), it now enforces the same security rules as typical ftp
  clients: the .netrc file must be owned by the user that owns the
  process and must not be readable by any other user.

* Issue #18873: The tokenize module now detects Python source code
  encoding only in comment lines.

* Issue #17764: Enable http.server to bind to a user specified
  network interface.  Patch contributed by Malte Swart.

* Issue #18937: Add an assertLogs() context manager to
  unittest.TestCase to ensure that a block of code emits a message
  using the logging module.

* Issue #17324: Fix http.server's request handling case on trailing
  '/'. Patch contributed by Vajrasky Kok.

* Issue #19018: The heapq.merge() function no longer suppresses
  IndexError in the underlying iterables.

* Issue #18784: The uuid module no longer attempts to load libc via
  ctypes.CDLL if all the necessary functions have already been found
  in libuuid.  Patch by Evgeny Sologubov.

* The "PYTHONFAULTHANDLER" environment variable now only enables the
  faulthandler module if the variable is non-empty. Same behaviour
  than other variables like "PYTHONDONTWRITEBYTECODE".

* Issue #1565525: New function "traceback.clear_frames" will clear
  the local variables of all the stack frames referenced by a
  traceback object.


Tests
-----

* Issue #18952: Fix regression in support data downloads introduced
  when test.support was converted to a package. Regression noticed by
  Zachary Ware.


IDLE
----

* Issue #18873: IDLE now detects Python source code encoding only in
  comment lines.

* Issue #18988: The "Tab" key now works when a word is already
  autocompleted.


Documentation
-------------

* Issue #17003: Unified the size argument names in the io module
  with common practice.


Build
-----

* Issue #18596: Support the use of address sanity checking in recent
  versions of clang and GCC by appropriately marking known false
  alarms in the small object allocator. Patch contributed by Dhiru
  Kholia.


Tools/Demos
-----------

* Issue #18873: 2to3 and the findnocoding.py script now detect
  Python source code encoding only in comment lines.


Python 3.4.0 Alpha 2
====================

Release date: 2013-09-09


Core and Builtins
-----------------

* Issue #18942: sys._debugmallocstats() output was damaged on
  Windows.

* Issue #18571: Implementation of the PEP 446: file descriptors and
  file handles are now created non-inheritable; add functions
  os.get/set_inheritable(), os.get/set_handle_inheritable() and
  socket.socket.get/set_inheritable().

* Issue #11619: The parser and the import machinery do not encode
  Unicode filenames anymore on Windows.

* Issue #18808: Non-daemon threads are now automatically joined when
  a sub-interpreter is shutdown (it would previously dump a fatal
  error).

* Remove support for compiling on systems without getcwd().

* Issue #18774: Remove last bits of GNU PTH thread code and
  thread_pth.h.

* Issue #18771: Add optimization to set object lookups to reduce the
  cost of hash collisions.  The core idea is to inspect a second
  key/hash pair for each cache line retrieved.

* Issue #16105: When a signal handler fails to write to the file
  descriptor registered with "signal.set_wakeup_fd()", report an
  exception instead of ignoring the error.

* Issue #18722: Remove uses of the "register" keyword in C code.

* Issue #18667: Add missing "HAVE_FCHOWNAT" symbol to
  posix._have_functions.

* Issue #16499: Add command line option for isolated mode.

* Issue #15301: Parsing fd, uid, and gid parameters for builtins in
  Modules/posixmodule.c is now far more robust.

* Issue #18368: PyOS_StdioReadline() no longer leaks memory when
  realloc() fail.

* Issue #17934: Add a clear() method to frame objects, to help clean
  up expensive details (local variables) and break reference cycles.

* Issue #18780: %-formatting codes %d, %i, and %u now treat int-
  subclasses as int (displays value of int-subclass instead of str
  (int-subclass) ).


Library
-------

* Issue #18808: Thread.join() now waits for the underlying thread
  state to be destroyed before returning.  This prevents unpredictable
  aborts in Py_EndInterpreter() when some non-daemon threads are still
  running.

* Issue #18458: Prevent crashes with newer versions of libedit.  Its
  readline emulation has changed from 0-based indexing to 1-based like
  gnu readline.

* Issue #18852: Handle case of "readline.__doc__" being "None" in
  the new readline activation code in "site.py".

* Issue #18672: Fixed format specifiers for Py_ssize_t in debugging
  output in the _sre module.

* Issue #18830: inspect.getclasstree() no longer produces duplicate
  entries even when input list contains duplicates.

* Issue #18878: sunau.open now supports the context management
  protocol.  Based on patches by Claudiu Popa and R. David Murray.

* Issue #18909: Fix _tkinter.tkapp.interpaddr() on Windows 64-bit,
  don't cast 64-bit pointer to long (32 bits).

* Issue #18876: The FileIO.mode attribute now better reflects the
  actual mode under which the file was opened.  Patch by Erik Bray.

* Issue #16853: Add new selectors module.

* Issue #18882: Add threading.main_thread() function.

* Issue #18901: The sunau getparams method now returns a namedtuple
  rather than a plain tuple.  Patch by Claudiu Popa.

* Issue #17487: The result of the wave getparams method now is
  pickleable again. Patch by Claudiu Popa.

* Issue #18756: os.urandom() now uses a lazily-opened persistent
  file descriptor, so as to avoid using many file descriptors when run
  in parallel from multiple threads.

* Issue #18418: After fork(), reinit all threads states, not only
  active ones. Patch by A. Jesse Jiryu Davis.

* Issue #17974: Switch unittest from using getopt to using argparse.

* Issue #11798: TestSuite now drops references to own tests after
  execution.

* Issue #16611: http.cookie now correctly parses the 'secure' and
  'httponly' cookie flags.

* Issue #11973: Fix a problem in kevent. The flags and fflags fields
  are now properly handled as unsigned.

* Issue #18807: "pyvenv" now takes a --copies argument allowing
  copies instead of symlinks even where symlinks are available and the
  default.

* Issue #18538: "python -m dis" now uses argparse for argument
  processing. Patch by Michele Orrù.

* Issue #18394: Close cgi.FieldStorage's optional file.

* Issue #17702: On error, os.environb now suppresses the exception
  context when raising a new KeyError with the original key.

* Issue #16809: Fixed some tkinter incompabilities with Tcl/Tk 8.6.

* Issue #16809: Tkinter's splitlist() and split() methods now accept
  Tcl_Obj argument.

* Issue #18324: set_payload now correctly handles binary input.
  This also supersedes the previous fixes for #14360, #1717, and
  #16564.

* Issue #18794: Add a fileno() method and a closed attribute to
  select.devpoll objects.

* Issue #17119: Fixed integer overflows when processing large
  strings and tuples in the tkinter module.

* Issue #18747: Re-seed OpenSSL's pseudo-random number generator
  after fork. A pthread_atfork() parent handler is used to seed the
  PRNG with pid, time and some stack data.

* Issue #8865: Concurrent invocation of select.poll.poll() now
  raises a RuntimeError exception.  Patch by Christian Schubert.

* Issue #18777: The ssl module now uses the new CRYPTO_THREADID API
  of OpenSSL 1.0.0+ instead of the deprecated CRYPTO id callback
  function.

* Issue #18768: Correct doc string of RAND_edg(). Patch by Vajrasky
  Kok.

* Issue #18178: Fix ctypes on BSD. dlmalloc.c was compiled twice
  which broke malloc weak symbols.

* Issue #18709: Fix CVE-2013-4238. The SSL module now handles NULL
  bytes inside subjectAltName correctly. Formerly the module has used
  OpenSSL's GENERAL_NAME_print() function to get the string
  represention of ASN.1 strings for "rfc822Name" (email), "dNSName"
  (DNS) and "uniformResourceIdentifier" (URI).

* Issue #18701: Remove support of old CPython versions (<3.0) from C
  code.

* Issue #18756: Improve error reporting in os.urandom() when the
  failure is due to something else than /dev/urandom not existing (for
  example, exhausting the file descriptor limit).

* Issue #18673: Add O_TMPFILE to os module. O_TMPFILE requires Linux
  kernel 3.11 or newer. It's only defined on system with 3.11 uapi
  headers, too.

* Issue #18532: Change the builtin hash algorithms' names to lower
  case names as promised by hashlib's documentation.

* Issue #8713: add new spwan and forkserver start methods, and new
  functions get_all_start_methods, get_start_method, and
  set_start_method, to multiprocessing.

* Issue #18405: Improve the entropy of crypt.mksalt().

* Issue #12015: The tempfile module now uses a suffix of 8 random
  characters instead of 6, to reduce the risk of filename collision.
  The entropy was reduced when uppercase letters were removed from the
  charset used to generate random characters.

* Issue #18585: Add "textwrap.shorten()" to collapse and truncate a
  piece of text to a given length.

* Issue #18598: Tweak exception message for
  importlib.import_module() to include the module name when a key
  argument is missing.

* Issue #19151: Fix docstring and use of
  _get_supported_file_loaders() to reflect 2-tuples.

* Issue #19152: Add ExtensionFileLoader.get_filename().

* Issue #18676: Change 'positive' to 'non-negative' in queue.py put
  and get docstrings and ValueError messages. Patch by Zhongyue Luo

* Fix refcounting issue with extension types in tkinter.

* Issue #8112: xlmrpc.server's DocXMLRPCServer server no longer
  raises an error if methods have annotations; it now correctly
  displays the annotations.

* Issue #18600: Added policy argument to
  email.message.Message.as_string, and as_bytes and __bytes__ methods
  to Message.

* Issue #18671: Output more information when logging exceptions
  occur.

* Issue #18621: Prevent the site module's patched builtins from
  keeping too many references alive for too long.

* Issue #4885: Add weakref support to mmap objects.  Patch by
  Valerie Lambert.

* Issue #8860: Fixed rounding in timedelta constructor.

* Issue #18849: Fixed a Windows-specific tempfile bug where
  collision with an existing directory caused mkstemp and related APIs
  to fail instead of retrying. Report and fix by Vlad Shcherbina.

* Issue #18920: argparse's default destination for the version
  action (-v, --version) has also been changed to stdout, to match the
  Python executable.


Tests
-----

* Issue #18623: Factor out the _SuppressCoreFiles context manager
  into test.support.  Patch by Valerie Lambert.

* Issue #12037: Fix test_email for desktop Windows.

* Issue #15507: test_subprocess's test_send_signal could fail if the
  test runner were run in an environment where the process inherited
  an ignore setting for SIGINT.  Restore the SIGINT handler to the
  desired KeyboardInterrupt raising one during that test.

* Issue #16799: Switched from getopt to argparse style in regrtest's
  argument parsing.  Added more tests for regrtest's argument parsing.

* Issue #18792: Use "127.0.0.1" or "::1" instead of "localhost" as
  much as possible, since "localhost" goes through a DNS lookup under
  recent Windows versions.


IDLE
----

* Issue #18489: Add tests for SearchEngine. Original patch by Phil
  Webster.


Documentation
-------------

* Issue #18743: Fix references to non-existant "StringIO" module.

* Issue #18783: Removed existing mentions of Python long type in
  docstrings, error messages and comments.


Build
-----

* Issue #1584: Provide configure options to override default search
  paths for Tcl and Tk when building _tkinter.

* Issue #15663: Tcl/Tk 8.5.14 is now included with the OS X 10.6+
  64-/32-bit installer.  It is no longer necessary to install a third-
  party version of Tcl/Tk 8.5 to work around the problems in the
  Apple-supplied Tcl/Tk 8.5 shipped in OS X 10.6 and later releases.


Tools/Demos
-----------

* Issue #18922: Now The Lib/smtpd.py and Tools/i18n/msgfmt.py
  scripts write their version strings to stdout, and not to sderr.


Python 3.4.0 Alpha 1
====================

Release date: 2013-08-03


Core and Builtins
-----------------

* Issue #16741: Fix an error reporting in int().

* Issue #17899: Fix rare file descriptor leak in os.listdir().

* Issue #10241: Clear extension module dict copies at interpreter
  shutdown. Patch by Neil Schemenauer, minimally modified.

* Issue #9035: ismount now recognises volumes mounted below a drive
  root on Windows. Original patch by Atsuo Ishimoto.

* Issue #18214: Improve finalization of Python modules to avoid
  setting their globals to None, in most cases.

* Issue #18112: PEP 442 implementation (safe object finalization).

* Issue #18552: Check return value of PyArena_AddPyObject() in
  obj2ast_object().

* Issue #18560: Fix potential NULL pointer dereference in sum().

* Issue #18520: Add a new PyStructSequence_InitType2() function,
  same than PyStructSequence_InitType() except that it has a return
  value (0 on success, -1 on error).

* Issue #15905: Fix theoretical buffer overflow in handling of
  sys.argv[0], prefix and exec_prefix if the operation system does not
  obey MAXPATHLEN.

* Issue #18408: Fix many various bugs in code handling errors,
  especially on memory allocation failure (MemoryError).

* Issue #18344: Fix potential ref-leaks in
  _bufferedreader_read_all().

* Issue #18342: Use the repr of a module name when an import fails
  when using "from ... import ...".

* Issue #17872: Fix a segfault in marshal.load() when input stream
  returns more bytes than requested.

* Issue #18338: "python --version" now prints version string to
  stdout, and not to stderr.  Patch by Berker Peksag and Michael
  Dickens.

* Issue #18426: Fix NULL pointer dereference in C extension import
  when PyModule_GetDef() returns an error.

* Issue #17206: On Windows, increase the stack size from 2 MB to 4.2
  MB to fix a stack overflow in the marshal module (fix a crash in
  test_marshal). Patch written by Jeremy Kloth.

* Issue #3329: Implement the PEP 445: Add new APIs to customize
  Python memory allocators.

* Issue #18328: Reorder ops in PyThreadState_Delete*() functions.
  Now the tstate is first removed from TLS and then deallocated.

* Issue #13483: Use VirtualAlloc in obmalloc on Windows.

* Issue #18184: PyUnicode_FromFormat() and PyUnicode_FromFormatV()
  now raise OverflowError when an argument of %c format is out of
  range.

* Issue #18111: The min() and max() functions now support a default
  argument to be returned instead of raising a ValueError on an empty
  sequence. (Contributed by Julian Berman.)

* Issue #18137: Detect integer overflow on precision in
  float.__format__() and complex.__format__().

* Issue #18183: Fix various unicode operations on strings with large
  unicode codepoints.

* Issue #18180: Fix ref leak in _PyImport_GetDynLoadWindows().

* Issue #18038: SyntaxError raised during compilation sources with
  illegal encoding now always contains an encoding name.

* Issue #17931: Resolve confusion on Windows between pids and
  process handles.

* Tweak the exception message when the magic number or size value in
  a bytecode file is truncated.

* Issue #17932: Fix an integer overflow issue on Windows 64-bit in
  iterators: change the C type of seqiterobject.it_index from long to
  Py_ssize_t.

* Issue #18065: Don't set __path__ to the package name for frozen
  packages.

* Issue #18088: When reloading a module, unconditionally reset all
  relevant attributes on the module (e.g. __name__, __loader__,
  __package__, __file__, __cached__).

* Issue #17937: Try harder to collect cyclic garbage at shutdown.

* Issue #12370: Prevent class bodies from interfering with the
  __class__ closure.

* Issue #17644: Fix a crash in str.format when curly braces are used
  in square brackets.

* Issue #17237: Fix crash in the ASCII decoder on m68k.

* Issue #17927: Frame objects kept arguments alive if they had been
  copied into a cell, even if the cell was cleared.

* Issue #1545463: At shutdown, defer finalization of codec modules
  so that stderr remains usable.

* Issue #7330: Implement width and precision (ex: "%5.3s") for the
  format string of PyUnicode_FromFormat() function, original patch
  written by Ysj Ray.

* Issue #1545463: Global variables caught in reference cycles are
  now garbage-collected at shutdown.

* Issue #17094: Clear stale thread states after fork().  Note that
  this is a potentially disruptive change since it may release some
  system resources which would otherwise remain perpetually alive
  (e.g. database connections kept in thread-local storage).

* Issue #17408: Avoid using an obsolete instance of the copyreg
  module when the interpreter is shutdown and then started again.

* Issue #5845: Enable tab-completion in the interactive interpreter
  by default, thanks to a new sys.__interactivehook__.

* Issue #17115,17116: Module initialization now includes setting
  __package__ and __loader__ attributes to None.

* Issue #17853: Ensure locals of a class that shadow free variables
  always win over the closures.

* Issue #17863: In the interactive console, don't loop forever if
  the encoding can't be fetched from stdin.

* Issue #17867: Raise an ImportError if __import__ is not found in
  __builtins__.

* Issue #18698: Ensure importlib.reload() returns the module out of
  sys.modules.

* Issue #17857: Prevent build failures with pre-3.5.0 versions of
  sqlite3, such as was shipped with Centos 5 and Mac OS X 10.4.

* Issue #17413: sys.settrace callbacks were being passed a string
  instead of an exception instance for the 'value' element of the arg
  tuple if the exception originated from C code; now an exception
  instance is always provided.

* Issue #17782: Fix undefined behaviour on platforms where "struct
  timespec"'s "tv_nsec" member is not a C long.

* Issue #17722: When looking up __round__, resolve descriptors.

* Issue #16061: Speed up str.replace() for replacing 1-character
  strings.

* Issue #17715: Fix segmentation fault from raising an exception in
  a __trunc__ method.

* Issue #17643: Add __callback__ attribute to weakref.ref.

* Issue #16447: Fixed potential segmentation fault when setting
  __name__ on a class.

* Issue #17669: Fix crash involving finalization of generators using
  yield from.

* Issue #14439: Python now prints the traceback on runpy failure at
  startup.

* Issue #17469: Fix _Py_GetAllocatedBlocks() and
  sys.getallocatedblocks() when running on valgrind.

* Issue #17619: Make input() check for Ctrl-C correctly on Windows.

* Issue #17357: Add missing verbosity messages for -v/-vv that were
  lost during the importlib transition.

* Issue #17610: Don't rely on non-standard behavior of the C qsort()
  function.

* Issue #17323: The "[X refs, Y blocks]" printed by debug builds has
  been disabled by default.  It can be re-enabled with the "-X
  showrefcount" option.

* Issue #17328: Fix possible refleak in dict.setdefault.

* Issue #17275: Corrected class name in init error messages of the C
  version of BufferedWriter and BufferedRandom.

* Issue #7963: Fixed misleading error message that issued when
  object is called without arguments.

* Issue #8745: Small speed up zipimport on Windows. Patch by Catalin
  Iacob.

* Issue #5308: Raise ValueError when marshalling too large object (a
  sequence with size >= 2**31), instead of producing illegal marshal
  data.

* Issue #12983: Bytes literals with invalid "\x" escape now raise a
  SyntaxError and a full traceback including line number.

* Issue #16967: In function definition, evaluate positional defaults
  before keyword-only defaults.

* Issue #17173: Remove uses of locale-dependent C functions
  (isalpha() etc.) in the interpreter.

* Issue #17137: When an Unicode string is resized, the internal wide
  character string (wstr) format is now cleared.

* Issue #17043: The unicode-internal decoder no longer read past the
  end of input buffer.

* Issue #17098: All modules now have __loader__ set even if they
  pre- exist the bootstrapping of importlib.

* Issue #16979: Fix error handling bugs in the unicode-escape-decode
  decoder.

* Issue #16772: The base argument to the int constructor no longer
  accepts floats, or other non-integer objects with an __int__ method.
  Objects with an __index__ method are now accepted.

* Issue #10156: In the interpreter's initialization phase, unicode
  globals are now initialized dynamically as needed.

* Issue #16980: Fix processing of escaped non-ascii bytes in the
  unicode-escape-decode decoder.

* Issue #16975: Fix error handling bug in the escape-decode bytes
  decoder.

* Issue #14850: Now a charmap decoder treats U+FFFE as "undefined
  mapping" in any mapping, not only in a string.

* Issue #16613: Add *m* argument to "collections.Chainmap.new_child"
  to allow the new child map to be specified explicitly.

* Issue #16730: importlib.machinery.FileFinder now no longers raises
  an exception when trying to populate its cache and it finds out the
  directory is unreadable or has turned into a file. Reported and
  diagnosed by David Pritchard.

* Issue #16906: Fix a logic error that prevented most static strings
  from being cleared.

* Issue #11461: Fix the incremental UTF-16 decoder. Original patch
  by Amaury Forgeot d'Arc.

* Issue #16856: Fix a segmentation fault from calling repr() on a
  dict with a key whose repr raise an exception.

* Issue #16367: Fix FileIO.readall() on Windows for files larger
  than 2 GB.

* Issue #16761: Calling int() with base argument only now raises
  TypeError.

* Issue #16759: Support the full DWORD (unsigned long) range in
  Reg2Py when retrieving a REG_DWORD value. This corrects functions
  like winreg.QueryValueEx that may have been returning truncated
  values.

* Issue #14420: Support the full DWORD (unsigned long) range in
  Py2Reg when passed a REG_DWORD value. Fixes OverflowError in
  winreg.SetValueEx.

* Issue #11939: Set the st_dev attribute of stat_result to allow
  Windows to take advantage of the
  os.path.samefile/sameopenfile/samestat implementations used by other
  platforms.

* Issue #16772: The int() constructor's second argument (base) no
  longer accepts non integer values.  Consistent with the behavior in
  Python 2.

* Issue #14470: Remove w9xpopen support per PEP 11.

* Issue #9856: Replace deprecation warning with raising TypeError in
  object.__format__. Patch by Florent Xicluna.

* Issue #16597: In buffered and text IO, call close() on the
  underlying stream if invoking flush() fails.

* Issue #16722: In the bytes() constructor, try to call __bytes__ on
  the argument before __index__.

* Issue #16421: loading multiple modules from one shared object is
  now handled correctly (previously, the first module loaded from that
  file was silently returned). Patch by Václav Šmilauer.

* Issue #16602: When a weakref's target was part of a long
  deallocation chain, the object could remain reachable through its
  weakref even though its refcount had dropped to zero.

* Issue #16495: Remove extraneous NULL encoding check from
  bytes_decode().

* Issue #16619: Create NameConstant AST class to represent None,
  True, and False literals. As a result, these constants are never
  loaded at runtime from builtins.

* Issue #16455: On FreeBSD and Solaris, if the locale is C, the
  ASCII/surrogateescape codec is now used (instead of the locale
  encoding) to decode the command line arguments. This change fixes
  inconsistencies with os.fsencode() and os.fsdecode(), because these
  operating systems announce an ASCII locale encoding, but actually
  use the ISO-8859-1 encoding in practice.

* Issue #16562: Optimize dict equality testing.  Patch by Serhiy
  Storchaka.

* Issue #16588: Silence unused-but-set warnings in
  Python/thread_pthread

* Issue #16592: stringlib_bytes_join doesn't raise MemoryError on
  allocation failure.

* Issue #16546: Fix: ast.YieldFrom argument is now mandatory.

* Issue #16514: Fix regression causing a traceback when sys.path[0]
  is None (actually, any non-string or non-bytes type).

* Issue #16306: Fix multiple error messages when unknown command
  line parameters where passed to the interpreter.  Patch by Hieu
  Nguyen.

* Issue #16215: Fix potential double memory free in str.replace().
  Patch by Serhiy Storchaka.

* Issue #16290: A float return value from the __complex__ special
  method is no longer accepted in the complex() constructor.

* Issue #16416: On Mac OS X, operating system data are now always
  encoded/decoded to/from UTF-8/surrogateescape, instead of the locale
  encoding (which may be ASCII if no locale environment variable is
  set), to avoid inconsistencies with os.fsencode() and os.fsdecode()
  functions which are already using UTF-8/surrogateescape.

* Issue #16453: Fix equality testing of dead weakref objects.

* Issue #9535: Fix pending signals that have been received but not
  yet handled by Python to not persist after os.fork() in the child
  process.

* Issue #14794: Fix slice.indices to return correct results for huge
  values, rather than raising OverflowError.

* Issue #15001: fix segfault on "del sys.modules['__main__']". Patch
  by Victor Stinner.

* Issue #8271: the utf-8 decoder now outputs the correct number of
  U+FFFD characters when used with the 'replace' error handler on
  invalid utf-8 sequences.  Patch by Serhiy Storchaka, tests by Ezio
  Melotti.

* Issue #5765: Apply a hard recursion limit in the compiler instead
  of blowing the stack and segfaulting. Initial patch by Andrea
  Griffini.

* Issue #16402: When slicing a range, fix shadowing of exceptions
  from __index__.

* Issue #16336: fix input checking in the surrogatepass error
  handler. Patch by Serhiy Storchaka.

* Issue #8401: assigning an int to a bytearray slice (e.g. b[3:4] =
  5) now raises an error.

* Issue #7317: Display full tracebacks when an error occurs
  asynchronously. Patch by Alon Horev with update by Alexey Kachayev.

* Issue #16309: Make PYTHONPATH="" behavior the same as if
  PYTHONPATH not set at all.

* Issue #10189: Improve the error reporting of SyntaxErrors related
  to global and nonlocal statements.

* Fix segfaults on setting __qualname__ on builtin types and
  attempting to delete it on any type.

* Issue #14625: Rewrite the UTF-32 decoder. It is now 3x to 4x
  faster. Patch written by Serhiy Storchaka.

* Issue #16345: Fix an infinite loop when "fromkeys" on a dict
  subclass received a nonempty dict from the constructor.

* Issue #16271: Fix strange bugs that resulted from __qualname__
  appearing in a class's __dict__ and on type.

* Issue #12805: Make bytes.join and bytearray.join faster when the
  separator is empty.  Patch by Serhiy Storchaka.

* Issue #6074: Ensure cached bytecode files can always be updated by
  the user that created them, even when the source file is read-only.

* Issue #15958: bytes.join and bytearray.join now accept arbitrary
  buffer objects.

* Issue #14783: Improve int() docstring and switch docstrings for
  str(), range(), and slice() to use multi-line signatures.

* Issue #16160: Subclass support now works for
  types.SimpleNamespace.

* Issue #16148: Implement PEP 424, adding operator.length_hint and
  PyObject_LengthHint.

* Upgrade Unicode data (UCD) to version 6.2.

* Issue #15379: Fix passing of non-BMP characters as integers for
  the charmap decoder (already working as unicode strings).  Patch by
  Serhiy Storchaka.

* Issue #15144: Fix possible integer overflow when handling pointers
  as integer values, by using "Py_uintptr_t" instead of "size_t".
  Patch by Serhiy Storchaka.

* Issue #15965: Explicitly cast "AT_FDCWD" as (int).  Required on
  Solaris 10 (which defines "AT_FDCWD" as "0xffd19553"), harmless on
  other platforms.

* Issue #15839: Convert SystemErrors in "super()" to RuntimeErrors.

* Issue #15448: Buffered IO now frees the buffer when closed,
  instead of when deallocating.

* Issue #15846: Fix SystemError which happened when using
  "ast.parse()" in an exception handler on code with syntax errors.

* Issue #15897: zipimport.c doesn't check return value of fseek().
  Patch by Felipe Cruz.

* Issue #15801: Make sure mappings passed to '%' formatting are
  actually subscriptable.

* Issue #15111: __import__ should propagate ImportError when raised
  as a side-effect of a module triggered from using fromlist.

* Issue #15022: Add pickle and comparison support to
  types.SimpleNamespace.


Library
-------

* Issue #4331: Added functools.partialmethod (Initial patch by Alon
  Horev)

* Issue #13461: Fix a crash in the TextIOWrapper.tell method on
  64-bit platforms.  Patch by Yogesh Chaudhari.

* Issue #18681: Fix a NameError in importlib.reload() (noticed by
  Weizhao Li).

* Issue #14323: Expanded the number of digits in the coefficients
  for the RGB -- YIQ conversions so that they match the FCC NTSC
  versions.

* Issue #17998: Fix an internal error in regular expression engine.

* Issue #17557: Fix os.getgroups() to work with the modified
  behavior of getgroups(2) on OS X 10.8.  Original patch by Mateusz
  Lenik.

* Issue #18608: Avoid keeping a strong reference to the locale
  module inside the _io module.

* Issue #18619: Fix atexit leaking callbacks registered from sub-
  interpreters, and make it GC-aware.

* Issue #15699: The readline module now uses PEP 3121-style module
  initialization, so as to reclaim allocated resources (Python
  callbacks) at shutdown.  Original patch by Robin Schreiber.

* Issue #17616: wave.open now supports the context management
  protocol.

* Issue #18599: Fix name attribute of _sha1.sha1() object. It now
  returns 'SHA1' instead of 'SHA'.

* Issue #13266: Added inspect.unwrap to easily unravel __wrapped__
  chains (initial patch by Daniel Urban and Aaron Iles)

* Issue #18561: Skip name in ctypes' _build_callargs() if name is
  NULL.

* Issue #18559: Fix NULL pointer dereference error in _pickle module

* Issue #18556: Check the return type of PyUnicode_AsWideChar() in
  ctype's U_set().

* Issue #17818: aifc.getparams now returns a namedtuple.

* Issue #18549: Eliminate dead code in socket_ntohl()

* Issue #18530: Remove additional stat call from posixpath.ismount.
  Patch by Alex Gaynor.

* Issue #18514: Fix unreachable Py_DECREF() call in
  PyCData_FromBaseObj()

* Issue #9177: Calling read() or write() now raises ValueError, not
  AttributeError, on a closed SSL socket.  Patch by Senko Rasic.

* Issue #18513: Fix behaviour of cmath.rect w.r.t. signed zeros on
  OS X 10.8 + gcc.

* Issue #18479: Changed venv Activate.ps1 to make deactivate a
  function, and removed Deactivate.ps1.

* Issue #18480: Add missing call to PyType_Ready to the _elementtree
  extension.

* Issue #17778: Fix test discovery for test_multiprocessing. (Patch
  by Zachary Ware.)

* Issue #18393: The private module _gestalt and private functions
  platform._mac_ver_gestalt, platform._mac_ver_lookup and
  platform._bcd2str have been removed. This does not affect the public
  interface of the platform module.

* Issue #17482: functools.update_wrapper (and functools.wraps) now
  set the __wrapped__ attribute correctly even if the underlying
  function has a __wrapped__ attribute set.

* Issue #18431: The new email header parser now decodes RFC2047
  encoded words in structured headers.

* Issue #18432: The sched module's queue method was incorrectly
  returning an iterator instead of a list.

* Issue #18044: The new email header parser was mis-parsing encoded
  words where an encoded character immediately followed the '?' that
  follows the CTE character, resulting in a decoding failure.  They
  are now decoded correctly.

* Issue #18101: Tcl.split() now process strings nested in a tuple as
  it do with byte strings.

* Issue #18116: getpass was always getting an error when testing
  /dev/tty, and thus was always falling back to stdin, and would then
  raise an exception if stdin could not be used (such as /dev/null).
  It also leaked an open file. All of these issues are now fixed.

* Issue #17198: Fix a NameError in the dbm module.  Patch by
  Valentina Mukhamedzhanova.

* Issue #18013: Fix cgi.FieldStorage to parse the W3C sample form.

* Issue #18020: improve html.escape speed by an order of magnitude.
  Patch by Matt Bryant.

* Issue #18347: ElementTree's html serializer now preserves the case
  of closing tags.

* Issue #17261: Ensure multiprocessing's proxies use proper address.

* Issue #18343: faulthandler.register() now keeps the previous
  signal handler when the function is called twice, so
  faulthandler.unregister() restores correctly the original signal
  handler.

* Issue #17097: Make multiprocessing ignore EINTR.

* Issue #18339: Negative ints keys in unpickler.memo dict no longer
  cause a segfault inside the _pickle C extension.

* Issue #18240: The HMAC module is no longer restricted to bytes and
  accepts any bytes-like object, e.g. memoryview. Original patch by
  Jonas Borgström.

* Issue #18224: Removed pydoc script from created venv, as it causes
  problems on Windows and adds no value over and above python -m pydoc
  ...

* Issue #18155: The csv module now correctly handles csv files that
  use a delimter character that has a special meaning in regexes,
  instead of throwing an exception.

* Issue #14360: encode_quopri can now be successfully used as an
  encoder when constructing a MIMEApplication object.

* Issue #11390: Add -o and -f command line options to the doctest
  CLI to specify doctest options (and convert it to using argparse).

* Issue #18135: ssl.SSLSocket.write() now raises an OverflowError if
  the input string in longer than 2 gigabytes, and
  ssl.SSLContext.load_cert_chain() raises a ValueError if the password
  is longer than 2 gigabytes. The ssl module does not support partial
  write.

* Issue #11016: Add C implementation of the stat module as _stat.

* Issue #18248: Fix libffi build on AIX.

* Issue #18259: Declare sethostname in socketmodule.c for AIX

* Issue #18147: Add diagnostic functions to ssl.SSLContext().
  get_ca_list() lists all loaded CA certificates and
  cert_store_stats() returns amount of loaded X.509 certs, X.509 CA
  certs and CRLs.

* Issue #18167: cgi.FieldStorage no longer fails to handle multipart
  /form-data when "\r\n" appears at end of 65535 bytes without other
  newlines.

* Issue #18076: Introduce importlib.util.decode_source().

* Issue #18357: add tests for dictview set difference. Patch by
  Fraser Tweedale.

* importlib.abc.SourceLoader.get_source() no longer changes
  SyntaxError or UnicodeDecodeError into ImportError.

* Issue #18058, 18057: Make the namespace package loader meet the
  importlib.abc.InspectLoader ABC, allowing for namespace packages to
  work with runpy.

* Issue #17177: The imp module is pending deprecation.

* subprocess: Prevent a possible double close of parent pipe fds
  when the subprocess exec runs into an error.  Prevent a regular
  multi- close of the /dev/null fd when any of stdin, stdout and
  stderr was set to DEVNULL.

* Issue #18194: Introduce importlib.util.cache_from_source() and
  source_from_cache() while documenting the equivalent functions in
  imp as deprecated.

* Issue #17907: Document imp.new_module() as deprecated in favour of
  types.ModuleType.

* Issue #18192: Introduce importlib.util.MAGIC_NUMBER and document
  as deprecated imp.get_magic().

* Issue #18149: Add filecmp.clear_cache() to manually clear the
  filecmp cache. Patch by Mark Levitt

* Issue #18193: Add importlib.reload().

* Issue #18157: Stop using imp.load_module() in pydoc.

* Issue #16102: Make uuid._netbios_getnode() work again on Python 3.

* Issue #17134: Add ssl.enum_cert_store() as interface to Windows'
  cert store.

* Issue #18143: Implement ssl.get_default_verify_paths() in order to
  debug the default locations for cafile and capath.

* Issue #17314: Move multiprocessing.forking over to importlib.

* Issue #11959: SMTPServer and SMTPChannel now take an optional map,
  use of which avoids affecting global state.

* Issue #18109: os.uname() now decodes fields from the locale
  encoding, and socket.gethostname() now decodes the hostname from the
  locale encoding, instead of using the UTF-8 encoding in strict mode.

* Issue #18089: Implement importlib.abc.InspectLoader.load_module.

* Issue #18088: Introduce importlib.abc.Loader.init_module_attrs for
  setting module attributes. Leads to the pending deprecation of
  importlib.util.module_for_loader.

* Issue #17403: urllib.parse.robotparser normalizes the urls before
  adding to ruleline. This helps in handling certain types invalid
  urls in a conservative manner. Patch contributed by Mher Movsisyan.

* Issue #18070: Have importlib.util.module_for_loader() set
  attributes unconditionally in order to properly support reloading.

* Added importlib.util.module_to_load to return a context manager to
  provide the proper module object to load.

* Issue #18025: Fixed a segfault in io.BufferedIOBase.readinto()
  when raw stream's read() returns more bytes than requested.

* Issue #18011: As was originally intended, base64.b32decode() now
  raises a binascii.Error if there are non-b32-alphabet characters
  present in the input string, instead of a TypeError.

* Issue #18072: Implement importlib.abc.InspectLoader.get_code() and
  importlib.abc.ExecutionLoader.get_code().

* Issue #8240: Set the SSL_MODE_ACCEPT_MOVING_WRITE_BUFFER flag on
  SSL sockets.

* Issue #17269: Workaround for socket.getaddrinfo crash on MacOS X
  with port None or "0" and flags AI_NUMERICSERV.

* Issue #16986: ElementTree now correctly works with string input
  when the internal XML encoding is not UTF-8 or US-ASCII.

* Issue #17996: socket module now exposes AF_LINK constant on BSD
  and OSX.

* Issue #17900: Allowed pickling of recursive OrderedDicts.
  Decreased pickled size and pickling time.

* Issue #17914: Add os.cpu_count(). Patch by Yogesh Chaudhari, based
  on an initial patch by Trent Nelson.

* Issue #17812: Fixed quadratic complexity of base64.b32encode().
  Optimize base64.b32encode() and base64.b32decode() (speed up to 3x).

* Issue #17980: Fix possible abuse of ssl.match_hostname() for
  denial of service using certificates with many wildcards
  (CVE-2013-2099).

* Issue #15758: Fix FileIO.readall() so it no longer has O(n**2)
  complexity.

* Issue #14596: The struct.Struct() objects now use a more compact
  implementation.

* Issue #17981: logging's SysLogHandler now closes the socket when
  it catches socket OSErrors.

* Issue #17964: Fix os.sysconf(): the return type of the C sysconf()
  function is long, not int.

* Fix typos in the multiprocessing module.

* Issue #17754: Make ctypes.util.find_library() independent of the
  locale.

* Issue #17968: Fix memory leak in os.listxattr().

* Issue #17606: Fixed support of encoded byte strings in the
  XMLGenerator characters() and ignorableWhitespace() methods.
  Original patch by Sebastian Ortiz Vasquez.

* Issue #17732: Ignore distutils.cfg options pertaining to install
  paths if a virtual environment is active.

* Issue #17915: Fix interoperability of xml.sax with file objects
  returned by codecs.open().

* Issue #16601: Restarting iteration over tarfile really restarts
  rather than continuing from where it left off.  Patch by Michael
  Birtwell.

* Issue #17289: The readline module now plays nicer with external
  modules or applications changing the
  rl_completer_word_break_characters global variable.  Initial patch
  by Bradley Froehle.

* Issue #12181: select module: Fix struct kevent definition on
  OpenBSD 64-bit platforms. Patch by Federico Schwindt.

* Issue #11816: multiple improvements to the dis module:
  get_instructions generator, ability to redirect output to a file,
  Bytecode and Instruction abstractions. Patch by Nick Coghlan, Ryan
  Kelly and Thomas Kluyver.

* Issue #13831: Embed stringification of remote traceback in local
  traceback raised when pool task raises an exception.

* Issue #15528: Add weakref.finalize to support finalization using
  weakref callbacks.

* Issue #14173: Avoid crashing when reading a signal handler during
  interpreter shutdown.

* Issue #15902: Fix imp.load_module() accepting None as a file when
  loading an extension module.

* Issue #13721: SSLSocket.getpeercert() and SSLSocket.do_handshake()
  now raise an OSError with ENOTCONN, instead of an AttributeError,
  when the SSLSocket is not connected.

* Issue #14679: add an __all__ (that contains only HTMLParser) to
  html.parser.

* Issue #17802: Fix an UnboundLocalError in html.parser.  Initial
  tests by Thomas Barlow.

* Issue #17358: Modules loaded by imp.load_source() and
  load_compiled() (and by extention load_module()) now have a better
  chance of working when reloaded.

* Issue #17804: New function "struct.iter_unpack" allows for
  streaming struct unpacking.

* Issue #17830: When keyword.py is used to update a keyword file, it
  now preserves the line endings of the original file.

* Issue #17272: Making the urllib.request's Request.full_url a
  descriptor. Fixes bugs with assignment to full_url. Patch by Demian
  Brecht.

* Issue #17353: Plistlib emitted empty data tags with deeply nested
  datastructures

* Issue #11714: Use 'with' statements to assure a Semaphore releases
  a condition variable.  Original patch by Thomas Rachel.

* Issue #16624: "subprocess.check_output" now accepts an "input"
  argument, allowing the subprocess's stdin to be provided as a (byte)
  string. Patch by Zack Weinberg.

* Issue #17795: Reverted backwards-incompatible change in
  SysLogHandler with Unix domain sockets.

* Issue #16694: Add a pure Python implementation of the operator
  module. Patch by Zachary Ware.

* Issue #11182: remove the unused and undocumented pydoc.Scanner
  class. Patch by Martin Morrison.

* Issue #17741: Add ElementTree.XMLPullParser, an event-driven
  parser for non-blocking applications.

* Issue #17555: Fix ForkAwareThreadLock so that size of after fork
  registry does not grow exponentially with generation of process.

* Issue #17707: fix regression in multiprocessing.Queue's get()
  method where it did not block for short timeouts.

* Issue #17720: Fix the Python implementation of pickle.Unpickler to
  correctly process the APPENDS opcode when it is used on non-list
  objects.

* Issue #17012: shutil.which() no longer falls back to the PATH
  environment variable if an empty path argument is specified.  Patch
  by Serhiy Storchaka.

* Issue #17710: Fix pickle raising a SystemError on bogus input.

* Issue #17341: Include the invalid name in the error messages from
  re about invalid group names.

* Issue #17702: os.environ now raises KeyError with the original
  environment variable name (str on UNIX), instead of using the
  encoded name (bytes on UNIX).

* Issue #16163: Make the importlib based version of
  pkgutil.iter_importers work for submodules. Initial patch by Berker
  Peksag.

* Issue #16804: Fix a bug in the 'site' module that caused running
  'python -S -m site' to incorrectly throw an exception.

* Issue #15480: Remove the deprecated and unused TYPE_INT64 code
  from marshal. Initial patch by Daniel Riti.

* Issue #2118: SMTPException is now a subclass of OSError.

* Issue #17016: Get rid of possible pointer wraparounds and integer
  overflows in the re module.  Patch by Nickolai Zeldovich.

* Issue #16658: add missing return to HTTPConnection.send(). Patch
  by Jeff Knupp.

* Issue #9556: the logging package now allows specifying a time-of-
  day for a TimedRotatingFileHandler to rotate.

* Issue #14971: unittest test discovery no longer gets confused when
  a function has a different __name__ than its name in the TestCase
  class dictionary.

* Issue #17487: The wave getparams method now returns a namedtuple
  rather than a plain tuple.

* Issue #17675: socket repr() provides local and remote addresses
  (if any). Patch by Giampaolo Rodola'

* Issue #17093: Make the ABCs in importlib.abc provide default
  values or raise reasonable exceptions for their methods to make them
  more amenable to super() calls.

* Issue #17566: Make importlib.abc.Loader.module_repr() optional
  instead of an abstractmethod; now it raises NotImplementedError so
  as to be ignored by default.

* Issue #17678: Remove the use of deprecated method in
  http/cookiejar.py by changing the call to get_origin_req_host() to
  origin_req_host.

* Issue #17666: Fix reading gzip files with an extra field.

* Issue #16475: Support object instancing, recursion and interned
  strings in marshal

* Issue #17502: Process DEFAULT values in mock side_effect that
  returns iterator.

* Issue #16795: On the ast.arguments object, unify vararg with
  varargannotation and kwarg and kwargannotation. Change the column
  offset of ast.Attribute to be at the attribute name.

* Issue #17434: Properly raise a SyntaxError when a string occurs
  between future imports.

* Issue #17117: Import and @importlib.util.set_loader now set
  __loader__ when it has a value of None or the attribute doesn't
  exist.

* Issue #17032: The "global" in the "NameError: global name 'x' is
  not defined" error message has been removed.  Patch by Ram Rachum.

* Issue #18080: When building a C extension module on OS X, if the
  compiler is overriden with the CC environment variable, use the new
  compiler as the default for linking if LDSHARED is not also
  overriden.  This restores Distutils behavior introduced in 3.2.3 and
  inadvertently dropped in 3.3.0.

* Issue #18113: Fixed a refcount leak in the curses.panel module's
  set_userptr() method.  Reported by Atsuo Ishimoto.

* Implement PEP 443 "Single-dispatch generic functions".

* Implement PEP 435 "Adding an Enum type to the Python standard
  library".

* Issue #15596: Faster pickling of unicode strings.

* Issue #17572: Avoid chained exceptions when passing bad directives
  to time.strptime().  Initial patch by Claudiu Popa.

* Issue #17435: threading.Timer's __init__ method no longer uses
  mutable default values for the args and kwargs parameters.

* Issue #17526: fix an IndexError raised while passing code without
  filename to inspect.findsource().  Initial patch by Tyler Doyle.

* Issue #17540: Added style parameter to logging formatter
  configuration by dict.

* Issue #16692: The ssl module now supports TLS 1.1 and TLS 1.2.
  Initial patch by Michele Orrù.

* Issue #17025: multiprocessing: Reduce Queue and SimpleQueue
  contention.

* Issue #17536: Add to webbrowser's browser list: www-browser,
  x-www- browser, iceweasel, iceape.

* Issue #17150: pprint now uses line continuations to wrap long
  string literals.

* Issue #17488: Change the subprocess.Popen bufsize parameter
  default value from unbuffered (0) to buffering (-1) to match the
  behavior existing code expects and match the behavior of the
  subprocess module in Python 2 to avoid introducing hard to track
  down bugs.

* Issue #17521: Corrected non-enabling of logger following two calls
  to fileConfig().

* Issue #17508: Corrected logging MemoryHandler configuration in
  dictConfig() where the target handler wasn't configured first.

* Issue #17209: curses.window.get_wch() now correctly handles
  KeyboardInterrupt (CTRL+c).

* Issue #5713: smtplib now handles 421 (closing connection) error
  codes when sending mail by closing the socket and reporting the 421
  error code via the exception appropriate to the command that
  received the error response.

* Issue #16997: unittest.TestCase now provides a subTest() context
  manager to procedurally generate, in an easy way, small test
  instances.

* Issue #17485: Also delete the Request Content-Length header if the
  data attribute is deleted.  (Follow on to issue Issue #16464).

* Issue #15927: CVS now correctly parses escaped newlines and
  carriage when parsing with quoting turned off.

* Issue #17467: add readline and readlines support to mock_open in
  unittest.mock.

* Issue #13248: removed deprecated and undocumented difflib.isbjunk,
  isbpopular.

* Issue #17192: Update the ctypes module's libffi to v3.0.13.  This
  specifically addresses a stack misalignment issue on x86 and issues
  on some more recent platforms.

* Issue #8862: Fixed curses cleanup when getkey is interrputed by a
  signal.

* Issue #17443: imaplib.IMAP4_stream was using the default
  unbuffered IO in subprocess, but the imap code assumes buffered IO.
  In Python2 this worked by accident.  IMAP4_stream now explicitly
  uses buffered IO.

* Issue #17476: Fixed regression relative to Python2 in undocumented
  pydoc 'allmethods'; it was missing unbound methods on the class.

* Issue #17474: Remove the deprecated methods of Request class.

* Issue #16709: unittest discover order is no-longer filesystem
  specific. Patch by Jeff Ramnani.

* Use the HTTPS PyPI url for upload, overriding any plain HTTP URL
  in pypirc.

* Issue #5024: sndhdr.whichhdr now returns the frame count for WAV
  files rather than -1.

* Issue #17460: Remove the strict argument of HTTPConnection and
  removing the DeprecationWarning being issued from 3.2 onwards.

* Issue #16880: Do not assume _imp.load_dynamic() is defined in the
  imp module.

* Issue #16389: Fixed a performance regression relative to Python
  3.1 in the caching of compiled regular expressions.

* Added missing FeedParser and BytesFeedParser to
  email.parser.__all__.

* Issue #17431: Fix missing import of BytesFeedParser in
  email.parser.

* Issue #12921: http.server's send_error takes an explain argument
  to send more information in response. Patch contributed by Karl.

* Issue #17414: Add timeit, repeat, and default_timer to
  timeit.__all__.

* Issue #1285086: Get rid of the refcounting hack and speed up
  urllib.parse.unquote() and urllib.parse.unquote_to_bytes().

* Issue #17099: Have importlib.find_loader() raise ValueError when
  __loader__ is not set, harmonizing with what happens when the
  attribute is set to None.

* Expose the O_PATH constant in the os module if it is available.

* Issue #17368: Fix an off-by-one error in the Python JSON decoder
  that caused a failure while decoding empty object literals when
  object_pairs_hook was specified.

* Issue #17385: Fix quadratic behavior in threading.Condition.  The
  FIFO queue now uses a deque instead of a list.

* Issue #15806: Add contextlib.ignore().  This creates a context
  manager to ignore specified exceptions, replacing the "except
  SomeException: pass" idiom.

* Issue #14645: The email generator classes now produce output using
  the specified linesep throughout.  Previously if the prolog, epilog,
  or body were stored with a different linesep, that linesep was used.
  This fix corrects an RFC non-compliance issue with
  smtplib.send_message.

* Issue #17278: Fix a crash in heapq.heappush() and heapq.heappop()
  when the list is being resized concurrently.

* Issue #16962: Use getdents64 instead of the obsolete getdents
  syscall in the subprocess module on Linux.

* Issue #16935: unittest now counts the module as skipped if it
  raises SkipTest, instead of counting it as an error.  Patch by
  Zachary Ware.

* Issue #17018: Make Process.join() retry if os.waitpid() fails with
  EINTR.

* Issue #17223: array module: Fix a crasher when converting an array
  containing invalid characters (outside range [U+0000; U+10ffff]) to
  Unicode: repr(array), str(array) and array.tounicode(). Patch
  written by Manuel Jacob.

* Issue #17197: profile/cProfile modules refactored so that code of
  run() and runctx() utility functions is not duplicated in both
  modules.

* Issue #14720: sqlite3: Convert datetime microseconds correctly.
  Patch by Lowe Thiderman.

* Issue #15132: Allow a list for the defaultTest argument of
  unittest.TestProgram. Patch by Jyrki Pulliainen.

* Issue #17225: JSON decoder now counts columns in the first line
  starting with 1, as in other lines.

* Issue #6623: Added explicit DeprecationWarning for ftplib.netrc,
  which has been deprecated and undocumented for a long time.

* Issue #13700: Fix byte/string handling in imaplib authentication
  when an authobject is specified.

* Issue #13153: Tkinter functions now raise TclError instead of
  ValueError when a string argument contains non-BMP character.

* Issue #9669: Protect re against infinite loops on zero-width
  matching in non-greedy repeat.  Patch by Matthew Barnett.

* Issue #13169: The maximal repetition number in a regular
  expression has been increased from 65534 to 2147483647 (on 32-bit
  platform) or 4294967294 (on 64-bit).

* Issue #17143: Fix a missing import in the trace module.  Initial
  patch by Berker Peksag.

* Issue #15220: email.feedparser's line splitting algorithm is now
  simpler and faster.

* Issue #16743: Fix mmap overflow check on 32 bit Windows.

* Issue #16996: webbrowser module now uses shutil.which() to find a
  web-browser on the executable search path.

* Issue #16800: tempfile.gettempdir() no longer left temporary files
  when the disk is full.  Original patch by Amir Szekely.

* Issue #17192: Import libffi-3.0.12.

* Issue #16564: Fixed regression relative to Python2 in the
  operation of email.encoders.encode_7or8bit when used with binary
  data.

* Issue #17052: unittest discovery should use self.testLoader.

* Issue #4591: Uid and gid values larger than 2**31 are supported
  now.

* Issue #17141: random.vonmisesvariate() no longer hangs for large
  kappas.

* Issue #17149: Fix random.vonmisesvariate to always return results
  in [0, 2*math.pi].

* Issue #1470548: XMLGenerator now works with binary output streams.

* Issue #6975: os.path.realpath() now correctly resolves multiple
  nested symlinks on POSIX platforms.

* Issue #13773: sqlite3.connect() gets a new "uri" parameter to pass
  the filename as a URI, allowing to pass custom options.

* Issue #16564: Fixed regression relative to Python2 in the
  operation of email.encoders.encode_noop when used with binary data.

* Issue #10355: The mode, name, encoding and newlines properties now
  work on SpooledTemporaryFile objects even when they have not yet
  rolled over. Obsolete method xreadline (which has never worked in
  Python 3) has been removed.

* Issue #16686: Fixed a lot of bugs in audioop module.  Fixed
  crashes in avgpp(), maxpp() and ratecv().  Fixed an integer overflow
  in add(), bias(), and ratecv().  reverse(), lin2lin() and ratecv()
  no more lose precision for 32-bit samples.  max() and rms() no more
  returns a negative result and various other functions now work
  correctly with 32-bit sample -0x80000000.

* Issue #17073: Fix some integer overflows in sqlite3 module.

* Issue #16723: httplib.HTTPResponse no longer marked closed when
  the connection is automatically closed.

* Issue #15359: Add CAN_BCM protocol support to the socket module.
  Patch by Brian Thorne.

* Issue #16948: Fix quoted printable body encoding for non-latin1
  character sets in the email package.

* Issue #16811: Fix folding of headers with no value in the
  provisional email policies.

* Issue #17132: Update symbol for "yield from" grammar changes.

* Issue #17076: Make copying of xattrs more tolerant of missing FS
  support. Patch by Thomas Wouters.

* Issue #17089: Expat parser now correctly works with string input
  when the internal XML encoding is not UTF-8 or US-ASCII.  It also
  now accepts bytes and strings larger than 2 GiB.

* Issue #6083: Fix multiple segmentation faults occured when
  PyArg_ParseTuple parses nested mutating sequence.

* Issue #5289: Fix ctypes.util.find_library on Solaris.

* Issue #17106: Fix a segmentation fault in io.TextIOWrapper when an
  underlying stream or a decoder produces data of an unexpected type
  (i.e. when io.TextIOWrapper initialized with text stream or use
  bytes-to-bytes codec).

* Issue #17015: When it has a spec, a Mock object now inspects its
  signature when matching calls, so that arguments can be matched
  positionally or by name.

* Issue #15633: httplib.HTTPResponse is now mark closed when the
  server sends less than the advertised Content-Length.

* Issue #12268: The io module file object write methods no longer
  abort early when one of its write system calls is interrupted
  (EINTR).

* Issue #6972: The zipfile module no longer overwrites files outside
  of its destination path when extracting malicious zip files.

* Issue #4844: ZipFile now raises BadZipFile when opens a ZIP file
  with an incomplete "End of Central Directory" record.  Original
  patch by Guilherme Polo and Alan McIntyre.

* Issue #17071: Signature.bind() now works when one of the keyword
  arguments is named "self".

* Issue #12004: Fix an internal error in PyZipFile when writing an
  invalid Python file.  Patch by Ben Morgan.

* Have py_compile use importlib as much as possible to avoid code
  duplication. Code now raises FileExistsError if the file path to be
  used for the byte-compiled file is a symlink or non-regular file as
  a warning that import will not keep the file path type if it writes
  to that path.

* Issue #16972: Have site.addpackage() consider already known paths
  even when none are explicitly passed in. Bug report and fix by
  Kirill.

* Issue #1602133: on Mac OS X a shared library build ("--enable-
  shared") now fills the "os.environ" variable correctly.

* Issue #15505: "unittest.installHandler" no longer assumes SIGINT
  handler is set to a callable object.

* Issue #13454: Fix a crash when deleting an iterator created by
  itertools.tee() if all other iterators were very advanced before.

* Issue #12411: Fix to cgi.parse_multipart to correctly use bytes
  boundaries and bytes data. Patch by Jonas Wagner.

* Issue #16957: shutil.which() no longer searches a bare file name
  in the current directory on Unix and no longer searches a relative
  file path with a directory part in PATH directories.  Patch by
  Thomas Kluyver.

* Issue #1159051: GzipFile now raises EOFError when reading a
  corrupted file with truncated header or footer.

* Issue #16993: shutil.which() now preserves the case of the path
  and extension on Windows.

* Issue #16992: On Windows in signal.set_wakeup_fd, validate the
  file descriptor argument.

* Issue #16422: For compatibility with the Python version, the C
  version of decimal now uses strings instead of integers for rounding
  mode constants.

* Issue #15861: tkinter now correctly works with lists and tuples
  containing strings with whitespaces, backslashes or unbalanced
  braces.

* Issue #9720: zipfile now writes correct local headers for files
  larger than 4 GiB.

* Issue #16955: Fix the poll() method for multiprocessing's socket
  connections on Windows.

* SSLContext.load_dh_params() now properly closes the input file.

* Issue #15031: Refactor some .pyc management code to cut down on
  code duplication. Thanks to Ronan Lamy for the report and taking an
  initial stab at the problem.

* Issue #16398: Optimize deque.rotate() so that it only moves
  pointers and doesn't touch the underlying data with increfs and
  decrefs.

* Issue #16900: Issue a ResourceWarning when an ssl socket is left
  unclosed.

* Issue #13899: "\A", "\Z", and "\B" now correctly match the A, Z,
  and B literals when used inside character classes (e.g. "'[\A]'").
  Patch by Matthew Barnett.

* Issue #15545: Fix regression in sqlite3's iterdump method where it
  was failing if the connection used a row factory (such as
  sqlite3.Row) that produced unsortable objects. (Regression was
  introduced by fix for 9750).

* fcntl: add F_DUPFD_CLOEXEC constant, available on Linux 2.6.24+.

* Issue #15972: Fix error messages when os functions expecting a
  file name or file descriptor receive the incorrect type.

* Issue #8109: The ssl module now has support for server-side SNI,
  thanks to a "SSLContext.set_servername_callback()" method.  Patch by
  Daniel Black.

* Issue #16860: In tempfile, use O_CLOEXEC when available to set the
  close-on-exec flag atomically.

* Issue #16674: random.getrandbits() is now 20-40% faster for small
  integers.

* Issue #16009: JSON error messages now provide more information.

* Issue #16828: Fix error incorrectly raised by bz2.compress(b'')
  and bz2.BZ2Compressor.compress(b''). Initial patch by Martin
  Packman.

* Issue #16833: In http.client.HTTPConnection, do not concatenate
  the request headers and body when the payload exceeds 16 KB, since
  it can consume more memory for no benefit.  Patch by Benno Leslie.

* Issue #16541: tk_setPalette() now works with keyword arguments.

* Issue #16820: In configparser, "parser.popitem()" no longer raises
  ValueError. This makes "parser.clean()" work correctly.

* Issue #16820: In configparser, "parser['section'] = {}" now
  preserves section order within the parser. This makes
  "parser.update()" preserve section order as well.

* Issue #16820: In configparser, "parser['DEFAULT'] = {}" now
  correctly clears previous values stored in the default section. Same
  goes for "parser.update({'DEFAULT': {}})".

* Issue #9586: Redefine SEM_FAILED on MacOSX to keep compiler happy.

* Issue #16787: Increase asyncore and asynchat default output
  buffers size, to decrease CPU usage and increase throughput.

* Issue #10527: make multiprocessing use poll() instead of select()
  if available.

* Issue #16688: Now regexes contained backreferences correctly work
  with non-ASCII strings.  Patch by Matthew Barnett.

* Issue #16486: Make aifc files act as context managers.

* Issue #16485: Now file descriptors are closed if file header
  patching failed on closing an aifc file.

* Issue #16640: Run less code under a lock in sched module.

* Issue #16165: sched.scheduler.run() no longer blocks a scheduler
  for other threads.

* Issue #16641: Default values of sched.scheduler.enter() are no
  longer modifiable.

* Issue #16618: Make glob.glob match consistently across strings and
  bytes regarding leading dots.  Patch by Serhiy Storchaka.

* Issue #16788: Add samestat to Lib/ntpath.py

* Issue #16713: Parsing of 'tel' urls using urlparse separates
  params from path.

* Issue #16443: Add docstrings to regular expression match objects.
  Patch by Anton Kasyanov.

* Issue #15701: Fix HTTPError info method call to return the headers
  information.

* Issue #16752: Add a missing import to modulefinder. Patch by
  Berker Peksag.

* Issue #16646: ftplib.FTP.makeport() might lose socket error
  details. (patch by Serhiy Storchaka)

* Issue #16626: Fix infinite recursion in glob.glob() on Windows
  when the pattern contains a wildcard in the drive or UNC path.
  Patch by Serhiy Storchaka.

* Issue #15783: Except for the number methods, the C version of
  decimal now supports all None default values present in decimal.py.
  These values were largely undocumented.

* Issue #11175: argparse.FileType now accepts encoding and errors
  arguments. Patch by Lucas Maystre.

* Issue #16488: epoll() objects now support the "with" statement.
  Patch by Serhiy Storchaka.

* Issue #16298: In HTTPResponse.read(), close the socket when there
  is no Content-Length and the incoming stream is finished.  Patch by
  Eran Rundstein.

* Issue #16049: Add abc.ABC class to enable the use of inheritance
  to create ABCs, rather than the more cumbersome metaclass=ABCMeta.
  Patch by Bruno Dupuis.

* Expose the TCP_FASTOPEN and MSG_FASTOPEN flags in socket when
  they're available.

* Issue #15701: Add a .headers attribute to urllib.error.HTTPError.
  Patch contributed by Berker Peksag.

* Issue #15872: Fix 3.3 regression introduced by the new fd-based
  shutil.rmtree that caused it to not ignore certain errors when
  ignore_errors was set. Patch by Alessandro Moura and Serhiy
  Storchaka.

* Issue #16248: Disable code execution from the user's home
  directory by tkinter when the -E flag is passed to Python.  Patch by
  Zachary Ware.

* Issue #13390: New function "sys.getallocatedblocks()" returns the
  number of memory blocks currently allocated.

* Issue #16628: Fix a memory leak in ctypes.resize().

* Issue #13614: Fix setup.py register failure with invalid rst in
  description. Patch by Julien Courteau and Pierre Paul Lefebvre.

* Issue #13512: Create ~/.pypirc securely (CVE-2011-4944).  Initial
  patch by Philip Jenvey, tested by Mageia and Debian.

* Issue #7719: Make distutils ignore ".nfs*" files instead of
  choking later on.  Initial patch by SilentGhost and Jeff Ramnani.

* Issue #13120: Allow to call pdb.set_trace() from thread. Patch by
  Ilya Sandler.

* Issue #16585: Make CJK encoders support error handlers that return
  bytes per PEP 383.

* Issue #10182: The re module doesn't truncate indices to 32 bits
  anymore. Patch by Serhiy Storchaka.

* Issue #16333: use (",", ": ") as default separator in json when
  indent is specified, to avoid trailing whitespace.  Patch by Serhiy
  Storchaka.

* Issue #16573: In 2to3, treat enumerate() like a consuming call, so
  superfluous list() calls aren't added to filter(), map(), and zip()
  which are directly passed enumerate().

* Issue #16464: Reset the Content-Length header when a urllib
  Request is reused with new data.

* Issue #12848: The pure Python pickle implementation now treats
  object lengths as unsigned 32-bit integers, like the C
  implementation does. Patch by Serhiy Storchaka.

* Issue #16423: urllib.request now has support for "data:" URLs.
  Patch by Mathias Panzenböck.

* Issue #4473: Add a POP3.stls() to switch a clear-text POP3 session
  into an encrypted POP3 session, on supported servers.  Patch by
  Lorenzo Catucci.

* Issue #4473: Add a POP3.capa() method to query the capabilities
  advertised by the POP3 server.  Patch by Lorenzo Catucci.

* Issue #4473: Ensure the socket is shutdown cleanly in
  POP3.close(). Patch by Lorenzo Catucci.

* Issue #16522: added FAIL_FAST flag to doctest.

* Issue #15627: Add the importlib.abc.InspectLoader.source_to_code()
  method.

* Issue #16408: Fix file descriptors not being closed in error
  conditions in the zipfile module.  Patch by Serhiy Storchaka.

* Issue #14631: Add a new "weakref.WeakMethod" to simulate weak
  references to bound methods.

* Issue #16469: Fix exceptions from float -> Fraction and Decimal ->
  Fraction conversions for special values to be consistent with those
  for float -> int and Decimal -> int.  Patch by Alexey Kachayev.

* Issue #16481: multiprocessing no longer leaks process handles on
  Windows.

* Issue #12428: Add a pure Python implementation of
  functools.partial(). Patch by Brian Thorne.

* Issue #16140: The subprocess module no longer double closes its
  child subprocess.PIPE parent file descriptors on child error prior
  to exec().

* Remove a bare print to stdout from the subprocess module that
  could have happened if the child process wrote garbage to its pre-
  exec error pipe.

* The subprocess module now raises its own SubprocessError instead
  of a RuntimeError in various error situations which should not
  normally happen.

* Issue #16327: The subprocess module no longer leaks file
  descriptors used for stdin/stdout/stderr pipes to the child when
  fork() fails.

* Issue #14396: Handle the odd rare case of waitpid returning 0 when
  not expected in subprocess.Popen.wait().

* Issue #16411: Fix a bug where zlib.decompressobj().flush() might
  try to access previously-freed memory. Patch by Serhiy Storchaka.

* Issue #16357: fix calling accept() on a SSLSocket created through
  SSLContext.wrap_socket().  Original patch by Jeff McNeil.

* Issue #16409: The reporthook callback made by the legacy
  urllib.request.urlretrieve API now properly supplies a constant non-
  zero block_size as it did in Python 3.2 and 2.7.  This matches the
  behavior of urllib.request.URLopener.retrieve.

* Issue #16431: Use the type information when constructing a Decimal
  subtype from a Decimal argument.

* Issue #15641: Clean up deprecated classes from importlib. Patch by
  Taras Lyapun.

* Issue #16350: zlib.decompressobj().decompress() now accumulates
  data from successive calls after EOF in unused_data, instead of only
  saving the argument to the last call. decompressobj().flush() now
  correctly sets unused_data and unconsumed_tail. A bug in the
  handling of MemoryError when setting the unconsumed_tail attribute
  has also been fixed. Patch by Serhiy Storchaka.

* Issue #12759: sre_parse now raises a proper error when the name of
  the group is missing.  Initial patch by Serhiy Storchaka.

* Issue #16152: fix tokenize to ignore whitespace at the end of the
  code when no newline is found.  Patch by Ned Batchelder.

* Issue #16284: Prevent keeping unnecessary references to worker
  functions in concurrent.futures ThreadPoolExecutor.

* Issue #16230: Fix a crash in select.select() when one the lists
  changes size while iterated on.  Patch by Serhiy Storchaka.

* Issue #16228: Fix a crash in the json module where a list changes
  size while it is being encoded.  Patch by Serhiy Storchaka.

* Issue #16351: New function gc.get_stats() returns per-generation
  collection statistics.

* Issue #14897: Enhance error messages of struct.pack and
  struct.pack_into. Patch by Matti Mäki.

* Issue #16316: mimetypes now recognizes the .xz and .txz (.tar.xz)
  extensions. Patch by Serhiy Storchaka.

* Issue #12890: cgitb no longer prints spurious <p> tags in text
  mode when the logdir option is specified.

* Issue #16307: Fix multiprocessing.Pool.map_async not calling its
  callbacks. Patch by Janne Karila.

* Issue #16305: Fix a segmentation fault occurring when interrupting
  math.factorial.

* Issue #16116: Fix include and library paths to be correct when
  building C extensions in venvs.

* Issue #16245: Fix the value of a few entities in
  html.entities.html5.

* Issue #16301: Fix the localhost verification in urllib/request.py
  for file:// urls.

* Issue #16250: Fix the invocations of URLError which had misplaced
  filename attribute for exception.

* Issue #10836: Fix exception raised when file not found in
  urlretrieve Initial patch by Ezio Melotti.

* Issue #14398: Fix size truncation and overflow bugs in the bz2
  module.

* Issue #12692: Fix resource leak in urllib.request when talking to
  an HTTP server that does not include a "Connection: close" header in
  its responses.

* Issue #12034: Fix bogus caching of result in
  check_GetFinalPathNameByHandle. Patch by Atsuo Ishimoto.

* Improve performance of "lzma.LZMAFile" (see also issue #16034).

* Issue #16220: wsgiref now always calls close() on an iterable
  response. Patch by Brent Tubbs.

* Issue #16270: urllib may hang when used for retrieving files via
  FTP by using a context manager.  Patch by Giampaolo Rodola'.

* Issue #16461: Wave library should be able to deal with 4GB wav
  files, and sample rate of 44100 Hz.

* Issue #16176: Properly identify Windows 8 via platform.platform()

* Issue #16088: BaseHTTPRequestHandler's send_error method includes
  a Content-Length header in it's response now. Patch by Antoine
  Pitrou.

* Issue #16114: The subprocess module no longer provides a
  misleading error message stating that args[0] did not exist when
  either the cwd or executable keyword arguments specified a path that
  did not exist.

* Issue #16169: Fix ctypes.WinError()'s confusion between errno and
  winerror.

* Issue #16110: logging.fileConfig now accepts a pre-initialised
  ConfigParser instance.

* Issue #1492704: shutil.copyfile() raises a distinct SameFileError
  now if source and destination are the same file. Patch by Atsuo
  Ishimoto.

* Issue #13896: Make shelf instances work with 'with' as context
  managers. Original patch by Filip Gruszczyński.

* Issue #15417: Add support for csh and fish in venv activation
  scripts.

* Issue #14377: ElementTree.write and some of the module-level
  functions have a new parameter - *short_empty_elements*. It controls
  how elements with no contents are emitted.

* Issue #16089: Allow ElementTree.TreeBuilder to work again with a
  non-Element element_factory (fixes a regression in SimpleTAL).

* Issue #9650: List commonly used format codes in time.strftime and
  time.strptime docsttings.  Original patch by Mike Hoy.

* Issue #15452: logging configuration socket listener now has a
  verify option that allows an application to apply a verification
  function to the received configuration data before it is acted upon.

* Issue #16034: Fix performance regressions in the new "bz2.BZ2File"
  implementation.  Initial patch by Serhiy Storchaka.

* "pty.spawn()" now returns the child process status returned by
  "os.waitpid()".

* Issue #15756: "subprocess.poll()" now properly handles
  "errno.ECHILD" to return a returncode of 0 when the child has
  already exited or cannot be waited on.

* Issue #15323: Improve failure message of
  "Mock.assert_called_once_with()".

* Issue #16064: "unittest -m" claims executable is "python", not
  "python3".

* Issue #12376: Pass on parameters in "TextTestResult.__init__()"
  super call.

* Issue #15222: Insert blank line after each message in mbox
  mailboxes.

* Issue #16013: Fix "csv.Reader" parsing issue with ending quote
  characters. Patch by Serhiy Storchaka.

* Issue #15421: Fix an OverflowError in "Calendar.itermonthdates()"
  after "datetime.MAXYEAR".  Patch by Cédric Krier.

* Issue #16112: platform.architecture does not correctly escape
  argument to /usr/bin/file.  Patch by David Benjamin.

* Issue #15970: "xml.etree.ElementTree" now serializes correctly the
  empty HTML elements 'meta' and 'param'.

* Issue #15842: The "SocketIO.{readable,writable,seekable}" methods
  now raise ValueError when the file-like object is closed.  Patch by
  Alessandro Moura.

* Issue #15876: Fix a refleak in the "curses" module:
  window.encoding.

* Issue #15881: Fix "atexit" hook in "multiprocessing".  Original
  patch by Chris McDonough.

* Issue #15841: The readable(), writable() and seekable() methods of
  "io.BytesIO" and "io.StringIO" objects now raise ValueError when the
  object has been closed.  Patch by Alessandro Moura.

* Issue #15447: Use "subprocess.DEVNULL" in webbrowser, instead of
  opening "os.devnull" explicitly and leaving it open.

* Issue #15509: "webbrowser.UnixBrowser" no longer passes empty
  arguments to Popen when "%action" substitutions produce empty
  strings.

* Issue #12776, issue #11839: Call "argparse" type function
  (specified by add_argument) only once. Before, the type function was
  called twice in the case where the default was specified and the
  argument was given as well.  This was especially problematic for the
  FileType type, as a default file would always be opened, even if a
  file argument was specified on the command line.

* Issue #15906: Fix a regression in argparse caused by the preceding
  change, when "action='append'", "type='str'" and "default=[]".

* Issue #16113: Added sha3 module based on the Keccak reference
  implementation 3.2. The "hashlib" module has four additional hash
  algorithms: "sha3_224", "sha3_256", "sha3_384" and "sha3_512". As
  part of the patch some common code was moved from _hashopenssl.c to
  hashlib.h.

* ctypes.call_commethod was removed, since its only usage was in the
  defunct samples directory.

* Issue #16692: Added TLSv1.1 and TLSv1.2 support for the ssl
  modules.

* Issue #16832: add abc.get_cache_token() to expose cache validity
  checking support in ABCMeta.


IDLE
----

* Issue #18429: Format / Format Paragraph, now works when comment
  blocks are selected. As with text blocks, this works best when the
  selection only includes complete lines.

* Issue #18226: Add docstrings and unittests for FormatParagraph.py.
  Original patches by Todd Rovito and Phil Webster.

* Issue #18279: Format - Strip trailing whitespace no longer marks a
  file as changed when it has not been changed. This fix followed the
  addition of a test file originally written by Phil Webster (the
  issue's main goal).

* Issue #7136: In the Idle File menu, "New Window" is renamed "New
  File". Patch by Tal Einat, Roget Serwy, and Todd Rovito.

* Remove dead imports of imp.

* Issue #18196: Avoid displaying spurious SystemExit tracebacks.

* Issue #5492: Avoid traceback when exiting IDLE caused by a race
  condition.

* Issue #17511: Keep IDLE find dialog open after clicking "Find
  Next". Original patch by Sarah K.

* Issue #18055: Move IDLE off of imp and on to importlib.

* Issue #15392: Create a unittest framework for IDLE. Initial patch
  by Rajagopalasarma Jayakrishnan. See
  Lib/idlelib/idle_test/README.txt for how to run Idle tests.

* Issue #14146: Highlight source line while debugging on Windows.

* Issue #17838: Allow sys.stdin to be reassigned.

* Issue #13495: Avoid loading the color delegator twice in IDLE.

* Issue #17798: Allow IDLE to edit new files when specified on
  command line.

* Issue #14735: Update IDLE docs to omit "Control-z on Windows".

* Issue #17532: Always include Options menu for IDLE on OS X. Patch
  by Guilherme Simões.

* Issue #17585: Fixed IDLE regression. Now closes when using exit()
  or quit().

* Issue #17657: Show full Tk version in IDLE's about dialog. Patch
  by Todd Rovito.

* Issue #17613: Prevent traceback when removing syntax colorizer in
  IDLE.

* Issue #1207589: Backwards-compatibility patch for right-click menu
  in IDLE.

* Issue #16887: IDLE now accepts Cancel in tabify/untabify dialog
  box.

* Issue #17625: In IDLE, close the replace dialog after it is used.

* Issue #14254: IDLE now handles readline correctly across shell
  restarts.

* Issue #17614: IDLE no longer raises exception when quickly closing
  a file.

* Issue #6698: IDLE now opens just an editor window when configured
  to do so.

* Issue #8900: Using keyboard shortcuts in IDLE to open a file no
  longer raises an exception.

* Issue #6649: Fixed missing exit status in IDLE. Patch by Guilherme
  Polo.

* Issue #17114: IDLE now uses non-strict config parser.

* Issue #9290: In IDLE the sys.std* streams now implement
  io.TextIOBase interface and support all mandatory methods and
  properties.

* Issue #5066: Update IDLE docs. Patch by Todd Rovito.

* Issue #16829: IDLE printing no longer fails if there are spaces or
  other special characters in the file path.

* Issue #16491: IDLE now prints chained exception tracebacks.

* Issue #16819: IDLE method completion now correctly works for bytes
  literals.

* Issue #16504: IDLE now catches SyntaxErrors raised by tokenizer.
  Patch by Roger Serwy.

* Issue #16511: Use default IDLE width and height if config param is
  not valid. Patch Serhiy Storchaka.

* Issue #1207589: Add Cut/Copy/Paste items to IDLE right click
  Context Menu. Patch by Todd Rovito.

* Issue #16123: IDLE - deprecate running without a subprocess. Patch
  by Roger Serwy.


Tests
-----

* Issue #1666318: Add a test that shutil.copytree() retains
  directory permissions.  Patch by Catherine Devlin.

* Issue #18273: move the tests in Lib/test/json_tests to
  Lib/test/test_json and make them discoverable by unittest.  Patch by
  Zachary Ware.

* Fix a fcntl test case on KFreeBSD, Debian #708653 (Petr Salinger).

* Issue #18396: Fix spurious test failure in test_signal on Windows
  when faulthandler is enabled (Patch by Jeremy Kloth)

* Issue #17046: Fix broken test_executable_without_cwd in
  test_subprocess.

* Issue #15415: Add new temp_dir() and change_cwd() context managers
  to test.support, and refactor temp_cwd() to use them.  Patch by
  Chris Jerdonek.

* Issue #15494: test.support is now a package rather than a module
  (Initial patch by Indra Talip)

* Issue #17944: test_zipfile now discoverable and uses subclassing
  to generate tests for different compression types.  Fixed a bug with
  skipping some tests due to use of exhausted iterators.

* Issue #18266: test_largefile now works with unittest test
  discovery and supports running only selected tests.  Patch by
  Zachary Ware.

* Issue #17767: test_locale now works with unittest test discovery.
  Original patch by Zachary Ware.

* Issue #18375: Assume --randomize when --randseed is used for
  running the testsuite.

* Issue #11185: Fix test_wait4 under AIX.  Patch by Sébastien Sablé.

* Issue #18207: Fix test_ssl for some versions of OpenSSL that
  ignore seconds in ASN1_TIME fields.

* Issue #18094: test_uuid no longer reports skipped tests as passed.

* Issue #17992: Add timeouts to asyncore and asynchat tests so that
  they won't accidentally hang.

* Issue #17833: Fix test_gdb failures seen on machines where debug
  symbols for glibc are available (seen on PPC64 Linux).

* Issue #7855: Add tests for ctypes/winreg for issues found in
  IronPython. Initial patch by Dino Viehland.

* Issue #11078: test___all__ now checks for duplicates in __all__.
  Initial patch by R. David Murray.

* Issue #17712: Fix test_gdb failures on Ubuntu 13.04.

* Issue #17835: Fix test_io when the default OS pipe buffer size is
  larger than one million bytes.

* Issue #17065: Use process-unique key for winreg tests to avoid
  failures if test is run multiple times in parallel (eg: on a
  buildbot host).

* Issue #12820: add tests for the xml.dom.minicompat module. Patch
  by John Chandler and Phil Connell.

* Issue #17691: test_univnewlines now works with unittest test
  discovery. Patch by Zachary Ware.

* Issue #17790: test_set now works with unittest test discovery.
  Patch by Zachary Ware.

* Issue #17789: test_random now works with unittest test discovery.
  Patch by Zachary Ware.

* Issue #17779: test_osx_env now works with unittest test discovery.
  Patch by Zachary Ware.

* Issue #17766: test_iterlen now works with unittest test discovery.
  Patch by Zachary Ware.

* Issue #17690: test_time now works with unittest test discovery.
  Patch by Zachary Ware.

* Issue #17692: test_sqlite now works with unittest test discovery.
  Patch by Zachary Ware.

* Issue #11995: test_pydoc doesn't import all sys.path modules
  anymore.

* Issue #17448: test_sax now skips if there are no xml parsers
  available instead of raising an ImportError.

* Issue #11420: make test suite pass with -B/DONTWRITEBYTECODE set.
  Initial patch by Thomas Wouters.

* Issue #10652: make tcl/tk tests run after __all__ test, patch by
  Zachary Ware.

* Issue #11963: remove human verification from test_parser and
  test_subprocess.

* Issue #11732: add a new suppress_crash_popup() context manager to
  test.support that disables crash popups on Windows and use it in
  test_faulthandler and test_capi.

* Issue #13898: test_ssl no longer prints a spurious stack trace on
  Ubuntu.

* Issue #17283: Share code between "__main__.py" and "regrtest.py"
  in "Lib/test".

* Issue #17249: convert a test in test_capi to use unittest and reap
  threads.

* Issue #17107: Test client-side SNI support in urllib.request
  thanks to the new server-side SNI support in the ssl module.
  Initial patch by Daniel Black.

* Issue #17041: Fix testing when Python is configured with the
  --without-doc-strings.

* Issue #16923: Fix ResourceWarnings in test_ssl.

* Issue #15539: Added regression tests for Tools/scripts/pindent.py.

* Issue #17479: test_io now works with unittest test discovery.
  Patch by Zachary Ware.

* Issue #17066: test_robotparser now works with unittest test
  discovery. Patch by Zachary Ware.

* Issue #17334: test_index now works with unittest test discovery.
  Patch by Zachary Ware.

* Issue #17333: test_imaplib now works with unittest test discovery.
  Patch by Zachary Ware.

* Issue #17082: test_dbm* now work with unittest test discovery.
  Patch by Zachary Ware.

* Issue #17079: test_ctypes now works with unittest test discovery.
  Patch by Zachary Ware.

* Issue #17304: test_hash now works with unittest test discovery.
  Patch by Zachary Ware.

* Issue #17303: test_future* now work with unittest test discovery.
  Patch by Zachary Ware.

* Issue #17163: test_file now works with unittest test discovery.
  Patch by Zachary Ware.

* Issue #16925: test_configparser now works with unittest test
  discovery. Patch by Zachary Ware.

* Issue #16918: test_codecs now works with unittest test discovery.
  Patch by Zachary Ware.

* Issue #16919: test_crypt now works with unittest test discovery.
  Patch by Zachary Ware.

* Issue #16910: test_bytes, test_unicode, and test_userstring now
  work with unittest test discovery.  Patch by Zachary Ware.

* Issue #16905: test_warnings now works with unittest test
  discovery. Initial patch by Berker Peksag.

* Issue #16898: test_bufio now works with unittest test discovery.
  Patch by Zachary Ware.

* Issue #16888: test_array now works with unittest test discovery.
  Patch by Zachary Ware.

* Issue #16896: test_asyncore now works with unittest test
  discovery. Patch by Zachary Ware.

* Issue #16897: test_bisect now works with unittest test discovery.
  Initial patch by Zachary Ware.

* Issue #16852: test_genericpath, test_posixpath, test_ntpath, and
  test_macpath now work with unittest test discovery.  Patch by
  Zachary Ware.

* Issue #16748: test_heapq now works with unittest test discovery.

* Issue #10646: Tests rearranged for os.samefile/samestat to check
  for not just symlinks but also hard links.

* Issue #15302: Switch regrtest from using getopt to using argparse.

* Issue #15324: Fix regrtest parsing of --fromfile, --match, and
  --randomize options.

* Issue #16702: test_urllib2_localnet tests now correctly ignores
  proxies for localhost tests.

* Issue #16664: Add regression tests for glob's behaviour concerning
  entries starting with a ".".  Patch by Sebastian Kreft.

* Issue #13390: The "-R" option to regrtest now also checks for
  memory allocation leaks, using "sys.getallocatedblocks()".

* Issue #16559: Add more tests for the json module, including some
  from the official test suite at json.org.  Patch by Serhiy
  Storchaka.

* Issue #16661: Fix the "os.getgrouplist()" test by not assuming
  that it gives the same output as **id -G**.

* Issue #16115: Add some tests for the executable argument to
  subprocess.Popen().  Initial patch by Kushal Das.

* Issue #16126: PyErr_Format format mismatch in _testcapimodule.c.
  Patch by Serhiy Storchaka.

* Issue #15304: Fix warning message when "os.chdir()" fails inside
  "test.support.temp_cwd()".  Patch by Chris Jerdonek.

* Issue #15802: Fix test logic in "TestMaildir.test_create_tmp()".
  Patch by Serhiy Storchaka.

* Issue #15557: Added a test suite for the webbrowser module, thanks
  to Anton Barkovsky.

* Issue #16698: Skip posix test_getgroups when built with OS X
  deployment target prior to 10.6.


Build
-----

* Issue #16067: Add description into MSI file to replace installer's
  temporary name.

* Issue #18257: Fix readlink usage in python-config.  Install the
  python version again on Darwin.

* Issue #18481: Add C coverage reporting with gcov and lcov. A new
  make target "coverage-report" creates an instrumented Python build,
  runs unit tests and creates a HTML. The report can be updated with
  "make coverage-lcov".

* Issue #17845: Clarified the message printed when some module are
  not built.

* Issue #18256: Compilation fix for recent AIX releases.  Patch by
  David Edelsohn.

* Issue #17547: In configure, explicitly pass -Wformat for the
  benefit for GCC 4.8.

* Issue #15172: Document NASM 2.10+ as requirement for building
  OpenSSL 1.0.1 on Windows.

* Issue #17591: Use lowercase filenames when including Windows
  header files. Patch by Roumen Petrov.

* Issue #17550: Fix the --enable-profiling configure switch.

* Issue #17425: Build with openssl 1.0.1d on Windows.

* Issue #16754: Fix the incorrect shared library extension on linux.
  Introduce two makefile macros SHLIB_SUFFIX and EXT_SUFFIX. SO now
  has the value of SHLIB_SUFFIX again (as in 2.x and 3.1). The SO
  macro is removed in 3.4.

* Issue #5033: Fix building of the sqlite3 extension module when the
  SQLite library version has "beta" in it. Patch by Andreas Pelme.

* Issue #17228: Fix building without pymalloc.

* Issue #3718: Use AC_ARG_VAR to set MACHDEP in configure.ac.

* Issue #16235: Implement python-config as a shell script.

* Issue #16769: Remove outdated Visual Studio projects.

* Issue #17031: Fix running regen in cross builds.

* Issue #3754: fix typo in pthread AC_CACHE_VAL.

* Issue #15484: Fix _PYTHON_PROJECT_BASE for srcdir != builddir
  builds; use _PYTHON_PROJECT_BASE in distutils/sysconfig.py.

* Drop support for Windows 2000 (changeset e52df05b496a).

* Issue #17029: Let h2py search the multiarch system include
  directory.

* Issue #16953: Fix socket module compilation on platforms with
  HAVE_BROKEN_POLL. Patch by Jeffrey Armstrong.

* Issue #16320: Remove redundant Makefile dependencies for strings
  and bytes.

* Cross compiling needs host and build settings. configure no longer
  creates a broken PYTHON_FOR_BUILD variable when --build is missing.

* Fix cross compiling issue in setup.py, ensure that lib_dirs and
  inc_dirs are defined in cross compiling mode, too.

* Issue #16836: Enable IPv6 support even if IPv6 is disabled on the
  build host.

* Issue #16593: Have BSD 'make -s' do the right thing, thanks to
  Daniel Shahaf

* Issue #16262: fix out-of-src-tree builds, if mercurial is not
  installed.

* Issue #15298: ensure _sysconfigdata is generated in build
  directory, not source directory.

* Issue #15833: Fix a regression in 3.3 that resulted in exceptions
  being raised if importlib failed to write byte-compiled files.  This
  affected attempts to build Python out-of-tree from a read-only
  source directory.

* Issue #15923: Fix a mistake in "asdl_c.py" that resulted in a
  TypeError after 2801bf875a24 (see #15801).

* Issue #16135: Remove OS/2 support.

* Issue #15819: Make sure we can build Python out-of-tree from a
  read- only source directory.  (Somewhat related to issue #9860.)

* Issue #15587: Enable Tk high-resolution text rendering on Macs
  with Retina displays.  Applies to Tkinter apps, such as IDLE, on OS
  X framework builds linked with Cocoa Tk 8.5.

* Issue #17161: make install now also installs a python3 man page.


C-API
-----

* Issue #18351: Fix various issues in a function in importlib
  provided to help PyImport_ExecCodeModuleWithPathnames() (and thus by
  extension PyImport_ExecCodeModule() and
  PyImport_ExecCodeModuleEx()).

* Issue #9369: The types of "char*" arguments of
  PyObject_CallFunction() and PyObject_CallMethod() now changed to
  "const char*".  Based on patches by Jörg Müller and Lars Buitinck.

* Issue #17206: Py_CLEAR(), Py_DECREF(), Py_XINCREF() and
  Py_XDECREF() now expand their arguments once instead of multiple
  times.  Patch written by Illia Polosukhin.

* Issue #17522: Add the PyGILState_Check() API.

* Issue #17327: Add PyDict_SetDefault.

* Issue #16881: Fix Py_ARRAY_LENGTH macro for GCC < 3.1.

* Issue #16505: Remove unused Py_TPFLAGS_INT_SUBCLASS.

* Issue #16086: PyTypeObject.tp_flags and PyType_Spec.flags are now
  unsigned (unsigned long and unsigned int) to avoid an undefined
  behaviour with Py_TPFLAGS_TYPE_SUBCLASS ((1 << 31).
  PyType_GetFlags() result type is now unsigned too (unsigned long,
  instead of long).

* Issue #16166: Add PY_LITTLE_ENDIAN and PY_BIG_ENDIAN macros and
  unified endianness detection and handling.


Documentation
-------------

* Issue #17701: Improving strftime documentation.

* Issue #18440: Clarify that "hash()" can truncate the value
  returned from an object's custom "__hash__()" method.

* Issue #17844: Add links to encoders and decoders for bytes-to-
  bytes codecs.

* Issue #14097: improve the "introduction" page of the tutorial.

* Issue #17977: The documentation for the cadefault argument's
  default value in urllib.request.urlopen() is fixed to match the
  code.

* Issue #6696: add documentation for the Profile objects, and
  improve profile/cProfile docs.  Patch by Tom Pinckney.

* Issue #15940: Specify effect of locale on time functions.

* Issue #17538: Document XML vulnerabilties

* Issue #16642: sched.scheduler timefunc initial default is
  time.monotonic. Patch by Ramchandra Apte

* Issue #17047: remove doubled words in docs and docstrings reported
  by Serhiy Storchaka and Matthew Barnett.

* Issue #15465: Document the versioning macros in the C API docs
  rather than the standard library docs. Patch by Kushal Das.

* Issue #16406: Combine the pages for uploading and registering to
  PyPI.

* Issue #16403: Document how distutils uses the maintainer field in
  PKG-INFO. Patch by Jyrki Pulliainen.

* Issue #16695: Document how glob handles filenames starting with a
  dot. Initial patch by Jyrki Pulliainen.

* Issue #8890: Stop advertising an insecure practice by replacing
  uses of the /tmp directory with better alternatives in the
  documentation. Patch by Geoff Wilson.

* Issue #17203: add long option names to unittest discovery docs.

* Issue #13094: add "Why do lambdas defined in a loop with different
  values all return the same result?" programming FAQ.

* Issue #14901: Update portions of the Windows FAQ. Patch by Ashish
  Nitin Patil.

* Issue #16267: Better document the 3.3+ approach to combining
  @abstractmethod with @staticmethod, @classmethod and @property

* Issue #15209: Clarify exception chaining description in exceptions
  module documentation

* Issue #15990: Improve argument/parameter documentation.

* Issue #16209: Move the documentation for the str built-in function
  to a new str class entry in the "Text Sequence Type" section.

* Issue #13538: Improve str() and object.__str__() documentation.

* Issue #16489: Make it clearer that importlib.find_loader() needs
  parent packages to be explicitly imported.

* Issue #16400: Update the description of which versions of a given
  package PyPI displays.

* Issue #15677: Document that zlib and gzip accept a compression
  level of 0 to mean 'no compression'. Patch by Brian Brazil.

* Issue #16197: Update winreg docstrings and documentation to match
  code. Patch by Zachary Ware.

* Issue #8040: added a version switcher to the documentation.  Patch
  by Yury Selivanov.

* Issue #16241: Document -X faulthandler command line option. Patch
  by Marek Šuppa.

* Additional comments and some style changes in the
  concurrent.futures URL retrieval example

* Issue #16115: Improve subprocess.Popen() documentation around
  args, shell, and executable arguments.

* Issue #13498: Clarify docs of os.makedirs()'s exist_ok argument.
  Done with great native-speaker help from R. David Murray.

* Issue #15533: Clarify docs and add tests for
  "subprocess.Popen()"'s cwd argument.

* Issue #15979: Improve timeit documentation.

* Issue #16036: Improve documentation of built-in "int()"'s
  signature and arguments.

* Issue #15935: Clarification of "argparse" docs, re: add_argument()
  type and default arguments.  Patch contributed by Chris Jerdonek.

* Issue #11964: Document a change in v3.2 to the behavior of the
  indent parameter of json encoding operations.

* Issue #15116: Remove references to appscript as it is no longer
  being supported.


Tools/Demos
-----------

* Issue #18817: Fix a resource warning in Lib/aifc.py demo.  Patch
  by Vajrasky Kok.

* Issue #18439: Make patchcheck work on Windows for ACKS, NEWS.

* Issue #18448: Fix a typo in Tools/demo/eiffel.py.

* Issue #18457: Fixed saving of formulas and complex numbers in
  Tools/demo/ss1.py.

* Issue #18449: Make Tools/demo/ss1.py work again on Python 3.
  Patch by Févry Thibault.

* Issue #12990: The "Python Launcher" on OSX could not launch python
  scripts that have paths that include wide characters.

* Issue #15239: Make mkstringprep.py work again on Python 3.

* Issue #17028: Allowed Python arguments to be supplied to the
  Windows launcher.

* Issue #17156: pygettext.py now detects the encoding of source
  files and correctly writes and escapes non-ascii characters.

* Issue #15539: Fix a number of bugs in Tools/scripts/pindent.py.
  Now pindent.py works with a "with" statement.  pindent.py no longer
  produces improper indentation.  pindent.py now works with continued
  lines broken after "class" or "def" keywords and with continuations
  at the start of line.

* Issue #11797: Add a 2to3 fixer that maps reload() to imp.reload().

* Issue #10966: Remove the concept of unexpected skipped tests.

* Issue #9893: Removed the Misc/Vim directory.

* Removed the Misc/TextMate directory.

* Issue #16245: Add the Tools/scripts/parse_html5_entities.py script
  to parse the list of HTML5 entities and update the
  html.entities.html5 dictionary.

* Issue #15378: Fix Tools/unicode/comparecodecs.py.  Patch by Serhiy
  Storchaka.

* Issue #16549: Make json.tool work again on Python 3 and add tests.
  Initial patch by Berker Peksag and Serhiy Storchaka.

* Issue #13301: use ast.literal_eval() instead of eval() in
  Tools/i18n/msgfmt.py. Patch by Serhiy Storchaka.


Windows
-------

* Issue #18569: The installer now adds .py to the PATHEXT variable
  when extensions are registered. Patch by Paul Moore.


Python 3.3.0
============

*Release date: 29-Sep-2012*


Core and Builtins
-----------------

* Issue #16046: Fix loading sourceless legacy .pyo files.

* Issue #16060: Fix refcounting bug when "__trunc__()" returns an
  object whose "__int__()" gives a non-integer.  Patch by Serhiy
  Storchaka.


Extension Modules
-----------------

* Issue #16012: Fix a regression in pyexpat. The parser's
  "UseForeignDTD()" method doesn't require an argument again.


Python 3.3.0 Release Candidate 3
================================

*Release date: 23-Sep-2012*


Core and Builtins
-----------------

* Issue #15900: Fix reference leak in
  "PyUnicode_TranslateCharmap()".

* Issue #15926: Fix crash after multiple reinitializations of the
  interpreter.

* Issue #15895: Fix FILE pointer leak in one error branch of
  "PyRun_SimpleFileExFlags()" when filename points to a pyc/pyo file,
  closeit is false an and set_main_loader() fails.

* Fixes for a few crash and memory leak regressions found by
  Coverity.


Library
-------

* Issue #15882: Change "_decimal" to accept any coefficient tuple
  when constructing infinities. This is done for backwards
  compatibility with decimal.py: Infinity coefficients are undefined
  in _decimal (in accordance with the specification).

* Issue #15925: Fix a regression in "email.util" where the
  "parsedate()" and "parsedate_tz()" functions did not return None
  anymore when the argument could not be parsed.


Extension Modules
-----------------

* Issue #15973: Fix a segmentation fault when comparing datetime
  timezone objects.

* Issue #15977: Fix memory leak in Modules/_ssl.c when the function
  _set_npn_protocols() is called multiple times, thanks to Daniel
  Sommermann.

* Issue #15969: "faulthandler" module: rename
  dump_tracebacks_later() to dump_traceback_later() and
  cancel_dump_tracebacks_later() to cancel_dump_traceback_later().

* _decimal module: use only C 89 style comments.


Python 3.3.0 Release Candidate 2
================================

*Release date: 09-Sep-2012*


Core and Builtins
-----------------

* Issue #13992: The trashcan mechanism is now thread-safe.  This
  eliminates sporadic crashes in multi-thread programs when several
  long deallocator chains ran concurrently and involved subclasses of
  built-in container types.

* Issue #15784: Modify "OSError".__str__() to better distinguish
  between errno error numbers and Windows error numbers.

* Issue #15781: Fix two small race conditions in import's module
  locking.


Library
-------

* Issue #17158: Add 'symbols' to help() welcome message; clarify
  'modules spam' messages.

* Issue #15847: Fix a regression in argparse, which did not accept
  tuples as argument lists anymore.

* Issue #15828: Restore support for C extensions in
  "imp.load_module()".

* Issue #15340: Fix importing the random module when "/dev/urandom"
  cannot be opened.  This was a regression caused by the hash
  randomization patch.

* Issue #10650: Deprecate the watchexp parameter of the
  "Decimal.quantize()" method.

* Issue #15785: Modify "window.get_wch()" API of the curses module:
  return a character for most keys, and an integer for special keys,
  instead of always returning an integer. So it is now possible to
  distinguish special keys like keypad keys.

* Issue #14223: Fix "window.addch()" of the curses module for
  special characters like curses.ACS_HLINE: the Python function
  addch(int) and addch(bytes) is now calling the C function
  waddch()/mvwaddch() (as it was done in Python 3.2), instead of
  wadd_wch()/mvwadd_wch(). The Python function addch(str) is still
  calling the C function wadd_wch()/mvwadd_wch() if the Python curses
  is linked to libncursesw.


Build
-----

* Issue #15822: Really ensure 2to3 grammar pickles are properly
  installed (replaces fixes for Issue #15645).


Documentation
-------------

* Issue #15814: The memoryview enhancements in 3.3.0 accidentally
  permitted the hashing of multi-dimensional memorviews and
  memoryviews with multi-byte item formats. The intended restrictions
  have now been documented - they will be correctly enforced in 3.3.1.


Python 3.3.0 Release Candidate 1
================================

*Release date: 25-Aug-2012*


Core and Builtins
-----------------

* Issue #15573: memoryview comparisons are now performed by value
  with full support for any valid struct module format definition.

* Issue #15316: When an item in the fromlist for "__import__()"
  doesn't exist, don't raise an error, but if an exception is raised
  as part of an import do let that propagate.

* Issue #15778: Ensure that "str(ImportError(msg))" returns a str
  even when msg isn't a str.

* Issue #2051: Source file permission bits are once again correctly
  copied to the cached bytecode file. (The migration to importlib
  reintroduced this problem because these was no regression test. A
  test has been added as part of this patch)

* Issue #15761: Fix crash when "PYTHONEXECUTABLE" is set on Mac OS
  X.

* Issue #15726: Fix incorrect bounds checking in PyState_FindModule.
  Patch by Robin Schreiber.

* Issue #15604: Update uses of "PyObject_IsTrue()" to check for and
  handle errors correctly.  Patch by Serhiy Storchaka.

* Issue #14846: "importlib.FileFinder" now handles the case where
  the directory being searched is removed after a previous import
  attempt.


Library
-------

* Issue #13370: Ensure that ctypes works on Mac OS X when Python is
  compiled using the clang compiler.

* Issue #13072: The array module's 'u' format code is now deprecated
  and will be removed in Python 4.0.

* Issue #15544: Fix Decimal.__float__ to work with payload-carrying
  NaNs.

* Issue #15776: Allow pyvenv to work in existing directory with
  --clean.

* Issue #15249: email's BytesGenerator now correctly mangles From
  lines (when requested) even if the body contains undecodable bytes.

* Issue #15777: Fix a refleak in _posixsubprocess.

* Issue ##665194: Update "email.utils.localtime" to use
  datetime.astimezone and correctly handle historic changes in UTC
  offsets.

* Issue #15199: Fix JavaScript's default MIME type to
  application/javascript. Patch by Bohuslav Kabrda.

* Issue #12643: "code.InteractiveConsole" now respects
  "sys.excepthook" when displaying exceptions.  Patch by Aaron Iles.

* Issue #13579: "string.Formatter" now understands the 'a'
  conversion specifier.

* Issue #15595: Fix "subprocess.Popen(universal_newlines=True)" for
  certain locales (utf-16 and utf-32 family). Patch by Chris Jerdonek.

* Issue #15477: In cmath and math modules, add workaround for
  platforms whose system-supplied log1p function doesn't respect signs
  of zeros.

* Issue #15715: "importlib.__import__()" will silence an ImportError
  when the use of fromlist leads to a failed import.

* Issue #14669: Fix pickling of connections and sockets on Mac OS X
  by sending/receiving an acknowledgment after file descriptor
  transfer. TestPicklingConnection has been reenabled for Mac OS X.

* Issue #11062: Fix adding a message from file to Babyl mailbox.

* Issue #15646: Prevent equivalent of a fork bomb when using
  "multiprocessing" on Windows without the "if __name__ == '__main__'"
  idiom.


IDLE
----

* Issue #15678: Fix IDLE menus when started from OS X command line
  (3.3.0b2 regression).


Documentation
-------------

* Touched up the Python 2 to 3 porting guide.

* Issue #14674: Add a discussion of the "json" module's standard
  compliance. Patch by Chris Rebert.

* Create a 'Concurrent Execution' section in the docs, and split up
  the 'Optional Operating System Services' section to use a more user-
  centric classification scheme (splitting them across the new CE
  section, IPC and text processing). Operating system limitations can
  be reflected with the Sphinx ":platform:" tag, it doesn't make sense
  as part of the Table of Contents.

* Issue #4966: Bring the sequence docs up to date for the Py3k
  transition and the many language enhancements since they were
  original written.

* The "path importer" misnomer has been replaced with Eric Snow's
  more-awkward-but-at-least-not-wrong suggestion of "path based
  finder" in the import system reference docs.

* Issue #15640: Document "importlib.abc.Finder" as deprecated.

* Issue #15630: Add an example for "continue" stmt in the tutorial.
  Patch by Daniel Ellis.


Tests
-----

* Issue #15747: ZFS always returns EOPNOTSUPP when attempting to set
  the UF_IMMUTABLE flag (via either chflags or lchflags); refactor
  affected tests in test_posix.py to account for this.

* Issue #15285: Refactor the approach for testing connect timeouts
  using two external hosts that have been configured specifically for
  this type of test.

* Issue #15743: Remove the deprecated method usage in "urllib"
  tests. Patch by Jeff Knupp.

* Issue #15615: Add some tests for the "json" module's handling of
  invalid input data.  Patch by Kushal Das.


Build
-----

* Output lib files for PGO build into PGO directory.

* Pick up 32-bit launcher from PGO directory on 64-bit PGO build.

* Drop "PC\python_nt.h" as it's not used.  Add input dependency on
  custom build step.

* Issue #15511: Drop explicit dependency on pythonxy.lib from
  _decimal amd64 configuration.

* Add missing PGI/PGO configurations for pywlauncher.

* Issue #15645: Ensure 2to3 grammar pickles are properly installed.


Python 3.3.0 Beta 2
===================

*Release date: 12-Aug-2012*


Core and Builtins
-----------------

* Issue #15568: Fix the return value of "yield from" when
  StopIteration is raised by a custom iterator.

* Issue #13119: "sys.stdout" and "sys.stderr" are now using "rn"
  newline on Windows, as Python 2.

* Issue #15534: Fix the fast-search function for non-ASCII Unicode
  strings.

* Issue #15508: Fix the docstring for "__import__()" to have the
  proper default value of 0 for 'level' and to not mention negative
  levels since they are not supported.

* Issue #15425: Eliminated traceback noise from more situations
  involving importlib.

* Issue #14578: Support modules registered in the Windows registry
  again.

* Issue #15466: Stop using TYPE_INT64 in marshal, to make
  importlib.h (and other byte code files) equal between 32-bit and
  64-bit systems.

* Issue #1692335: Move initial exception args assignment to
  "BaseException.__new__()" to help pickling of naive subclasses.

* Issue #12834: Fix "PyBuffer_ToContiguous()" for non-contiguous
  arrays.

* Issue #15456: Fix code "__sizeof__()" after #12399 change.  Patch
  by Serhiy Storchaka.

* Issue #15404: Refleak in PyMethodObject repr.

* Issue #15394: An issue in "PyModule_Create()" that caused
  references to be leaked on some error paths has been fixed.  Patch
  by Julia Lawall.

* Issue #15368: An issue that caused bytecode generation to be non-
  deterministic has been fixed.

* Issue #15202: Consistently use the name "follow_symlinks" for new
  parameters in os and shutil functions.

* Issue #15314: "__main__.__loader__" is now set correctly during
  interpreter startup.

* Issue #15111: When a module imported using 'from import' has an
  ImportError inside itself, don't mask that fact behind a generic
  ImportError for the module itself.

* Issue #15293: Add GC support to the AST base node type.

* Issue #15291: Fix a memory leak where AST nodes where not properly
  deallocated.

* Issue #15110: Fix the tracebacks generated by "import xxx" to not
  show the importlib stack frames.

* Issue #16369: Global PyTypeObjects not initialized with
  PyType_Ready(...).

* Issue #15020: The program name used to search for Python's path is
  now "python3" under Unix, not "python".

* Issue #15897: zipimport.c doesn't check return value of fseek().
  Patch by Felipe Cruz.

* Issue #15033: Fix the exit status bug when modules invoked using
  -m switch, return the proper failure return value (1). Patch
  contributed by Jeff Knupp.

* Issue #15229: An "OSError" subclass whose __init__ doesn't call
  back OSError.__init__ could produce incomplete instances, leading to
  crashes when calling str() on them.

* Issue #15307: Virtual environments now use symlinks with framework
  builds on Mac OS X, like other POSIX builds.


Library
-------

* Issue #14590: configparser now correctly strips inline comments
  when delimiter occurs earlier without preceding space.

* Issue #15424: Add a "__sizeof__()" implementation for array
  objects. Patch by Ludwig Hähne.

* Issue #15576: Allow extension modules to act as a package's
  __init__ module.

* Issue #15502: Have "importlib.invalidate_caches()" work on
  "sys.meta_path" instead of "sys.path_importer_cache".

* Issue #15163: Pydoc shouldn't list __loader__ as module data.

* Issue #15471: Do not use mutable objects as defaults for
  "importlib.__import__()".

* Issue #15559: To avoid a problematic failure mode when passed to
  the bytes constructor, objects in the ipaddress module no longer
  implement "__index__()" (they still implement "__int__()" as
  appropriate).

* Issue #15546: Fix handling of pathological input data in the
  peek() and read1() methods of the BZ2File, GzipFile and LZMAFile
  classes.

* Issue #12655: Instead of requiring a custom type,
  "os.sched_getaffinity()" and "os.sched_setaffinity()" now use
  regular sets of integers to represent the CPUs a process is
  restricted to.

* Issue #15538: Fix compilation of the "socket.getnameinfo()" /
  "socket.getaddrinfo()" emulation code.  Patch by Philipp
  Hagemeister.

* Issue #15519: Properly expose WindowsRegistryFinder in importlib
  (and use the correct term for it).  Original patch by Eric Snow.

* Issue #15502: Bring the importlib ABCs into line with the current
  state of the import protocols given PEP 420.  Original patch by Eric
  Snow.

* Issue #15499: Launching a webbrowser in Unix used to sleep for a
  few seconds. Original patch by Anton Barkovsky.

* Issue #15463: The faulthandler module truncates strings to 500
  characters, instead of 100, to be able to display long file paths.

* Issue #6056: Make "multiprocessing" use setblocking(True) on the
  sockets it uses.  Original patch by J Derek Wilson.

* Issue #15364: Fix sysconfig.get_config_var('srcdir') to be an
  absolute path.

* Issue #15413: "os.times()" had disappeared under Windows.

* Issue #15402: An issue in the struct module that caused
  "sys.getsizeof()" to return incorrect results for struct.Struct
  instances has been fixed.  Initial patch by Serhiy Storchaka.

* Issue #15232: When mangle_from is True, "email.Generator" now
  correctly mangles lines that start with 'From ' that occur in a MIME
  preamble or epilogue.

* Issue #15094: Incorrectly placed #endif in _tkinter.c.  Patch by
  Serhiy Storchaka.

* Issue #13922: "argparse" no longer incorrectly strips '--'s that
  appear after the first one.

* Issue #12353: "argparse" now correctly handles null argument
  values.

* Issue #10017, issue #14998: Fix TypeError using pprint on
  dictionaries with user-defined types as keys or other unorderable
  keys.

* Issue #15397: "inspect.getmodulename()" is now based directly on
  importlib via a new "importlib.machinery.all_suffixes()" API.

* Issue #14635: "telnetlib" will use poll() rather than select()
  when possible to avoid failing due to the select() file descriptor
  limit.

* Issue #15180: Clarify posixpath.join() error message when mixing
  str & bytes.

* Issue #15343: pkgutil now includes an iter_importer_modules
  implementation for importlib.machinery.FileFinder (similar to the
  way it already handled zipimport.zipimporter).

* Issue #15314: runpy now sets __main__.__loader__ correctly.

* Issue #15357: The import emulation in pkgutil is now deprecated.
  pkgutil uses importlib internally rather than the emulation.

* Issue #15233: Python now guarantees that callables registered with
  the atexit module will be called in a deterministic order.

* Issue #15238: "shutil.copystat()" now copies Linux "extended
  attributes".

* Issue #15230: runpy.run_path now correctly sets __package__ as
  described in the documentation.

* Issue #15315: Support VS 2010 in distutils cygwincompiler.

* Issue #15294: Fix a regression in pkgutil.extend_path()'s handling
  of nested namespace packages.

* Issue #15056: "imp.cache_from_source()" and
  "imp.source_from_cache()" raise NotImplementedError when
  "sys.implementation.cache_tag" is set to None.

* Issue #15256: Grammatical mistake in exception raised by
  "imp.find_module()".

* Issue #5931: "wsgiref" environ variable SERVER_SOFTWARE will
  specify an implementation specific term like CPython, Jython instead
  of generic "Python".

* Issue #13248: Remove obsolete argument "max_buffer_size" of
  BufferedWriter and BufferedRWPair, from the io module.

* Issue #13248: Remove obsolete argument "version" of
  "argparse.ArgumentParser".

* Issue #14814: Implement more consistent ordering and sorting
  behaviour for ipaddress objects.

* Issue #14814: "ipaddress" network objects correctly return
  NotImplemented when compared to arbitrary objects instead of raising
  TypeError.

* Issue #14990: Correctly fail with SyntaxError on invalid encoding
  declaration.

* Issue #14814: "ipaddress" now provides more informative error
  messages when constructing instances directly (changes permitted
  during beta due to provisional API status).

* Issue #15247: "io.FileIO" now raises an error when given a file
  descriptor pointing to a directory.

* Issue #15261: Stop os.stat(fd) crashing on Windows when fd not
  open.

* Issue #15166: Implement "imp.get_tag()" using
  "sys.implementation.cache_tag".

* Issue #15210: Catch KeyError when "importlib.__init__()" can't
  find _frozen_importlib in sys.modules, not ImportError.

* Issue #15030: "importlib.abc.PyPycLoader" now supports the new
  source size header field in .pyc files.

* Issue #5346: Preserve permissions of mbox, MMDF and Babyl mailbox
  files on flush().

* Issue #10571: Fix the "--sign" option of distutils' upload
  command. Patch by Jakub Wilk.

* Issue #9559: If messages were only added, a new file is no longer
  created and renamed over the old file when flush() is called on an
  mbox, MMDF or Babyl mailbox.

* Issue #10924: Fixed "crypt.mksalt()" to use a RNG that is suitable
  for cryptographic purpose.

* Issue #15184: Ensure consistent results of OS X configuration
  tailoring for universal builds by factoring out common OS X-specific
  customizations from sysconfig, distutils.sysconfig, distutils.util,
  and distutils.unixccompiler into a new module _osx_support.


C API
-----

* Issue #15610: "PyImport_ImportModuleEx()" now uses a 'level' of 0
  instead of -1.

* Issue #15169, issue #14599: Strip out the C implementation of
  "imp.source_from_cache()" used by
  PyImport_ExecCodeModuleWithPathnames() and used the Python code
  instead. Leads to PyImport_ExecCodeModuleObject() to not try to
  infer the source path from the bytecode path as
  PyImport_ExecCodeModuleWithPathnames() does.


Extension Modules
-----------------

* Issue #6493: An issue in ctypes on Windows that caused structure
  bitfields of type "ctypes.c_uint32" and width 32 to incorrectly be
  set has been fixed.

* Issue #15194: Update libffi to the 3.0.11 release.


IDLE
----

* Issue #13052: Fix IDLE crashing when replace string in
  Search/Replace dialog ended with "\".  Patch by Roger Serwy.


Tools/Demos
-----------

* Issue #15458: python-config gets a new option --configdir to print
  the $LIBPL value.

* Move importlib.test.benchmark to Tools/importbench.

* Issue #12605: The gdb hooks for debugging CPython (within
  Tools/gdb) have been enhanced to show information on more C frames
  relevant to CPython within the "py-bt" and "py-bt-full" commands:

  * C frames that are waiting on the GIL

  * C frames that are garbage-collecting

  * C frames that are due to the invocation of a PyCFunction


Documentation
-------------

* Issue #15041: Update "see also" list in tkinter documentation.

* Issue #15444: Use proper spelling for non-ASCII contributor names.
  Patch by Serhiy Storchaka.

* Issue #15295: Reorganize and rewrite the documentation on the
  import system.

* Issue #15230: Clearly document some of the limitations of the
  runpy module and nudge readers towards importlib when appropriate.

* Issue #15053: Copy Python 3.3 import lock change notice to all
  relevant functions in imp instead of just at the top of the relevant
  section.

* Issue #15288: Link to the term "loader" in notes in pkgutil about
  how things won't work as expected in Python 3.3 and mark the
  requisite functions as "changed" since they will no longer work with
  modules directly imported by import itself.

* Issue #13557: Clarify effect of giving two different namespaces to
  "exec()" or "execfile()".

* Issue #15250: Document that "filecmp.dircmp()" compares files
  shallowly. Patch contributed by Chris Jerdonek.

* Issue #15442: Expose the default list of directories ignored by
  "filecmp.dircmp()" as a module attribute, and expand the list to
  more modern values.


Tests
-----

* Issue #15467: Move helpers for "__sizeof__()" tests into
  test_support.  Patch by Serhiy Storchaka.

* Issue #15320: Make iterating the list of tests thread-safe when
  running tests in multiprocess mode. Patch by Chris Jerdonek.

* Issue #15168: Move "importlib.test" to "test.test_importlib".

* Issue #15091: Reactivate a test on UNIX which was failing thanks
  to a forgotten "importlib.invalidate_caches()" call.

* Issue #15230: Adopted a more systematic approach in the runpy
  tests.

* Issue #15300: Ensure the temporary test working directories are in
  the same parent folder when running tests in multiprocess mode from
  a Python build. Patch by Chris Jerdonek.

* Issue #15284: Skip {send,recv}msg tests in test_socket when IPv6
  is not enabled. Patch by Brian Brazil.

* Issue #15277: Fix a resource leak in support.py when IPv6 is
  disabled.  Patch by Brian Brazil.


Build
-----

* Issue #11715: Fix multiarch detection without having Debian
  development tools (dpkg-dev) installed.

* Issue #15037: Build OS X installers with local copy of ncurses 5.9
  libraries to avoid curses.unget_wch bug present in older versions of
  ncurses such as those shipped with OS X.

* Issue #15560: Fix building _sqlite3 extension on OS X with an SDK.
  Also, for OS X installers, ensure consistent sqlite3 behavior and
  feature availability by building a local copy of libsqlite3 rather
  than depending on the wide range of versions supplied with various
  OS X releases.

* Issue #8847: Disable COMDAT folding in Windows PGO builds.

* Issue #14018: Fix OS X Tcl/Tk framework checking when using OS X
  SDKs.

* Issue #16256: OS X installer now sets correct permissions for doc
  directory.

* Issue #15431: Add _freeze_importlib project to regenerate
  importlib.h on Windows. Patch by Kristján Valur Jónsson.

* Issue #14197: For OS X framework builds, ensure links to the
  shared library are created with the proper ABI suffix.

* Issue #14330: For cross builds, don't use host python, use host
  search paths for host compiler.

* Issue #15235: Allow Berkley DB versions up to 5.3 to build the dbm
  module.

* Issue #15268: Search curses.h in /usr/include/ncursesw.


Python 3.3.0 Beta 1
===================

*Release date: 27-Jun-2012*


Core and Builtins
-----------------

* Fix a (most likely) very rare memory leak when calling main() and
  not being able to decode a command-line argument.

* Issue #14815: Use Py_ssize_t instead of long for the object hash,
  to preserve all 64 bits of hash on Win64.

* Issue #12268: File readline, readlines and read() or readall()
  methods no longer lose data when an underlying read system call is
  interrupted. IOError is no longer raised due to a read system call
  returning EINTR from within these methods.

* Issue #11626: Add _SizeT functions to stable ABI.

* Issue #15142: Fix reference leak when deallocating instances of
  types created using PyType_FromSpec().

* Issue #10053: Don't close FDs when FileIO.__init__ fails. Loosely
  based on the work by Hirokazu Yamamoto.

* Issue #15096: Removed support for ur'' as the raw notation isn't
  compatible with Python 2.x's raw unicode strings.

* Issue #13783: Generator objects now use the identifier APIs
  internally

* Issue #14874: Restore charmap decoding speed to pre-PEP 393
  levels. Patch by Serhiy Storchaka.

* Issue #15026: utf-16 encoding is now significantly faster (up to
  10x). Patch by Serhiy Storchaka.

* Issue #11022: open() and io.TextIOWrapper are now calling
  locale.getpreferredencoding(False) instead of
  locale.getpreferredencoding() in text mode if the encoding is not
  specified. Don't change temporary the locale encoding using
  locale.setlocale(), use the current locale encoding instead of the
  user preferred encoding.

* Issue #14673: Add Eric Snow's sys.implementation implementation.

* Issue #15038: Optimize python Locks on Windows.


Library
-------

* Issue #12288: Consider '0' and '0.0' as valid initialvalue for
  tkinter SimpleDialog.

* Issue #15512: Add a __sizeof__ implementation for parser. Patch by
  Serhiy Storchaka.

* Issue #15469: Add a __sizeof__ implementation for deque objects.
  Patch by Serhiy Storchaka.

* Issue #15489: Add a __sizeof__ implementation for BytesIO objects.
  Patch by Serhiy Storchaka.

* Issue #15487: Add a __sizeof__ implementation for buffered I/O
  objects. Patch by Serhiy Storchaka.

* Issue #15514: Correct __sizeof__ support for cpu_set. Patch by
  Serhiy Storchaka.

* Issue #15177: Added dir_fd parameter to os.fwalk().

* Issue #15061: Re-implemented hmac.compare_digest() in C to prevent
  further timing analysis and to support all buffer protocol aware
  objects as well as ASCII only str instances safely.

* Issue #15164: Change return value of platform.uname() from a plain
  tuple to a collections.namedtuple.

* Support Mageia Linux in the platform module.

* Issue #11678: Support Arch linux in the platform module.

* Issue #15118: Change return value of os.uname() and os.times()
  from plain tuples to immutable iterable objects with named
  attributes (structseq objects).

* Speed up _decimal by another 10-15% by caching the thread local
  context that was last accessed. In the pi benchmark (64-bit
  platform, prec=9), _decimal is now only 1.5x slower than float.

* Remove the packaging module, which is not ready for prime time.

* Issue #15154: Add "dir_fd" parameter to os.rmdir, remove "rmdir"
  parameter from os.remove / os.unlink.

* Issue #4489: Add a shutil.rmtree that isn't susceptible to symlink
  attacks. It is used automatically on platforms supporting the
  necessary os.openat() and os.unlinkat() functions. Main code by
  Martin von Löwis.

* Issue #15156: HTMLParser now uses the new "html.entities.html5"
  dictionary.

* Issue #11113: add a new "html5" dictionary containing the named
  character references defined by the HTML5 standard and the
  equivalent Unicode character(s) to the html.entities module.

* Issue #15114: the strict mode of HTMLParser and the HTMLParseError
  exception are deprecated now that the parser is able to parse
  invalid markup.

* Issue #3665: u and U escapes are now supported in unicode regular
  expressions.  Patch by Serhiy Storchaka.

* Issue #15153: Added inspect.getgeneratorlocals to simplify white
  box testing of generator state updates

* Issue #13062: Added inspect.getclosurevars to simplify testing
  stateful closures

* Issue #11024: Fixes and additional tests for Time2Internaldate.

* Issue #14626: Large refactoring of functions / parameters in the
  os module. Many functions now support "dir_fd" and "follow_symlinks"
  parameters; some also support accepting an open file descriptor in
  place of a path string.  Added os.support_* collections as LBYL
  helpers.  Removed many functions only previously seen in 3.3 alpha
  releases (often starting with "f" or "l", or ending with "at").
  Originally suggested by Serhiy Storchaka; implemented by Larry
  Hastings.

* Issue #15008: Implement PEP 362 "Signature Objects". Patch by Yury
  Selivanov.

* Issue: #15138: base64.urlsafe_{en,de}code() are now 3-4x faster.

* Issue #444582: Add shutil.which, for finding programs on the
  system path. Original patch by Erik Demaine, with later iterations
  by Jan Killian and Brian Curtin.

* Issue #14837: SSL errors now have "library" and "reason"
  attributes describing precisely what happened and in which OpenSSL
  submodule. The str() of a SSLError is also enhanced accordingly.

* Issue #9527: datetime.astimezone() method will now supply a class
  timezone instance corresponding to the system local timezone when
  called with no arguments.

* Issue #14653: email.utils.mktime_tz() no longer relies on system
  mktime() when timezone offest is supplied.

* Issue #14684: zlib.compressobj() and zlib.decompressobj() now
  support the use of predefined compression dictionaries. Original
  patch by Sam Rushing.

* Fix GzipFile's handling of filenames given as bytes objects.

* Issue #14772: Return destination values from some shutil
  functions.

* Issue #15064: Implement context manager protocol for
  multiprocessing types

* Issue #15101: Make pool finalizer avoid joining current thread.

* Issue #14657: The frozen instance of importlib used for bootstrap
  is now also the module imported as importlib._bootstrap.

* Issue #14055: Add __sizeof__ support to _elementtree.

* Issue #15054: A bug in tokenize.tokenize that caused string
  literals with 'b' prefixes to be incorrectly tokenized has been
  fixed. Patch by Serhiy Storchaka.

* Issue #15006: Allow equality comparison between naive and aware
  time or datetime objects.

* Issue #15036: Mailbox no longer throws an error if a flush is done
  between operations when removing or changing multiple items in mbox,
  MMDF, or Babyl mailboxes.

* Issue #14059: Implement multiprocessing.Barrier.

* Issue #15061: The inappropriately named hmac.secure_compare has
  been renamed to hmac.compare_digest, restricted to operating on
  bytes inputs only and had its documentation updated to more
  accurately reflect both its intent and its limitations

* Issue #13841: Make child processes exit using sys.exit() on
  Windows.

* Issue #14936: curses_panel was converted to PEP 3121 and PEP 384
  API. Patch by Robin Schreiber.

* Issue #1667546: On platforms supporting tm_zone and tm_gmtoff
  fields in struct tm, time.struct_time objects returned by
  time.gmtime(), time.localtime() and time.strptime() functions now
  have tm_zone and tm_gmtoff attributes.  Original patch by Paul
  Boddie.

* Rename adjusted attribute to adjustable in time.get_clock_info()
  result.

* Issue #3518: Remove references to non-existent
  BaseManager.from_address() method.

* Issue #13857: Added textwrap.indent() function (initial patch by
  Ezra Berch)

* Issue #2736: Added datetime.timestamp() method.

* Issue #13854: Make multiprocessing properly handle non-integer
  non- string argument to SystemExit.

* Issue #12157: Make pool.map() empty iterables correctly.  Initial
  patch by mouad.

* Issue #11823: disassembly now shows argument counts on calls with
  keyword args.

* Issue #14711: os.stat_float_times() has been deprecated.

* LZMAFile now accepts the modes "rb"/"wb"/"ab" as synonyms of
  "r"/"w"/"a".

* The bz2 and lzma modules now each contain an open() function,
  allowing compressed files to readily be opened in text mode as well
  as binary mode.

* BZ2File.__init__() and LZMAFile.__init__() now accept a file
  object as their first argument, rather than requiring a separate
  "fileobj" argument.

* gzip.open() now accepts file objects as well as filenames.

* Issue #14992: os.makedirs(path, exist_ok=True) would raise an
  OSError when the path existed and had the S_ISGID mode bit set when
  it was not explicitly asked for.  This is no longer an exception as
  mkdir cannot control if the OS sets that bit for it or not.

* Issue #14989: Make the CGI enable option to http.server available
  via command line.

* Issue #14987: Add a missing import statement to inspect.

* Issue #1079: email.header.decode_header now correctly parses all
  the examples in RFC2047.  There is a necessary visible behavior
  change: the leading and/or trailing whitespace on ASCII parts is now
  preserved.

* Issue #14969: Better handling of exception chaining in
  contextlib.ExitStack

* Issue #14963: Convert contextlib.ExitStack.__exit__ to use an
  iterative algorithm (Patch by Alon Horev)

* Issue #14785: Add sys._debugmallocstats() to help debug low-level
  memory allocation issues

* Issue #14443: Ensure that .py files are byte-compiled with the
  correct Python executable within bdist_rpm even on older versions of
  RPM


C-API
-----

* Issue #15146: Add PyType_FromSpecWithBases. Patch by Robin
  Schreiber.

* Issue #15042: Add PyState_AddModule and PyState_RemoveModule. Add
  version guard for Py_LIMITED_API additions. Patch by Robin
  Schreiber.

* Issue #13783: Inadvertent additions to the public C API in the PEP
  380 implementation have either been removed or marked as private
  interfaces.


Extension Modules
-----------------

* Issue #15000: Support the "unique" x32 architecture in
  _posixsubprocess.c.


IDLE
----

* Issue #9803: Don't close IDLE on saving if breakpoint is open.
  Patch by Roger Serwy.

* Issue #14962: Update text coloring in IDLE shell window after
  changing options.  Patch by Roger Serwy.


Documentation
-------------

* Issue #15176: Clarified behavior, documentation, and
  implementation of os.listdir().

* Issue #14982: Document that pkgutil's iteration functions require
  the non-standard iter_modules() method to be defined by an importer
  (something the importlib importers do not define).

* Issue #15081: Document PyState_FindModule. Patch by Robin
  Schreiber.

* Issue #14814: Added first draft of ipaddress module API reference


Tests
-----

* Issue #15187: Bugfix: remove temporary directories test_shutil was
  leaving behind.

* Issue #14769: test_capi now has SkipitemTest, which cleverly
  checks for "parity" between PyArg_ParseTuple() and the
  Python/getargs.c static function skipitem() for all possible "format
  units".

* test_nntplib now tolerates being run from behind NNTP gateways
  that add "X-Antivirus" headers to articles

* Issue #15043: test_gdb is now skipped entirely if gdb security
  settings block loading of the gdb hooks

* Issue #14963: Add test cases for exception handling behaviour in
  contextlib.ExitStack (Initial patch by Alon Horev)


Build
-----

* Issue #13590: Improve support for OS X Xcode 4:

     * Try to avoid building Python or extension modules with
       problematic llvm-gcc compiler.

     * Since Xcode 4 removes ppc support, extension module builds
       now check for ppc compiler support and automatically remove ppc
       and ppc64 archs when not available.

     * Since Xcode 4 no longer install SDKs in default locations,
       extension module builds now revert to using installed headers
       and libs if the SDK used to build the interpreter is not
       available.

     * Update ./configure to use better defaults for universal
       builds; in particular, --enable-universalsdk=yes uses the Xcode
       default SDK and --with-universal-archs now defaults to "intel"
       if ppc not available.

* Issue #14225: Fix Unicode support for curses (#12567) on OS X

* Issue #14928: Fix importlib bootstrap issues by using a custom
  executable (Modules/_freeze_importlib) to build Python/importlib.h.


Python 3.3.0 Alpha 4
====================

*Release date: 31-May-2012*


Core and Builtins
-----------------

* Issue #14835: Make plistlib output empty arrays & dicts like OS X.
  Patch by Sidney San Martín.

* Issue #14744: Use the new _PyUnicodeWriter internal API to speed
  up str%args and str.format(args).

* Issue #14930: Make memoryview objects weakrefable.

* Issue #14775: Fix a potential quadratic dict build-up due to the
  garbage collector repeatedly trying to untrack dicts.

* Issue #14857: fix regression in references to PEP 3135 implicit
  __class__ closure variable (Reopens issue #12370)

* Issue #14712 (PEP 405): Virtual environments. Implemented by Vinay
  Sajip.

* Issue #14660 (PEP 420): Namespace packages. Implemented by Eric
  Smith.

* Issue #14494: Fix __future__.py and its documentation to note that
  absolute imports are the default behavior in 3.0 instead of 2.7.
  Patch by Sven Marnach.

* Issue #9260: A finer-grained import lock.  Most of the import
  sequence now uses per-module locks rather than the global import
  lock, eliminating well-known issues with threads and imports.

* Issue #14624: UTF-16 decoding is now 3x to 4x faster on various
  inputs. Patch by Serhiy Storchaka.

* asdl_seq and asdl_int_seq are now Py_ssize_t sized.

* Issue #14133 (PEP 415): Implement suppression of __context__
  display with an attribute on BaseException. This replaces the
  original mechanism of PEP 409.

* Issue #14417: Mutating a dict during lookup now restarts the
  lookup instead of raising a RuntimeError (undoes issue #14205).

* Issue #14738: Speed-up UTF-8 decoding on non-ASCII data.  Patch by
  Serhiy Storchaka.

* Issue #14700: Fix two broken and undefined-behaviour-inducing
  overflow checks in old-style string formatting.


Library
-------

* Issue #14690: Use monotonic clock instead of system clock in the
  sched, subprocess and trace modules.

* Issue #14443: Tell rpmbuild to use the correct version of Python
  in bdist_rpm. Initial patch by Ross Lagerwall.

* Issue #12515: email now registers a defect if it gets to EOF while
  parsing a MIME part without seeing the closing MIME boundary.

* Issue #1672568: email now always decodes base64 payloads, adding
  padding and ignoring non-base64-alphabet characters if needed, and
  registering defects for any such problems.

* Issue #14925: email now registers a defect when the parser decides
  that there is a missing header/body separator line.
  MalformedHeaderDefect, which the existing code would never actually
  generate, is deprecated.

* Issue #10365: File open dialog now works instead of crashing even
  when the parent window is closed before the dialog. Patch by Roger
  Serwy.

* Issue #8739: Updated smtpd to support RFC 5321, and added support
  for the RFC 1870 SIZE extension.

* Issue #665194: Added a localtime function to email.utils to
  provide an aware local datetime for use in setting Date headers.

* Issue #12586: Added new provisional policies that implement
  convenient unicode support for email headers.  See What's New for
  details.

* Issue #14731: Refactored email Policy framework to support full
  backward compatibility with Python 3.2 by default yet allow for the
  introduction of new features through new policies.  Note that
  Policy.must_be_7bit is renamed to cte_type.

* Issue #14876: Use user-selected font for highlight configuration.

* Issue #14920: Fix the help(urllib.parse) failure on locale C on
  terminals. Have ascii characters in help.

* Issue #14548: Make multiprocessing finalizers check pid before
  running to cope with possibility of gc running just after fork.

* Issue #14036: Add an additional check to validate that port in
  urlparse does not go in illegal range and returns None.

* Issue #14862: Add missing names to os.__all__

* Issue #14875: Use float('inf') instead of float('1e66666') in the
  json module.

* Issue #13585: Added contextlib.ExitStack

* PEP 3144, Issue #14814: Added the ipaddress module

* Issue #14426: Correct the Date format in Expires attribute of Set-
  Cookie Header in Cookie.py.

* Issue #14588: The types module now provide new_class() and
  prepare_class() functions to support PEP 3115 compliant dynamic
  class creation. Patch by Daniel Urban and Nick Coghlan.

* Issue #13152: Allow to specify a custom tabsize for expanding tabs
  in textwrap. Patch by John Feuerstein.

* Issue #14721: Send the correct 'Content-length: 0' header when the
  body is an empty string ''. Initial Patch contributed by Arve
  Knudsen.

* Issue #14072: Fix parsing of 'tel' URIs in urlparse by making the
  check for ports stricter.

* Issue #9374: Generic parsing of query and fragment portions of url
  for any scheme. Supported both by RFC3986 and RFC2396.

* Issue #14798: Fix the functions in pyclbr to raise an ImportError
  when the first part of a dotted name is not a package. Patch by
  Xavier de Gaye.

* Issue #12098: multiprocessing on Windows now starts child
  processes using the same sys.flags as the current process.  Initial
  patch by Sergey Mezentsev.

* Issue #13031: Small speed-up for tarfile when unzipping tarfiles.
  Patch by Justin Peel.

* Issue #14780: urllib.request.urlopen() now has a "cadefault"
  argument to use the default certificate store.  Initial patch by
  James Oakley.

* Issue #14829: Fix bisect and range() indexing with large indices
  (>= 2 ** 32) under 64-bit Windows.

* Issue #14732: The _csv module now uses PEP 3121 module
  initialization. Patch by Robin Schreiber.

* Issue #14809: Add HTTP status codes introduced by RFC 6585 to
  http.server and http.client. Patch by EungJun Yi.

* Issue #14777: tkinter may return undecoded UTF-8 bytes as a string
  when accessing the Tk clipboard.  Modify clipboad_get() to first
  request type UTF8_STRING when no specific type is requested in an
  X11 windowing environment, falling back to the current default type
  STRING if that fails. Original patch by Thomas Kluyver.

* Issue #14773: Fix os.fwalk() failing on dangling symlinks.

* Issue #12541: Be lenient with quotes around Realm field of HTTP
  Basic Authentation in urllib2.

* Issue #14807: move undocumented tarfile.filemode() to
  stat.filemode() and add doc entry. Add tarfile.filemode alias with
  deprecation warning.

* Issue #13815: TarFile.extractfile() now returns io.BufferedReader
  objects.

* Issue #14532: Add a secure_compare() helper to the hmac module, to
  mitigate timing attacks. Patch by Jon Oberheide.

* Add importlib.util.resolve_name().

* Issue #14366: Support lzma compression in zip files. Patch by
  Serhiy Storchaka.

* Issue #13959: Introduce importlib.find_loader() and document
  imp.find_module/load_module as deprecated.

* Issue #14082: shutil.copy2() now copies extended attributes, if
  possible. Patch by Hynek Schlawack.

* Issue #13959: Make
  importlib.abc.FileLoader.load_module()/get_filename() and
  importlib.machinery.ExtensionFileLoader.load_module() have their
  single argument be optional. Allows for the replacement (and thus
  deprecation) of imp.load_source()/load_package()/load_compiled().

* Issue #13959: imp.get_suffixes() has been deprecated in favour of
  the new attributes on importlib.machinery: SOURCE_SUFFIXES,
  DEBUG_BYTECODE_SUFFIXES, OPTIMIZED_BYTECODE_SUFFIXES,
  BYTECODE_SUFFIXES, and EXTENSION_SUFFIXES. This led to an indirect
  deprecation of inspect.getmoduleinfo().

* Issue #14662: Prevent shutil failures on OS X when destination
  does not support chflag operations.  Patch by Hynek Schlawack.

* Issue #14157: Fix time.strptime failing without a year on February
  29th. Patch by Hynek Schlawack.

* Issue #14753: Make multiprocessing's handling of negative timeouts
  the same as it was in Python 3.2.

* Issue #14583: Fix importlib bug when a package's __init__.py would
  first import one of its modules then raise an error.

* Issue #14741: Fix missing support for Ellipsis ('...') in parser
  module.

* Issue #14697: Fix missing support for set displays and set
  comprehensions in parser module.

* Issue #14701: Fix missing support for 'raise ... from' in parser
  module.

* Add support for timeouts to the acquire() methods of
  multiprocessing's lock/semaphore/condition proxies.

* Issue #13989: Add support for text mode to gzip.open().

* Issue #14127: The os.stat() result object now provides three
  additional fields: st_ctime_ns, st_mtime_ns, and st_atime_ns,
  providing those times as an integer with nanosecond resolution.  The
  functions os.utime(), os.lutimes(), and os.futimes() now accept a
  new parameter, ns, which accepts mtime and atime as integers with
  nanosecond resolution.

* Issue #14127 and #10148: shutil.copystat now preserves exact mtime
  and atime on filesystems providing nanosecond resolution.


IDLE
----

* Issue #14958: Change IDLE systax highlighting to recognize all
  string and byte literals supported in Python 3.3.

* Issue #10997: Prevent a duplicate entry in IDLE's "Recent Files"
  menu.

* Issue #14929: Stop IDLE 3.x from closing on Unicode decode errors
  when grepping. Patch by Roger Serwy.

* Issue #12510: Attempting to get invalid tooltip no longer closes
  IDLE. Other tooltipss have been corrected or improved and the number
  of tests has been tripled. Original patch by Roger Serwy.


Tools/Demos
-----------

* Issue #14695: Bring Tools/parser/unparse.py support up to date
  with the Python 3.3 Grammar.


Build
-----

* Issue #14472: Update .gitignore. Patch by Matej Cepl.

* Upgrade Windows library versions: bzip 1.0.6, OpenSSL 1.0.1c.

* Issue #14693: Under non-Windows platforms, hashlib's fallback
  modules are always compiled, even if OpenSSL is present at build
  time.

* Issue #13210: Windows build now uses VS2010, ported from VS2008.


C-API
-----

* Issue #14705: The PyArg_Parse() family of functions now support
  the 'p' format unit, which accepts a "boolean predicate" argument.
  It converts any Python value into an integer--0 if it is "false",
  and 1 otherwise.


Documentation
-------------

* Issue #14863: Update the documentation of os.fdopen() to reflect
  the fact that it's only a thin wrapper around open() anymore.

* Issue #14588: The language reference now accurately documents the
  Python 3 class definition process. Patch by Nick Coghlan.

* Issue #14943: Correct a default argument value for winreg.OpenKey
  and correctly list the argument names in the function's explanation.


Python 3.3.0 Alpha 3
====================

*Release date: 01-May-2012*


Core and Builtins
-----------------

* Issue #14699: Fix calling the classmethod descriptor directly.

* Issue #14433: Prevent msvcrt crash in interactive prompt when
  stdin is closed.

* Issue #14521: Make result of float('nan') and float('-nan') more
  consistent across platforms.

* Issue #14646: __import__() sets __loader__ if the loader did not.

* Issue #14605: No longer have implicit entries in sys.meta_path. If
  sys.meta_path is found to be empty, raise ImportWarning.

* Issue #14605: No longer have implicit entries in sys.path_hooks.
  If sys.path_hooks is found to be empty, a warning will be raised.
  None is now inserted into sys.path_importer_cache if no finder was
  discovered. This also means imp.NullImporter is no longer implicitly
  used.

* Issue #13903: Implement PEP 412. Individual dictionary instances
  can now share their keys with other dictionaries. Classes take
  advantage of this to share their instance dictionary keys for
  improved memory and performance.

* Issue #11603 (again): Setting __repr__ to __str__ now raises a
  RuntimeError when repr() or str() is called on such an object.

* Issue #14658: Fix binding a special method to a builtin
  implementation of a special method with a different name.

* Issue #14630: Fix a memory access bug for instances of a subclass
  of int with value 0.

* Issue #14339: Speed improvements to bin, oct and hex functions.
  Patch by Serhiy Storchaka.

* Issue #14385: It is now possible to use a custom type for the
  __builtins__ namespace, instead of a dict. It can be used for
  sandboxing for example. Raise also a NameError instead of
  ImportError if __build_class__ name if not found in __builtins__.

* Issue #12599: Be more strict in accepting None compared to a
  false- like object for importlib.util.module_for_loader and
  importlib.machinery.PathFinder.

* Issue #14612: Fix jumping around with blocks by setting f_lineno.

* Issue #14592: Attempting a relative import w/o __package__ or
  __name__ set in globals raises a KeyError.

* Issue #14607: Fix keyword-only arguments which started with "__".

* Issue #10854: The ImportError raised when an extension module on
  Windows fails to import now uses the new path and name attributes
  from Issue #1559549.

* Issue #13889: Check and (if necessary) set FPU control word before
  calling any of the dtoa.c string <-> float conversion functions, on
  MSVC builds of Python.  This fixes issues when embedding Python in a
  Delphi app.

* __import__() now matches PEP 328 and documentation by defaulting
  'index' to 0 instead of -1 and removing support for negative values.

* Issue #2377: Make importlib the implementation of __import__().

* Issue #1559549: ImportError now has 'name' and 'path' attributes
  that are set using keyword arguments to its constructor. They are
  currently not set by import as they are meant for use by importlib.

* Issue #14474: Save and restore exception state in
  thread.start_new_thread() while writing error message if the thread
  leaves a unhandled exception.

* Issue #13019: Fix potential reference leaks in bytearray.extend().
  Patch by Suman Saha.


Library
-------

* Issue #14768: os.path.expanduser('~/a') doesn't works correctly
  when HOME is '/'.

* Issue #14371: Support bzip2 in zipfile module.  Patch by Serhiy
  Storchaka.

* Issue #13183: Fix pdb skipping frames after hitting a breakpoint
  and running step.  Patch by Xavier de Gaye.

* Issue #14696: Fix parser module to understand 'nonlocal'
  declarations.

* Issue #10941: Fix imaplib.Internaldate2tuple to produce correct
  result near the DST transition.  Patch by Joe Peterson.

* Issue #9154: Fix parser module to understand function annotations.

* Issue #6085: In http.server.py SimpleHTTPServer.address_string
  returns the client ip address instead client hostname. Patch by
  Charles-François Natali.

* Issue #14309: Deprecate time.clock(), use time.perf_counter() or
  time.process_time() instead.

* Issue #14428: Implement the PEP 418. Add time.get_clock_info(),
  time.perf_counter() and time.process_time() functions, and rename
  time.steady() to time.monotonic().

* Issue #14646: importlib.util.module_for_loader() now sets
  __loader__ and __package__ (when possible).

* Issue #14664: It is now possible to use @unittest.skip{If,Unless}
  on a test class that doesn't inherit from TestCase (i.e. a mixin).

* Issue #4892: multiprocessing Connections can now be transferred
  over multiprocessing Connections.  Patch by Richard Oudkerk (sbt).

* Issue #14160: TarFile.extractfile() failed to resolve symbolic
  links when the links were not located in an archive subdirectory.

* Issue #14638: pydoc now treats non-string __name__ values as if
  they were missing, instead of raising an error.

* Issue #13684: Fix httplib tunnel issue of infinite loops for
  certain sites which send EOF without trailing rn.

* Issue #14605: Add importlib.abc.FileLoader,
  importlib.machinery.(FileFinder, SourceFileLoader,
  SourcelessFileLoader, ExtensionFileLoader).

* Issue #13959: imp.cache_from_source()/source_from_cache() now
  follow os.path.join()/split() semantics for path manipulation
  instead of its prior, custom semantics of caring the right-most path
  separator forward in path joining.

* Issue #2193: Allow ":" character in Cookie NAME values.

* Issue #14629: tokenizer.detect_encoding will specify the filename
  in the SyntaxError exception if found at readline.__self__.name.

* Issue #14629: Raise SyntaxError in tokenizer.detect_encoding if
  the first two lines have non-UTF-8 characters without an encoding
  declaration.

* Issue #14308: Fix an exception when a "dummy" thread is in the
  threading module's active list after a fork().

* Issue #11750: The Windows API functions scattered in the
  _subprocess and _multiprocessing.win32 modules now live in a single
  module "_winapi". Patch by sbt.

* Issue #14087: multiprocessing: add Condition.wait_for(). Patch by
  sbt.

* Issue #14538: HTMLParser can now parse correctly start tags that
  contain a bare '/'.

* Issue #14452: SysLogHandler no longer inserts a UTF-8 BOM into the
  message.

* Issue #14386: Expose the dict_proxy internal type as
  types.MappingProxyType.

* Issue #13959: Make imp.reload() always use a module's __loader__
  to perform the reload.

* Issue #13959: Add imp.py and rename the built-in module to _imp,
  allowing for re-implementing parts of the module in pure Python.

* Issue #13496: Fix potential overflow in bisect.bisect algorithm
  when applied to a collection of size > sys.maxsize / 2.

* Have importlib take advantage of ImportError's new 'name' and
  'path' attributes.

* Issue #14399: zipfile now recognizes that the archive has been
  modified even if only the comment is changed.  In addition, the
  TypeError that results from trying to set a non-binary value as a
  comment is now raised at the time the comment is set rather than at
  the time the zipfile is written.

* trace.CoverageResults.is_ignored_filename() now ignores any name
  that starts with "<" and ends with ">" instead of special-casing
  "<string>" and "<doctest ".

* Issue #12537: The mailbox module no longer depends on knowledge of
  internal implementation details of the email package Message object.

* Issue #7978: socketserver now restarts the select() call when
  EINTR is returned.  This avoids crashing the server loop when a
  signal is received. Patch by Jerzy Kozera.

* Issue #14522: Avoid duplicating socket handles in
  multiprocessing.connection. Patch by sbt.

* Don't Py_DECREF NULL variable in io.IncrementalNewlineDecoder.

* Issue #3033: Add displayof parameter to tkinter font. Patch by
  Guilherme Polo.

* Issue #14482: Raise a ValueError, not a NameError, when trying to
  create a multiprocessing Client or Listener with an AF_UNIX type
  address under Windows.  Patch by Popa Claudiu.

* Issue #802310: Generate always unique tkinter font names if not
  directly passed.

* Issue #14151: Raise a ValueError, not a NameError, when trying to
  create a multiprocessing Client or Listener with an AF_PIPE type
  address under non-Windows platforms.  Patch by Popa Claudiu.

* Issue #14493: Use gvfs-open or xdg-open in webbrowser.


Build
-----

* "make touch" will now touch generated files that are checked into
  Mercurial, after a "hg update" which failed to bring the timestamps
  into the right order.


Tests
-----

* Issue #14026: In test_cmd_line_script, check that sys.argv is
  populated correctly for the various invocation approaches (Patch by
  Jason Yeo)

* Issue #14032: Fix incorrect variable name in test_cmd_line_script
  debugging message (Patch by Jason Yeo)

* Issue #14589: Update certificate chain for sha256.tbs-
  internet.com, fixing a test failure in test_ssl.

* Issue #14355: Regrtest now supports the standard unittest test
  loading, and will use it if a test file contains no "test_main"
  method.


IDLE
----

* Issue #8515: Set __file__ when run file in IDLE. Initial patch by
  Bruce Frederiksen.

* Issue #14496: Fix wrong name in idlelib/tabbedpages.py. Patch by
  Popa Claudiu.


Tools / Demos
-------------

* Issue #3561: The Windows installer now has an option, off by
  default, for placing the Python installation into the system "Path"
  environment variable.

* Issue #13165: stringbench is now available in the
  Tools/stringbench folder. It used to live in its own SVN project.


C-API
-----

* Issue #14098: New functions PyErr_GetExcInfo and PyErr_SetExcInfo.
  Patch by Stefan Behnel.


Python 3.3.0 Alpha 2
====================

*Release date: 01-Apr-2012*


Core and Builtins
-----------------

* Issue #1683368: object.__new__ and object.__init__ raise a
  TypeError if they are passed arguments and their complementary
  method is not overridden.

* Issue #14378: Fix compiling ast.ImportFrom nodes with a
  "__future__" string as the module name that was not interned.

* Issue #14331: Use significantly less stack space when importing
  modules by allocating path buffers on the heap instead of the stack.

* Issue #14334: Prevent in a segfault in type.__getattribute__ when
  it was not passed strings.

* Issue #1469629: Allow cycles through an object's __dict__ slot to
  be collected. (For example if "x.__dict__ is x").

* Issue #14205: dict lookup raises a RuntimeError if the dict is
  modified during a lookup.

* Issue #14220: When a generator is delegating to another iterator
  with the yield from syntax, it needs to have its "gi_running" flag
  set to True.

* Issue #14435: Remove dedicated block allocator from floatobject.c
  and rely on the PyObject_Malloc() api like all other objects.

* Issue #14471: Fix a possible buffer overrun in the winreg module.

* Issue #14288: Allow the serialization of builtin iterators


Library
-------

* Issue #14300: Under Windows, sockets created using socket.dup()
  now allow overlapped I/O.  Patch by sbt.

* Issue #13872: socket.detach() now marks the socket closed (as
  mirrored in the socket repr()).  Patch by Matt Joiner.

* Issue #14406: Fix a race condition when using
  "concurrent.futures.wait( return_when=ALL_COMPLETED)".  Patch by
  Matt Joiner.

* Issue #5136: deprecate old, unused functions from tkinter.

* Issue #14416: syslog now defines the LOG_ODELAY and LOG_AUTHPRIV
  constants if they are defined in <syslog.h>.

* Issue #14295: Add unittest.mock

* Issue #7652: Add --with-system-libmpdec option to configure for
  linking the _decimal module against an installed libmpdec.

* Issue #14380: MIMEText now defaults to utf-8 when passed non-ASCII
  unicode with no charset specified.

* Issue #10340: asyncore - properly handle EINVAL in dispatcher
  constructor on OSX; avoid to call handle_connect in case of a
  disconnected socket which was not meant to connect.

* Issue #14204: The ssl module now has support for the Next Protocol
  Negotiation extension, if available in the underlying OpenSSL
  library. Patch by Colin Marc.

* Issue #3035: Unused functions from tkinter are marked as pending
  deprecated.

* Issue #12757: Fix the skipping of doctests when python is run with
  -OO so that it works in unittest's verbose mode as well as non-
  verbose mode.

* Issue #7652: Integrate the decimal floating point libmpdec library
  to speed up the decimal module. Performance gains of the new C
  implementation are between 10x and 100x, depending on the
  application.

* Issue #14269: SMTPD now conforms to the RFC and requires a HELO
  command before MAIL, RCPT, or DATA.

* Issue #13694: asynchronous connect in asyncore.dispatcher does not
  set addr attribute.

* Issue #14344: fixed the repr of email.policy objects.

* Issue #11686: Added missing entries to email package __all__ lists
  (mostly the new Bytes classes).

* Issue #14335: multiprocessing's custom Pickler subclass now
  inherits from the C-accelerated implementation.  Patch by sbt.

* Issue #10484: Fix the CGIHTTPServer's PATH_INFO handling problem.

* Issue #11199: Fix the with urllib which hangs on particular ftp
  urls.

* Improve the memory utilization and speed of functools.lru_cache.

* Issue #14222: Use the new time.steady() function instead of
  time.time() for timeout in queue and threading modules to not be
  affected of system time update.

* Issue #13248: Remove lib2to3.pytree.Base.get_prefix/set_prefix.

* Issue #14234: CVE-2012-0876: Randomize hashes of xml attributes in
  the hash table internal to the pyexpat module's copy of the expat
  library to avoid a denial of service due to hash collisions.  Patch
  by David Malcolm with some modifications by the expat project.

* Issue #12818: format address no longer needlessly escapes ()s in
  names when the name ends up being quoted.

* Issue #14062: BytesGenerator now correctly folds Header objects,
  including using linesep when folding.

* Issue #13839: When invoked on the command-line, the pstats module
  now accepts several filenames of profile stat files and merges them
  all. Patch by Matt Joiner.

* Issue #14291: Email now defaults to utf-8 for non-ASCII unicode
  headers instead of raising an error.  This fixes a regression
  relative to 2.7.

* Issue #989712: Support using Tk without a mainloop.

* Issue #3835: Refuse to use unthreaded Tcl in threaded Python.

* Issue #2843: Add new Tk API to Tkinter.

* Issue #14184: Increase the default stack size for secondary
  threads on Mac OS X to avoid interpreter crashes when using threads
  on 10.7.

* Issue #14180: datetime.date.fromtimestamp(),
  datetime.datetime.fromtimestamp() and
  datetime.datetime.utcfromtimestamp() now raise an OSError instead of
  ValueError if localtime() or gmtime() failed.

* Issue #14180: time.ctime(), gmtime(), time.localtime(),
  datetime.date.fromtimestamp(), datetime.datetime.fromtimestamp() and
  datetime.datetime.utcfromtimestamp() now raises an OverflowError,
  instead of a ValueError, if the timestamp does not fit in time_t.

* Issue #14180: datetime.datetime.fromtimestamp() and
  datetime.datetime.utcfromtimestamp() now round microseconds towards
  zero instead of rounding to nearest with ties going away from zero.

* Issue #10543: Fix unittest test discovery with Jython bytecode
  files.

* Issue #1178863: Separate initialisation from setting when
  initializing Tkinter.Variables; harmonize exceptions to ValueError;
  only delete variables that have not been deleted; assert that
  variable names are strings.

* Issue #14104: Implement time.monotonic() on Mac OS X, patch
  written by Nicholas Riley.

* Issue #13394: the aifc module now uses warnings.warn() to signal
  warnings.

* Issue #14252: Fix subprocess.Popen.terminate() to not raise an
  error under Windows when the child process has already exited.

* Issue #14223: curses.addch() is no more limited to the range 0-255
  when the Python curses is not linked to libncursesw. It was a
  regression introduced in Python 3.3a1.

* Issue #14168: Check for presence of Element._attrs in minidom
  before accessing it.

* Issue #12328: Fix multiprocessing's use of overlapped I/O on
  Windows. Also, add a multiprocessing.connection.wait(rlist,
  timeout=None) function for polling multiple objects at once.  Patch
  by sbt.

* Issue #14007: Accept incomplete TreeBuilder objects (missing
  start, end, data or close method) for the Python implementation as
  well. Drop the no-op TreeBuilder().xml() method from the C
  implementation.

* Issue #14210: pdb now has tab-completion not only for command
  names, but also for their arguments, wherever possible.

* Issue #14310: Sockets can now be with other processes on Windows
  using the api socket.socket.share() and socket.fromshare().

* Issue #10576: The gc module now has a 'callbacks' member that will
  get called when garbage collection takes place.


Build
-----

* Issue #14557: Fix extensions build on HP-UX. Patch by Adi Roiban.

* Issue #14387: Do not include accu.h from Python.h.

* Issue #14359: Only use O_CLOEXEC in _posixmodule.c if it is
  defined. Based on patch from Hervé Coatanhay.

* Issue #14321: Do not run pgen during the build if files are up to
  date.


Documentation
-------------

* Issue #14034: added the argparse tutorial.

* Issue #14324: Fix configure tests for cross builds.

* Issue #14327: Call AC_CANONICAL_HOST in configure.ac and check in
  config.{guess,sub}. Don't use uname calls for cross builds.


Extension Modules
-----------------

* Issue #9041: An issue in ctypes.c_longdouble, ctypes.c_double, and
  ctypes.c_float that caused an incorrect exception to be returned in
  the case of overflow has been fixed.

* Issue #14212: The re module didn't retain a reference to buffers
  it was scanning, resulting in segfaults.

* Issue #14259: The finditer() method of re objects did not take any
  keyword arguments, contrary to the documentation.

* Issue #10142: Support for SEEK_HOLE/SEEK_DATA (for example, under
  ZFS).


Tests
-----

* Issue #14442: Add missing errno import in test_smtplib.

* Issue #8315: (partial fix) python -m unittest test.test_email now
  works.


Python 3.3.0 Alpha 1
====================

*Release date: 05-Mar-2012*


Core and Builtins
-----------------

* Issue #14172: Fix reference leak when marshalling a buffer-like
  object (other than a bytes object).

* Issue #13521: dict.setdefault() now does only one lookup for the
  given key, making it "atomic" for many purposes.  Patch by Filip
  Gruszczyński.

* PEP 409, Issue #6210: "raise X from None" is now supported as a
  means of suppressing the display of the chained exception context.
  The chained context still remains available as the __context__
  attribute.

* Issue #10181: New memoryview implementation fixes multiple
  ownership and lifetime issues of dynamically allocated Py_buffer
  members (#9990) as well as crashes (#8305, #7433). Many new features
  have been added (See whatsnew/3.3), and the documentation has been
  updated extensively. The ndarray test object from _testbuffer.c
  implements all aspects of PEP-3118, so further development towards
  the complete implementation of the PEP can proceed in a test-driven
  manner.

  Thanks to Nick Coghlan, Antoine Pitrou and Pauli Virtanen for review
  and many ideas.

* Issue #12834: Fix incorrect results of memoryview.tobytes() for
  non- contiguous arrays.

* Issue #5231: Introduce memoryview.cast() method that allows
  changing format and shape without making a copy of the underlying
  memory.

* Issue #14084: Fix a file descriptor leak when importing a module
  with a bad encoding.

* Upgrade Unicode data to Unicode 6.1.

* Issue #14040: Remove rarely used file name suffixes for C
  extensions (under POSIX mainly).

* Issue #14051: Allow arbitrary attributes to be set of classmethod
  and staticmethod.

* Issue #13703: oCERT-2011-003: Randomize hashes of str and bytes to
  protect against denial of service attacks due to hash collisions
  within the dict and set types.  Patch by David Malcolm, based on
  work by Victor Stinner.

* Issue #13020: Fix a reference leak when allocating a
  structsequence object fails.  Patch by Suman Saha.

* Issue #13908: Ready types returned from PyType_FromSpec.

* Issue #11235: Fix OverflowError when trying to import a source
  file whose modification time doesn't fit in a 32-bit timestamp.

* Issue #12705: A SyntaxError exception is now raised when
  attempting to compile multiple statements as a single interactive
  statement.

* Fix the builtin module initialization code to store the init
  function for future reinitialization.

* Issue #8052: The posix subprocess module would take a long time
  closing all possible file descriptors in the child process rather
  than just open file descriptors.  It now closes only the open fds if
  possible for the default close_fds=True behavior.

* Issue #13629: Renumber the tokens in token.h so that they match
  the indexes into _PyParser_TokenNames.

* Issue #13752: Add a casefold() method to str.

* Issue #13761: Add a "flush" keyword argument to the print()
  function, used to ensure flushing the output stream.

* Issue #13645: pyc files now contain the size of the corresponding
  source code, to avoid timestamp collisions (especially on
  filesystems with a low timestamp resolution) when checking for
  freshness of the bytecode.

* PEP 380, Issue #11682: Add "yield from <x>" to support easy
  delegation to subgenerators (initial patch by Greg Ewing,
  integration into 3.3 by Renaud Blanch, Ryan Kelly, Zbigniew
  Jędrzejewski-Szmek and Nick Coghlan)

* Issue #13748: Raw bytes literals can now be written with the "rb"
  prefix as well as "br".

* Issue #12736: Use full unicode case mappings for upper, lower, and
  title case.

* Issue #12760: Add a create mode to open(). Patch by David
  Townshend.

* Issue #13738: Simplify implementation of bytes.lower() and
  bytes.upper().

* Issue #13577: Built-in methods and functions now have a
  __qualname__. Patch by sbt.

* Issue #6695: Full garbage collection runs now clear the freelist
  of set objects.  Initial patch by Matthias Troffaes.

* Fix OSError.__init__ and OSError.__new__ so that each of them can
  be overriden and take additional arguments (followup to issue
  #12555).

* Fix the fix for issue #12149: it was incorrect, although it had
  the side effect of appearing to resolve the issue.  Thanks to Mark
  Shannon for noticing.

* Issue #13505: Pickle bytes objects in a way that is compatible
  with Python 2 when using protocols <= 2.

* Issue #11147: Fix an unused argument in _Py_ANNOTATE_MEMORY_ORDER.
  (Fix given by Campbell Barton).

* Issue #13503: Use a more efficient reduction format for bytearrays
  with pickle protocol >= 3.  The old reduction format is kept with
  older protocols in order to allow unpickling under Python 2.  Patch
  by Irmen de Jong.

* Issue #7111: Python can now be run without a stdin, stdout or
  stderr stream.  It was already the case with Python 2.  However, the
  corresponding sys module entries are now set to None (instead of an
  unusable file object).

* Issue #11849: Ensure that free()d memory arenas are really
  released on POSIX systems supporting anonymous memory mappings.
  Patch by Charles-François Natali.

* PEP 3155 / issue #13448: Qualified name for classes and functions.

* Issue #13436: Fix a bogus error message when an AST object was
  passed an invalid integer value.

* Issue #13411: memoryview objects are now hashable when the
  underlying object is hashable.

* Issue #13338: Handle all enumerations in _Py_ANNOTATE_MEMORY_ORDER
  to allow compiling extension modules with -Wswitch-enum on gcc.
  Initial patch by Floris Bruynooghe.

* Issue #10227: Add an allocation cache for a single slice object.
  Patch by Stefan Behnel.

* Issue #13393: BufferedReader.read1() now asks the full requested
  size to the raw stream instead of limiting itself to the buffer
  size.

* Issue #13392: Writing a pyc file should now be atomic under
  Windows as well.

* Issue #13333: The UTF-7 decoder now accepts lone surrogates (the
  encoder already accepts them).

* Issue #13389: Full garbage collection passes now clear the
  freelists for list and dict objects.  They already cleared other
  freelists in the interpreter.

* Issue #13327: Remove the need for an explicit None as the second
  argument to os.utime, os.lutimes, os.futimes, os.futimens,
  os.futimesat, in order to update to the current time. Also added
  keyword argument handling to os.utimensat in order to remove the
  need for explicit None.

* Issue #13350: Simplify some C code by replacing most usages of
  PyUnicode_Format by PyUnicode_FromFormat.

* Issue #13342: input() used to ignore sys.stdin's and sys.stdout's
  unicode error handler in interactive mode (when calling into
  PyOS_Readline()).

* Issue #9896: Add start, stop, and step attributes to range
  objects.

* Issue #13343: Fix a SystemError when a lambda expression uses a
  global variable in the default value of a keyword-only argument:
  "lambda *, arg=GLOBAL_NAME: None"

* Issue #12797: Added custom opener parameter to builtin open() and
  FileIO.open().

* Issue #10519: Avoid unnecessary recursive function calls in
  setobject.c.

* Issue #10363: Deallocate global locks in Py_Finalize().

* Issue #13018: Fix reference leaks in error paths in dictobject.c.
  Patch by Suman Saha.

* Issue #13201: Define '==' and '!=' to compare range objects based
  on the sequence of values they define (instead of comparing based on
  object identity).

* Issue #1294232: In a few cases involving metaclass inheritance,
  the interpreter would sometimes invoke the wrong metaclass when
  building a new class object. These cases now behave correctly. Patch
  by Daniel Urban.

* Issue #12753: Add support for Unicode name aliases and named
  sequences. Both "unicodedata.lookup()" and 'N{...}' now resolve
  aliases, and "unicodedata.lookup()" resolves named sequences too.

* Issue #12170: The count(), find(), rfind(), index() and rindex()
  methods of bytes and bytearray objects now accept an integer between
  0 and 255 as their first argument.  Patch by Petri Lehtinen.

* Issue #12604: VTRACE macro expanded to no-op in _sre.c to avoid
  compiler warnings. Patch by Josh Triplett and Petri Lehtinen.

* Issue #12281: Rewrite the MBCS codec to handle correctly replace
  and ignore error handlers on all Windows versions. The MBCS codec is
  now supporting all error handlers, instead of only replace to encode
  and ignore to decode.

* Issue #13188: When called without an explicit traceback argument,
  generator.throw() now gets the traceback from the passed exception's
  "__traceback__" attribute.  Patch by Petri Lehtinen.

* Issue #13146: Writing a pyc file is now atomic under POSIX.

* Issue #7833: Extension modules built using distutils on Windows
  will no longer include a "manifest" to prevent them failing at
  import time in some embedded situations.

* PEP 3151 / issue #12555: reworking the OS and IO exception
  hierarchy.

* Add internal API for static strings (_Py_identifier et al.).

* Issue #13063: the Windows error ERROR_NO_DATA (numbered 232 and
  described as "The pipe is being closed") is now mapped to POSIX
  errno EPIPE (previously EINVAL).

* Issue #12911: Fix memory consumption when calculating the repr()
  of huge tuples or lists.

* PEP 393: flexible string representation. Thanks to Torsten Becker
  for the initial implementation, and Victor Stinner for various bug
  fixes.

* Issue #14081: The 'sep' and 'maxsplit' parameter to str.split,
  bytes.split, and bytearray.split may now be passed as keyword
  arguments.

* Issue #13012: The 'keepends' parameter to str.splitlines may now
  be passed as a keyword argument:
  "my_string.splitlines(keepends=True)". The same change also applies
  to bytes.splitlines and bytearray.splitlines.

* Issue #7732: Don't open a directory as a file anymore while
  importing a module. Ignore the direcotry if its name matchs the
  module name (e.g. "__init__.py") and raise a ImportError instead.

* Issue #13021: Missing decref on an error path.  Thanks to Suman
  Saha for finding the bug and providing a patch.

* Issue #12973: Fix overflow checks that relied on undefined
  behaviour in list_repeat (listobject.c) and islice_next
  (itertoolsmodule.c). These bugs caused test failures with recent
  versions of Clang.

* Issue #12904: os.utime, os.futimes, os.lutimes, and os.futimesat
  now write atime and mtime with nanosecond precision on modern POSIX
  platforms.

* Issue #12802: the Windows error ERROR_DIRECTORY (numbered 267) is
  now mapped to POSIX errno ENOTDIR (previously EINVAL).

* Issue #9200: The str.is* methods now work with strings that
  contain non-BMP characters even in narrow Unicode builds.

* Issue #12791: Break reference cycles early when a generator exits
  with an exception.

* Issue #12773: Make __doc__ mutable on user-defined classes.

* Issue #12766: Raise a ValueError when creating a class with a
  class variable that conflicts with a name in __slots__.

* Issue #12266: Fix str.capitalize() to correctly
  uppercase/lowercase titlecased and cased non-letter characters.

* Issue #12732: In narrow unicode builds, allow Unicode identifiers
  which fall outside the BMP.

* Issue #12575: Validate user-generated AST before it is compiled.

* Make type(None), type(Ellipsis), and type(NotImplemented)
  callable. They return the respective singleton instances.

* Forbid summing bytes with sum().

* Verify the types of AST strings and identifiers provided by the
  user before compiling them.

* Issue #12647: The None object now has a __bool__() method that
  returns False. Formerly, bool(None) returned False only because of
  special case logic in PyObject_IsTrue().

* Issue #12579: str.format_map() now raises a ValueError if used on
  a format string that contains positional fields. Initial patch by
  Julian Berman.

* Issue #10271: Allow warnings.showwarning() be any callable.

* Issue #11627: Fix segfault when __new__ on a exception returns a
  non-exception class.

* Issue #12149: Update the method cache after a type's dictionary
  gets cleared by the garbage collector.  This fixes a segfault when
  an instance and its type get caught in a reference cycle, and the
  instance's deallocator calls one of the methods on the type (e.g.
  when subclassing IOBase).  Diagnosis and patch by Davide Rizzo.

* Issue #9611, Issue #9015: FileIO.read() clamps the length to
  INT_MAX on Windows.

* Issue #9642: Uniformize the tests on the availability of the mbcs
  codec, add a new HAVE_MBCS define.

* Issue #9642: Fix filesystem encoding initialization: use the ANSI
  code page on Windows if the mbcs codec is not available, and fail
  with a fatal error if we cannot get the locale encoding (if
  nl_langinfo(CODESET) is not available) instead of using UTF-8.

* When a generator yields, do not retain the caller's exception
  state on the generator.

* Issue #12475: Prevent generators from leaking their exception
  state into the caller's frame as they return for the last time.

* Issue #12291: You can now load multiple marshalled objects from a
  stream, with other data interleaved between marshalled objects.

* Issue #12356: When required positional or keyword-only arguments
  are not given, produce a informative error message which includes
  the name(s) of the missing arguments.

* Issue #12370: Fix super with no arguments when __class__ is
  overriden in the class body.

* Issue #12084: os.stat on Windows now works properly with relative
  symbolic links when called from any directory.

* Loosen type restrictions on the __dir__ method. __dir__ can now
  return any sequence, which will be converted to a list and sorted by
  dir().

* Issue #12265: Make error messages produced by passing an invalid
  set of arguments to a function more informative.

* Issue #12225: Still allow Python to build if Python is not in its
  hg repo or mercurial is not installed.

* Issue #1195: my_fgets() now always clears errors before calling
  fgets(). Fix the following case: sys.stdin.read() stopped with
  CTRL+d (end of file), raw_input() interrupted by CTRL+c.

* Issue #12216: Allow unexpected EOF errors to happen on any line of
  the file.

* Issue #12199: The TryExcept and TryFinally and AST nodes have been
  unified into a Try node.

* Issue #9670: Increase the default stack size for secondary threads
  on Mac OS X and FreeBSD to reduce the chances of a crash instead of
  a "maximum recursion depth" RuntimeError exception. (patch by Ronald
  Oussoren)

* Issue #12106: The use of the multiple-with shorthand syntax is now
  reflected in the AST.

* Issue #12190: Try to use the same filename object when compiling
  unmarshalling a code objects in the same file.

* Issue #12166: Move implementations of dir() specialized for
  various types into the __dir__() methods of those types.

* Issue #5715: In socketserver, close the server socket in the child
  process.

* Correct lookup of __dir__ on objects. Among other things, this
  causes errors besides AttributeError found on lookup to be
  propagated.

* Issue #12060: Use sig_atomic_t type and volatile keyword in the
  signal module. Patch written by Charles-François Natali.

* Issue #1746656: Added the if_nameindex, if_indextoname,
  if_nametoindex methods to the socket module.

* Issue #12044: Fixed subprocess.Popen when used as a context
  manager to wait for the process to end when exiting the context to
  avoid unintentionally leaving zombie processes around.

* Issue #1195: Fix input() if it is interrupted by CTRL+d and then
  CTRL+c, clear the end-of-file indicator after CTRL+d.

* Issue #1856: Avoid crashes and lockups when daemon threads run
  while the interpreter is shutting down; instead, these threads are
  now killed when they try to take the GIL.

* Issue #9756: When calling a method descriptor or a slot wrapper
  descriptor, the check of the object type doesn't read the __class__
  attribute anymore. Fix a crash if a class override its __class__
  attribute (e.g. a proxy of the str type). Patch written by Andreas
  Stührk.

* Issue #10517: After fork(), reinitialize the TLS used by the
  PyGILState_* APIs, to avoid a crash with the pthread implementation
  in RHEL 5.  Patch by Charles-François Natali.

* Issue #10914: Initialize correctly the filesystem codec when
  creating a new subinterpreter to fix a bootstrap issue with codecs
  implemented in Python, as the ISO-8859-15 codec.

* Issue #11918: OS/2 and VMS are no more supported because of the
  lack of maintainer.

* Issue #6780: fix starts/endswith error message to mention that
  tuples are accepted too.

* Issue #5057: fix a bug in the peepholer that led to non-portable
  pyc files between narrow and wide builds while optimizing
  BINARY_SUBSCR on non-BMP chars (e.g. "U00012345"[0]).

* Issue #11845: Fix typo in rangeobject.c that caused a crash in
  compute_slice_indices.  Patch by Daniel Urban.

* Issue #5673: Added a "timeout" keyword argument to
  subprocess.Popen.wait, subprocess.Popen.communicated,
  subprocess.call, subprocess.check_call, and subprocess.check_output.
  If the blocking operation takes more than "timeout" seconds, the
  "subprocess.TimeoutExpired" exception is raised.

* Issue #11650: PyOS_StdioReadline() retries fgets() if it was
  interrupted (EINTR), for example if the program is stopped with
  CTRL+z on Mac OS X. Patch written by Charles-Francois Natali.

* Issue #9319: Include the filename in "Non-UTF8 code ..." syntax
  error.

* Issue #10785: Store the filename as Unicode in the Python parser.

* Issue #11619: _PyImport_LoadDynamicModule() doesn't encode the
  path to bytes on Windows.

* Issue #10998: Remove mentions of -Q, sys.flags.division_warning
  and Py_DivisionWarningFlag left over from Python 2.

* Issue #11244: Remove an unnecessary peepholer check that was
  preventing negative zeros from being constant-folded properly.

* Issue #11395: io.FileIO().write() clamps the data length to 32,767
  bytes on Windows if the file is a TTY to workaround a Windows bug.
  The Windows console returns an error (12: not enough space error) on
  writing into stdout if stdout mode is binary and the length is
  greater than 66,000 bytes (or less, depending on heap usage).

* Issue #11320: fix bogus memory management in Modules/getpath.c,
  leading to a possible crash when calling Py_SetPath().

* Issue #11432: A bug was introduced in subprocess.Popen on posix
  systems with 3.2.0 where the stdout or stderr file descriptor being
  the same as the stdin file descriptor would raise an exception.
  webbrowser.open would fail. fixed.

* Issue #9856: Change object.__format__ with a non-empty format
  string to be a DeprecationWarning. In 3.2 it was a
  PendingDeprecationWarning. In 3.4 it will be a TypeError.

* Issue #11244: The peephole optimizer is now able to constant-fold
  arbitrarily complex expressions.  This also fixes a 3.2 regression
  where operations involving negative numbers were not constant-
  folded.

* Issue #11450: Don't truncate hg version info in Py_GetBuildInfo()
  when there are many tags (e.g. when using mq).  Patch by Nadeem
  Vawda.

* Issue #11335: Fixed a memory leak in list.sort when the key
  function throws an exception.

* Issue #8923: When a string is encoded to UTF-8 in strict mode, the
  result is cached into the object. Examples: str.encode(),
  str.encode('utf-8'), PyUnicode_AsUTF8String() and
  PyUnicode_AsEncodedString(unicode, "utf-8", NULL).

* Issue #10829: Refactor PyUnicode_FromFormat(), use the same
  function to parse the format string in the 3 steps, fix crashs on
  invalid format strings.

* Issue #13007: whichdb should recognize gdbm 1.9 magic numbers.

* Issue #11286: Raise a ValueError from calling
  PyMemoryView_FromBuffer with a buffer struct having a NULL data
  pointer.

* Issue #11272: On Windows, input() strips 'r' (and not only 'n'),
  and sys.stdin uses universal newline (replace 'rn' by 'n').

* Issue #11828: startswith and endswith now accept None as slice
  index. Patch by Torsten Becker.

* Issue #11168: Remove filename debug variable from
  PyEval_EvalFrameEx(). It encoded the Unicode filename to UTF-8, but
  the encoding fails on undecodable filename (on surrogate characters)
  which raises an unexpected UnicodeEncodeError on recursion limit.

* Issue #11187: Remove bootstrap code (use ASCII) of
  PyUnicode_AsEncodedString(), it was replaced by a better fallback
  (use the locale encoding) in PyUnicode_EncodeFSDefault().

* Check for NULL result in PyType_FromSpec.

* Issue #10516: New copy() and clear() methods for lists and
  bytearrays.

* Issue #11386: bytearray.pop() now throws IndexError when the
  bytearray is empty, instead of OverflowError.

* Issue #12380: The rjust, ljust and center methods of bytes and
  bytearray now accept a bytearray argument.


Library
-------

* Issue #14195: An issue that caused weakref.WeakSet instances to
  incorrectly return True for a WeakSet instance 'a' in both 'a < a'
  and 'a > a' has been fixed.

* Issue #14166: Pickler objects now have an optional
  "dispatch_table" attribute which allows to set custom per-pickler
  reduction functions. Patch by sbt.

* Issue #14177: marshal.loads() now raises TypeError when given an
  unicode string.  Patch by Guilherme Gonçalves.

* Issue #13550: Remove the debug machinery from the threading
  module: remove verbose arguments from all threading classes and
  functions.

* Issue #14159: Fix the len() of weak containers (WeakSet,
  WeakKeyDictionary, WeakValueDictionary) to return a better
  approximation when some objects are dead or dying.  Moreover, the
  implementation is now O(1) rather than O(n).

* Issue #11841: Fix comparison bug with 'rc' versions in
  packaging.version. Patch by Filip Gruszczyński.

* Issue #6884: Fix long-standing bugs with MANIFEST.in parsing in
  distutils on Windows.  Also fixed in packaging.

* Issue #8033: sqlite3: Fix 64-bit integer handling in user
  functions on 32-bit architectures. Initial patch by Philippe
  Devalkeneer.

* HTMLParser is now able to handle slashes in the start tag.

* Issue #13641: Decoding functions in the base64 module now accept
  ASCII-only unicode strings.  Patch by Catalin Iacob.

* Issue #14043: Speed up importlib's _FileFinder by at least 8x, and
  add a new importlib.invalidate_caches() function.

* Issue #14001: CVE-2012-0845: xmlrpc: Fix an endless loop in
  SimpleXMLRPCServer upon malformed POST request.

* Issue #13961: Move importlib over to using os.replace() for atomic
  renaming.

* Do away with ambiguous level values (as suggested by PEP 328) in
  importlib.__import__() by raising ValueError when level < 0.

* Issue #2489: pty.spawn could consume 100% cpu when it encountered
  an EOF.

* Issue #13014: Fix a possible reference leak in
  SSLSocket.getpeercert().

* Issue #13777: Add PF_SYSTEM sockets on OS X. Patch by Michael
  Goderbauer.

* Issue #13015: Fix a possible reference leak in
  defaultdict.__repr__. Patch by Suman Saha.

* Issue #1326113: distutils' and packaging's build_ext commands
  option now correctly parses multiple values (separated by whitespace
  or commas) given to their --libraries option.

* Issue #10287: nntplib now queries the server's CAPABILITIES first
  before sending MODE READER, and only sends it if not already in
  READER mode. Patch by Hynek Schlawack.

* Issue #13993: HTMLParser is now able to handle broken end tags
  when strict=False.

* Issue #13930: lib2to3 now supports writing converted output files
  to another directory tree as well as copying unchanged files and
  altering the file suffix.

* Issue #9750: Fix sqlite3.Connection.iterdump on tables and fields
  with a name that is a keyword or contains quotes. Patch by Marko
  Kohtala.

* Issue #10287: nntplib now queries the server's CAPABILITIES again
  after authenticating (since the result may change, according to RFC
  4643). Patch by Hynek Schlawack.

* Issue #13590: On OS X 10.7 and 10.6 with Xcode 4.2, building
  Distutils-based packages with C extension modules may fail because
  Apple has removed gcc-4.2, the version used to build python.org
  64-bit/32-bit Pythons.  If the user does not explicitly override the
  default C compiler by setting the CC environment variable, Distutils
  will now attempt to compile extension modules with clang if gcc-4.2
  is required but not found. Also as a convenience, if the user does
  explicitly set CC, substitute its value as the default compiler in
  the Distutils LDSHARED configuration variable for OS X. (Note, the
  python.org 32-bit-only Pythons use gcc-4.0 and the 10.4u SDK,
  neither of which are available in Xcode 4.  This change does not
  attempt to override settings to support their use with Xcode 4.)

* Issue #13960: HTMLParser is now able to handle broken comments
  when strict=False.

* When '' is a path (e.g. in sys.path), make sure __file__ uses the
  current working directory instead of '' in importlib.

* Issue #13609: Add two functions to query the terminal size:
  os.get_terminal_size (low level) and shutil.get_terminal_size (high
  level). Patch by Zbigniew Jędrzejewski-Szmek.

* Issue #13845: On Windows, time.time() now uses
  GetSystemTimeAsFileTime() instead of ftime() to have a resolution of
  100 ns instead of 1 ms (the clock accuracy is between 0.5 ms and 15
  ms).

* Issue #13846: Add time.monotonic(), monotonic clock.

* Issue #8184: multiprocessing: On Windows, don't set SO_REUSEADDR
  on Connection sockets, and set FILE_FLAG_FIRST_PIPE_INSTANCE on
  named pipes, to make sure two listeners can't bind to the same
  socket/pipe (or any existing socket/pipe).

* Issue #10811: Fix recursive usage of cursors. Instead of crashing,
  raise a ProgrammingError now.

* Issue #13734: Add os.fwalk(), a directory walking function
  yielding file descriptors.

* Issue #2945: Make the distutils upload command aware of bdist_rpm
  products.

* Issue #13712: pysetup create should not convert package_data to
  extra_files.

* Issue #11805: package_data in setup.cfg should allow more than one
  value.

* Issue #13676: Handle strings with embedded zeros correctly in
  sqlite3.

* Issue #8828: Add new function os.replace(), for cross-platform
  renaming with overwriting.

* Issue #13848: open() and the FileIO constructor now check for NUL
  characters in the file name.  Patch by Hynek Schlawack.

* Issue #13806: The size check in audioop decompression functions
  was too strict and could reject valid compressed data.  Patch by
  Oleg Plakhotnyuk.

* Issue #13812: When a multiprocessing Process child raises an
  exception, flush stderr after printing the exception traceback.

* Issue #13885: CVE-2011-3389: the _ssl module would always disable
  the CBC IV attack countermeasure.

* Issue #13847: time.localtime() and time.gmtime() now raise an
  OSError instead of ValueError on failure. time.ctime() and
  time.asctime() now raises an OSError if localtime() failed.
  time.clock() now raises a RuntimeError if the processor time used is
  not available or its value cannot be represented

* Issue #13772: In os.symlink() under Windows, do not try to guess
  the link target's type (file or directory).  The detection was buggy
  and made the call non-atomic (therefore prone to race conditions).

* Issue #6631: Disallow relative file paths in urllib urlopen
  methods.

* Issue #13722: Avoid silencing ImportErrors when initializing the
  codecs registry.

* Issue #13781: Fix GzipFile bug that caused an exception to be
  raised when opening for writing using a fileobj returned by
  os.fdopen().

* Issue #13803: Under Solaris, distutils doesn't include bitness in
  the directory name.

* Issue #10278: Add time.wallclock() function, monotonic clock.

* Issue #13809: Fix regression where bz2 module wouldn't work when
  threads are disabled. Original patch by Amaury Forgeot d'Arc.

* Issue #13589: Fix some serialization primitives in the aifc
  module. Patch by Oleg Plakhotnyuk.

* Issue #13642: Unquote before b64encoding user:password during
  Basic Authentication. Patch contributed by Joonas Kuorilehto.

* Issue #12364: Fix a hang in
  concurrent.futures.ProcessPoolExecutor. The hang would occur when
  retrieving the result of a scheduled future after the executor had
  been shut down.

* Issue #13502: threading: Fix a race condition in Event.wait() that
  made it return False when the event was set and cleared right after.

* Issue #9993: When the source and destination are on different
  filesystems, and the source is a symlink, shutil.move() now
  recreates a symlink on the destination instead of copying the file
  contents.  Patch by Jonathan Niehof and Hynek Schlawack.

* Issue #12926: Fix a bug in tarfile's link extraction.

* Issue #13696: Fix the 302 Relative URL Redirection problem.

* Issue #13636: Weak ciphers are now disabled by default in the ssl
  module (except when SSLv2 is explicitly asked for).

* Issue #12715: Add an optional symlinks argument to shutil
  functions (copyfile, copymode, copystat, copy, copy2).  When that
  parameter is true, symlinks aren't dereferenced and the operation
  instead acts on the symlink itself (or creates one, if relevant).
  Patch by Hynek Schlawack.

* Add a flags parameter to select.epoll.

* Issue #13626: Add support for SSL Diffie-Hellman key exchange,
  through the SSLContext.load_dh_params() method and the
  ssl.OP_SINGLE_DH_USE option.

* Issue #11006: Don't issue low level warning in subprocess when
  pipe2() fails.

* Issue #13620: Support for Chrome browser in webbrowser.  Patch
  contributed by Arnaud Calmettes.

* Issue #11829: Fix code execution holes in inspect.getattr_static
  for metaclasses with metaclasses. Patch by Andreas Stührk.

* Issue #12708: Add starmap() and starmap_async() methods (similar
  to itertools.starmap()) to multiprocessing.Pool.  Patch by Hynek
  Schlawack.

* Issue #1785: Fix inspect and pydoc with misbehaving descriptors.

* Issue #13637: "a2b" functions in the binascii module now accept
  ASCII-only unicode strings.

* Issue #13634: Add support for querying and disabling SSL
  compression.

* Issue #13627: Add support for SSL Elliptic Curve-based Diffie-
  Hellman key exchange, through the SSLContext.set_ecdh_curve() method
  and the ssl.OP_SINGLE_ECDH_USE option.

* Issue #13635: Add ssl.OP_CIPHER_SERVER_PREFERENCE, so that SSL
  servers choose the cipher based on their own preferences, rather
  than on the client's.

* Issue #11813: Fix inspect.getattr_static for modules. Patch by
  Andreas Stührk.

* Issue #7502: Fix equality comparison for DocTestCase instances.
  Patch by Cédric Krier.

* Issue #11870: threading: Properly reinitialize threads internal
  locks and condition variables to avoid deadlocks in child processes.

* Issue #8035: urllib: Fix a bug where the client could remain stuck
  after a redirection or an error.

* Issue #13560: os.strerror() now uses the current locale encoding
  instead of UTF-8.

* Issue #8373: The filesystem path of AF_UNIX sockets now uses the
  filesystem encoding and the surrogateescape error handler, rather
  than UTF-8.  Patch by David Watson.

* Issue #10350: Read and save errno before calling a function which
  might overwrite it.  Original patch by Hallvard B Furuseth.

* Issue #11610: Introduce a more general way to declare abstract
  properties.

* Issue #13591: A bug in importlib has been fixed that caused
  import_module to load a module twice.

* Issue #13449 sched.scheduler.run() method has a new "blocking"
  parameter which when set to False makes run() execute the scheduled
  events due to expire soonest (if any) and then return.  Patch by
  Giampaolo Rodolà.

* Issue #8684 sched.scheduler class can be safely used in multi-
  threaded environments.  Patch by Josiah Carlson and Giampaolo
  Rodolà.

* Alias resource.error to OSError ala PEP 3151.

* Issue #5689: Add support for lzma compression to the tarfile
  module.

* Issue #13248: Turn 3.2's PendingDeprecationWarning into 3.3's
  DeprecationWarning.  It covers 'cgi.escape',
  'importlib.abc.PyLoader', 'importlib.abc.PyPycLoader',
  'nntplib.NNTP.xgtitle', 'nntplib.NNTP.xpath', and private attributes
  of 'smtpd.SMTPChannel'.

* Issue #5905, Issue #13560: time.strftime() is now using the
  current locale encoding, instead of UTF-8, if the wcsftime()
  function is not available.

* Issue #13464: Add a readinto() method to http.client.HTTPResponse.
  Patch by Jon Kuhn.

* tarfile.py: Correctly detect bzip2 compressed streams with
  blocksizes other than 900k.

* Issue #13439: Fix many errors in turtle docstrings.

* Issue #6715: Add a module 'lzma' for compression using the LZMA
  algorithm. Thanks to Per Øyvind Karlsen for the initial
  implementation.

* Issue #13487: Make inspect.getmodule robust against changes done
  to sys.modules while it is iterating over it.

* Issue #12618: Fix a bug that prevented py_compile from creating
  byte compiled files in the current directory.  Initial patch by
  Sjoerd de Vries.

* Issue #13444: When stdout has been closed explicitly, we should
  not attempt to flush it at shutdown and print an error.

* Issue #12567: The curses module uses Unicode functions for Unicode
  arguments when it is linked to the ncurses library. It encodes also
  Unicode strings to the locale encoding instead of UTF-8.

* Issue #12856: Ensure child processes do not inherit the parent's
  random seed for filename generation in the tempfile module.  Patch
  by Brian Harring.

* Issue #9957: SpooledTemporaryFile.truncate() now accepts an
  optional size parameter, as other file-like objects.  Patch by Ryan
  Kelly.

* Issue #13458: Fix a memory leak in the ssl module when decoding a
  certificate with a subjectAltName.  Patch by Robert Xiao.

* Issue #13415: os.unsetenv() doesn't ignore errors anymore.

* Issue #13245: sched.scheduler class constructor's timefunc and
  delayfunct parameters are now optional. scheduler.enter and
  scheduler.enterabs methods gained a new kwargs parameter. Patch
  contributed by Chris Clark.

* Issue #12328: Under Windows, refactor handling of Ctrl-C events
  and make _multiprocessing.win32.WaitForMultipleObjects interruptible
  when the wait_flag parameter is false.  Patch by sbt.

* Issue #13322: Fix BufferedWriter.write() to ensure that
  BlockingIOError is raised when the wrapped raw file is non-blocking
  and the write would block. Previous code assumed that the raw
  write() would raise BlockingIOError, but RawIOBase.write() is
  defined to returned None when the call would block. Patch by sbt.

* Issue #13358: HTMLParser now calls handle_data only once for each
  CDATA.

* Issue #4147: minidom's toprettyxml no longer adds whitespace
  around a text node when it is the only child of an element.  Initial
  patch by Dan Kenigsberg.

* Issue #13374: The Windows bytes API has been deprecated in the os
